/* FileItem.c generated by valac 0.48.8, the Vala compiler
 * generated from FileItem.vala, do not modify */

/*
 * FileItem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_FILE_ITEM (file_item_get_type ())
#define FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_ITEM, FileItem))
#define FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_ITEM, FileItemClass))
#define IS_FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_ITEM))
#define IS_FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_ITEM))
#define FILE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_ITEM, FileItemClass))

typedef struct _FileItem FileItem;
typedef struct _FileItemClass FileItemClass;
typedef struct _FileItemPrivate FileItemPrivate;
enum  {
	FILE_ITEM_0_PROPERTY,
	FILE_ITEM_SIZE_PROPERTY,
	FILE_ITEM_SIZE_COMPRESSED_PROPERTY,
	FILE_ITEM_NUM_PROPERTIES
};
static GParamSpec* file_item_properties[FILE_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_ARCHIVE_FILE (archive_file_get_type ())
#define ARCHIVE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARCHIVE_FILE, ArchiveFile))
#define ARCHIVE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARCHIVE_FILE, ArchiveFileClass))
#define IS_ARCHIVE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARCHIVE_FILE))
#define IS_ARCHIVE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARCHIVE_FILE))
#define ARCHIVE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARCHIVE_FILE, ArchiveFileClass))

typedef struct _ArchiveFile ArchiveFile;
typedef struct _ArchiveFileClass ArchiveFileClass;

struct _FileItem {
	GObject parent_instance;
	FileItemPrivate * priv;
	gchar* file_name;
	gchar* file_location;
	gchar* file_path;
	gchar* file_path_prefix;
	GFileType file_type;
	GDateTime* modified;
	gchar* permissions;
	gchar* owner_user;
	gchar* owner_group;
	gchar* content_type;
	gchar* file_status;
	gboolean is_selected;
	gboolean is_symlink;
	gchar* symlink_target;
	gboolean is_archive;
	gboolean is_stale;
	FileItem* parent;
	GeeHashMap* children;
	FileItem* source_archive;
	GObject* tag;
	glong file_count;
	glong dir_count;
	glong file_count_total;
	glong dir_count_total;
	GIcon* icon;
	gboolean is_dummy;
};

struct _FileItemClass {
	GObjectClass parent_class;
};

struct _FileItemPrivate {
	gint64 _size;
	gint64 _size_compressed;
};

static gint FileItem_private_offset;
static gpointer file_item_parent_class = NULL;
extern gchar** file_item_archive_extensions;
extern gint file_item_archive_extensions_length1;
gchar** file_item_archive_extensions = NULL;
gint file_item_archive_extensions_length1 = 0;
static GeeComparableIface * file_item_gee_comparable_parent_iface = NULL;

GType file_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileItem, g_object_unref)
FileItem* file_item_new (const gchar* name);
FileItem* file_item_construct (GType object_type,
                               const gchar* name);
FileItem* file_item_new_dummy (GFileType _file_type);
FileItem* file_item_construct_dummy (GType object_type,
                                     GFileType _file_type);
FileItem* file_item_new_dummy_root (void);
FileItem* file_item_construct_dummy_root (GType object_type);
FileItem* file_item_new_from_disk_path_with_basic_info (const gchar* _file_path);
FileItem* file_item_construct_from_disk_path_with_basic_info (GType object_type,
                                                              const gchar* _file_path);
gchar* tee_jee_file_system_file_basename (const gchar* file_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
void file_item_query_file_info_basic (FileItem* self);
FileItem* file_item_new_from_path_and_type (const gchar* _file_path,
                                            GFileType _file_type);
FileItem* file_item_construct_from_path_and_type (GType object_type,
                                                  const gchar* _file_path,
                                                  GFileType _file_type);
static gint file_item_real_compare_to (GeeComparable* base,
                                FileItem* b);
FileItem* file_item_add_child_from_disk (FileItem* self,
                                         const gchar* item_file_path,
                                         gint depth);
FileItem* file_item_add_child (FileItem* self,
                               const gchar* item_file_path,
                               GFileType item_file_type,
                               gint64 item_size,
                               gint64 item_size_compressed,
                               gboolean item_query_file_info);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
FileItem* file_item_add_descendant (FileItem* self,
                                    const gchar* _file_path,
                                    GFileType* _file_type,
                                    gint64 item_size,
                                    gint64 item_size_compressed);
ArchiveFile* archive_file_new (const gchar* archive_file_path);
ArchiveFile* archive_file_construct (GType object_type,
                                     const gchar* archive_file_path);
GType archive_file_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArchiveFile, g_object_unref)
void file_item_query_file_info (FileItem* self);
void file_item_query_children (FileItem* self,
                               gint depth);
void file_item_clear_children (FileItem* self);
FileItem* file_item_remove_child (FileItem* self,
                                  const gchar* child_name);
gint64 file_item_get_size (FileItem* self);
gint64 file_item_get_size_compressed (FileItem* self);
FileItem* file_item_find_descendant (FileItem* self,
                                     const gchar* path);
void file_item_set_file_path_prefix (FileItem* self,
                                     const gchar* prefix);
void file_item_print (FileItem* self,
                      gint level);
GeeArrayList* file_item_get_children_sorted (FileItem* self);
static gint __lambda7_ (FileItem* self,
                 FileItem* a,
                 FileItem* b);
static gint ___lambda7__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
GdkPixbuf* file_item_get_icon (FileItem* self,
                               gint icon_size,
                               gboolean add_transparency,
                               gboolean add_emblems);
GdkPixbuf* icon_manager_lookup_gicon (GIcon* gicon,
                                      gint icon_size);
GdkPixbuf* icon_manager_lookup (const gchar* icon_name,
                                gint icon_size,
                                gboolean symbolic,
                                gboolean use_hardcoded,
                                gint scale);
static void file_item_finalize (GObject * obj);
static GType file_item_get_type_once (void);
static void _vala_file_item_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
file_item_get_instance_private (FileItem* self)
{
	return G_STRUCT_MEMBER_P (self, FileItem_private_offset);
}

FileItem*
file_item_construct (GType object_type,
                     const gchar* name)
{
	FileItem * self = NULL;
	gchar* _tmp0_;
#line 99 "Utility/FileItem.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 99 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 100 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (name);
#line 100 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 100 "Utility/FileItem.vala"
	self->file_name = _tmp0_;
#line 99 "Utility/FileItem.vala"
	return self;
#line 232 "FileItem.c"
}

FileItem*
file_item_new (const gchar* name)
{
#line 99 "Utility/FileItem.vala"
	return file_item_construct (TYPE_FILE_ITEM, name);
#line 240 "FileItem.c"
}

FileItem*
file_item_construct_dummy (GType object_type,
                           GFileType _file_type)
{
	FileItem * self = NULL;
#line 103 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 104 "Utility/FileItem.vala"
	self->is_dummy = TRUE;
#line 105 "Utility/FileItem.vala"
	self->file_type = _file_type;
#line 103 "Utility/FileItem.vala"
	return self;
#line 256 "FileItem.c"
}

FileItem*
file_item_new_dummy (GFileType _file_type)
{
#line 103 "Utility/FileItem.vala"
	return file_item_construct_dummy (TYPE_FILE_ITEM, _file_type);
#line 264 "FileItem.c"
}

FileItem*
file_item_construct_dummy_root (GType object_type)
{
	FileItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 108 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 109 "Utility/FileItem.vala"
	_tmp0_ = g_strdup ("dummy");
#line 109 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 109 "Utility/FileItem.vala"
	self->file_name = _tmp0_;
#line 110 "Utility/FileItem.vala"
	_tmp1_ = g_strdup ("");
#line 110 "Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 110 "Utility/FileItem.vala"
	self->file_location = _tmp1_;
#line 108 "Utility/FileItem.vala"
	return self;
#line 289 "FileItem.c"
}

FileItem*
file_item_new_dummy_root (void)
{
#line 108 "Utility/FileItem.vala"
	return file_item_construct_dummy_root (TYPE_FILE_ITEM);
#line 297 "FileItem.c"
}

FileItem*
file_item_construct_from_disk_path_with_basic_info (GType object_type,
                                                    const gchar* _file_path)
{
	FileItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 113 "Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 113 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 114 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (_file_path);
#line 114 "Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 114 "Utility/FileItem.vala"
	self->file_path = _tmp0_;
#line 115 "Utility/FileItem.vala"
	_tmp1_ = tee_jee_file_system_file_basename (_file_path);
#line 115 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 115 "Utility/FileItem.vala"
	self->file_name = _tmp1_;
#line 116 "Utility/FileItem.vala"
	_tmp2_ = tee_jee_file_system_file_parent (_file_path);
#line 116 "Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 116 "Utility/FileItem.vala"
	self->file_location = _tmp2_;
#line 117 "Utility/FileItem.vala"
	file_item_query_file_info_basic (self);
#line 113 "Utility/FileItem.vala"
	return self;
#line 334 "FileItem.c"
}

FileItem*
file_item_new_from_disk_path_with_basic_info (const gchar* _file_path)
{
#line 113 "Utility/FileItem.vala"
	return file_item_construct_from_disk_path_with_basic_info (TYPE_FILE_ITEM, _file_path);
#line 342 "FileItem.c"
}

FileItem*
file_item_construct_from_path_and_type (GType object_type,
                                        const gchar* _file_path,
                                        GFileType _file_type)
{
	FileItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 120 "Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 120 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 121 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (_file_path);
#line 121 "Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 121 "Utility/FileItem.vala"
	self->file_path = _tmp0_;
#line 122 "Utility/FileItem.vala"
	_tmp1_ = tee_jee_file_system_file_basename (_file_path);
#line 122 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 122 "Utility/FileItem.vala"
	self->file_name = _tmp1_;
#line 123 "Utility/FileItem.vala"
	_tmp2_ = tee_jee_file_system_file_parent (_file_path);
#line 123 "Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 123 "Utility/FileItem.vala"
	self->file_location = _tmp2_;
#line 124 "Utility/FileItem.vala"
	self->file_type = _file_type;
#line 120 "Utility/FileItem.vala"
	return self;
#line 380 "FileItem.c"
}

FileItem*
file_item_new_from_path_and_type (const gchar* _file_path,
                                  GFileType _file_type)
{
#line 120 "Utility/FileItem.vala"
	return file_item_construct_from_path_and_type (TYPE_FILE_ITEM, _file_path, _file_type);
#line 389 "FileItem.c"
}

static gint
file_item_real_compare_to (GeeComparable* base,
                           FileItem* b)
{
	FileItem * self;
	GFileType _tmp0_;
	GFileType _tmp1_;
	gint result = 0;
#line 143 "Utility/FileItem.vala"
	self = (FileItem*) base;
#line 143 "Utility/FileItem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 144 "Utility/FileItem.vala"
	_tmp0_ = self->file_type;
#line 144 "Utility/FileItem.vala"
	_tmp1_ = b->file_type;
#line 144 "Utility/FileItem.vala"
	if (_tmp0_ != _tmp1_) {
#line 410 "FileItem.c"
		GFileType _tmp2_;
#line 145 "Utility/FileItem.vala"
		_tmp2_ = self->file_type;
#line 145 "Utility/FileItem.vala"
		if (_tmp2_ == G_FILE_TYPE_DIRECTORY) {
#line 146 "Utility/FileItem.vala"
			result = -1;
#line 146 "Utility/FileItem.vala"
			return result;
#line 420 "FileItem.c"
		} else {
#line 149 "Utility/FileItem.vala"
			result = 1;
#line 149 "Utility/FileItem.vala"
			return result;
#line 426 "FileItem.c"
		}
	} else {
		GCompareFunc _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gint _tmp10_;
#line 154 "Utility/FileItem.vala"
		_tmp3_ = ((GCompareFunc) g_strcmp0);
#line 154 "Utility/FileItem.vala"
		_tmp4_ = self->file_name;
#line 154 "Utility/FileItem.vala"
		_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 154 "Utility/FileItem.vala"
		_tmp6_ = _tmp5_;
#line 154 "Utility/FileItem.vala"
		_tmp7_ = b->file_name;
#line 154 "Utility/FileItem.vala"
		_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 154 "Utility/FileItem.vala"
		_tmp9_ = _tmp8_;
#line 154 "Utility/FileItem.vala"
		_tmp10_ = _tmp3_ (_tmp6_, _tmp9_);
#line 154 "Utility/FileItem.vala"
		_g_free0 (_tmp9_);
#line 154 "Utility/FileItem.vala"
		_g_free0 (_tmp6_);
#line 154 "Utility/FileItem.vala"
		result = _tmp10_;
#line 154 "Utility/FileItem.vala"
		return result;
#line 461 "FileItem.c"
	}
}

FileItem*
file_item_add_child_from_disk (FileItem* self,
                               const gchar* item_file_path,
                               gint depth)
{
	FileItem* item = NULL;
	GError* _inner_error0_ = NULL;
	FileItem* result = NULL;
#line 164 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "Utility/FileItem.vala"
	g_return_val_if_fail (item_file_path != NULL, NULL);
#line 165 "Utility/FileItem.vala"
	item = NULL;
#line 479 "FileItem.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 172 "Utility/FileItem.vala"
		_tmp0_ = g_file_parse_name (item_file_path);
#line 172 "Utility/FileItem.vala"
		file = _tmp0_;
#line 174 "Utility/FileItem.vala"
		_tmp1_ = file;
#line 174 "Utility/FileItem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 494 "FileItem.c"
			GFileType item_file_type = 0;
			GFile* _tmp2_;
			GFileType _tmp3_;
			FileItem* _tmp4_;
			gboolean _tmp5_ = FALSE;
			FileItem* _tmp6_;
			GFileType _tmp7_;
#line 177 "Utility/FileItem.vala"
			_tmp2_ = file;
#line 177 "Utility/FileItem.vala"
			item_file_type = g_file_query_file_type (_tmp2_, G_FILE_QUERY_INFO_NONE, NULL);
#line 180 "Utility/FileItem.vala"
			_tmp3_ = item_file_type;
#line 180 "Utility/FileItem.vala"
			_tmp4_ = file_item_add_child (self, item_file_path, _tmp3_, (gint64) 0, (gint64) 0, TRUE);
#line 180 "Utility/FileItem.vala"
			_g_object_unref0 (item);
#line 180 "Utility/FileItem.vala"
			item = _tmp4_;
#line 182 "Utility/FileItem.vala"
			_tmp6_ = item;
#line 182 "Utility/FileItem.vala"
			_tmp7_ = _tmp6_->file_type;
#line 182 "Utility/FileItem.vala"
			if (_tmp7_ == G_FILE_TYPE_DIRECTORY) {
#line 520 "FileItem.c"
				FileItem* _tmp8_;
#line 182 "Utility/FileItem.vala"
				_tmp8_ = item;
#line 182 "Utility/FileItem.vala"
				_tmp5_ = !_tmp8_->is_symlink;
#line 526 "FileItem.c"
			} else {
#line 182 "Utility/FileItem.vala"
				_tmp5_ = FALSE;
#line 530 "FileItem.c"
			}
#line 182 "Utility/FileItem.vala"
			if (_tmp5_) {
#line 183 "Utility/FileItem.vala"
				if (depth != 0) {
#line 536 "FileItem.c"
					GFileEnumerator* _tmp9_ = NULL;
					GFile* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					GFileEnumerator* _tmp13_;
					GFileEnumerator* _tmp14_;
					GFileEnumerator* _tmp15_;
#line 185 "Utility/FileItem.vala"
					_tmp10_ = file;
#line 185 "Utility/FileItem.vala"
					_tmp11_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 185 "Utility/FileItem.vala"
					_tmp12_ = _tmp11_;
#line 185 "Utility/FileItem.vala"
					_tmp13_ = g_file_enumerate_children (_tmp10_, _tmp12_, 0, NULL, &_inner_error0_);
#line 185 "Utility/FileItem.vala"
					_tmp14_ = _tmp13_;
#line 185 "Utility/FileItem.vala"
					_g_free0 (_tmp12_);
#line 185 "Utility/FileItem.vala"
					_tmp9_ = _tmp14_;
#line 185 "Utility/FileItem.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "Utility/FileItem.vala"
						_g_object_unref0 (file);
#line 185 "Utility/FileItem.vala"
						_g_object_unref0 (info);
#line 185 "Utility/FileItem.vala"
						_g_object_unref0 (enumerator);
#line 566 "FileItem.c"
						goto __catch0_g_error;
					}
#line 185 "Utility/FileItem.vala"
					_tmp15_ = _tmp9_;
#line 185 "Utility/FileItem.vala"
					_tmp9_ = NULL;
#line 185 "Utility/FileItem.vala"
					_g_object_unref0 (enumerator);
#line 185 "Utility/FileItem.vala"
					enumerator = _tmp15_;
#line 186 "Utility/FileItem.vala"
					while (TRUE) {
#line 579 "FileItem.c"
						GFileInfo* _tmp16_ = NULL;
						GFileEnumerator* _tmp17_;
						GFileInfo* _tmp18_;
						GFileInfo* _tmp19_;
						GFileInfo* _tmp20_;
						gchar* child_path = NULL;
						GFileInfo* _tmp21_;
						const gchar* _tmp22_;
						gchar* _tmp23_;
						FileItem* _tmp24_;
						const gchar* _tmp25_;
						FileItem* _tmp26_;
						FileItem* _tmp27_;
#line 186 "Utility/FileItem.vala"
						_tmp17_ = enumerator;
#line 186 "Utility/FileItem.vala"
						_tmp18_ = g_file_enumerator_next_file (_tmp17_, NULL, &_inner_error0_);
#line 186 "Utility/FileItem.vala"
						_tmp16_ = _tmp18_;
#line 186 "Utility/FileItem.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 186 "Utility/FileItem.vala"
							_g_object_unref0 (_tmp9_);
#line 186 "Utility/FileItem.vala"
							_g_object_unref0 (file);
#line 186 "Utility/FileItem.vala"
							_g_object_unref0 (info);
#line 186 "Utility/FileItem.vala"
							_g_object_unref0 (enumerator);
#line 609 "FileItem.c"
							goto __catch0_g_error;
						}
#line 186 "Utility/FileItem.vala"
						_tmp19_ = _tmp16_;
#line 186 "Utility/FileItem.vala"
						_tmp16_ = NULL;
#line 186 "Utility/FileItem.vala"
						_g_object_unref0 (info);
#line 186 "Utility/FileItem.vala"
						info = _tmp19_;
#line 186 "Utility/FileItem.vala"
						_tmp20_ = info;
#line 186 "Utility/FileItem.vala"
						if (!(_tmp20_ != NULL)) {
#line 186 "Utility/FileItem.vala"
							_g_object_unref0 (_tmp16_);
#line 186 "Utility/FileItem.vala"
							break;
#line 628 "FileItem.c"
						}
#line 187 "Utility/FileItem.vala"
						_tmp21_ = info;
#line 187 "Utility/FileItem.vala"
						_tmp22_ = g_file_info_get_name (_tmp21_);
#line 187 "Utility/FileItem.vala"
						_tmp23_ = g_strdup_printf ("%s/%s", item_file_path, _tmp22_);
#line 187 "Utility/FileItem.vala"
						child_path = _tmp23_;
#line 188 "Utility/FileItem.vala"
						_tmp24_ = item;
#line 188 "Utility/FileItem.vala"
						_tmp25_ = child_path;
#line 188 "Utility/FileItem.vala"
						_tmp26_ = file_item_add_child_from_disk (_tmp24_, _tmp25_, depth - 1);
#line 188 "Utility/FileItem.vala"
						_tmp27_ = _tmp26_;
#line 188 "Utility/FileItem.vala"
						_g_object_unref0 (_tmp27_);
#line 186 "Utility/FileItem.vala"
						_g_free0 (child_path);
#line 186 "Utility/FileItem.vala"
						_g_object_unref0 (_tmp16_);
#line 652 "FileItem.c"
					}
#line 183 "Utility/FileItem.vala"
					_g_object_unref0 (_tmp9_);
#line 656 "FileItem.c"
				}
			}
		}
#line 169 "Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 169 "Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 169 "Utility/FileItem.vala"
		_g_object_unref0 (enumerator);
#line 666 "FileItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 169 "Utility/FileItem.vala"
		e = _inner_error0_;
#line 169 "Utility/FileItem.vala"
		_inner_error0_ = NULL;
#line 195 "Utility/FileItem.vala"
		_tmp28_ = e;
#line 195 "Utility/FileItem.vala"
		_tmp29_ = _tmp28_->message;
#line 195 "Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp29_, FALSE, FALSE);
#line 169 "Utility/FileItem.vala"
		_g_error_free0 (e);
#line 686 "FileItem.c"
	}
	__finally0:
#line 169 "Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "Utility/FileItem.vala"
		_g_object_unref0 (item);
#line 169 "Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "Utility/FileItem.vala"
		g_clear_error (&_inner_error0_);
#line 169 "Utility/FileItem.vala"
		return NULL;
#line 699 "FileItem.c"
	}
#line 198 "Utility/FileItem.vala"
	result = item;
#line 198 "Utility/FileItem.vala"
	return result;
#line 705 "FileItem.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 726 "FileItem.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1481 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1481 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1482 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1483 "glib-2.0.vapi"
		start = string_length + start;
#line 753 "FileItem.c"
	}
#line 1485 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1486 "glib-2.0.vapi"
		end = string_length + end;
#line 759 "FileItem.c"
	}
#line 1488 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 765 "FileItem.c"
	} else {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 769 "FileItem.c"
	}
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1489 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 777 "FileItem.c"
	} else {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 781 "FileItem.c"
	}
#line 1489 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1490 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1491 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1491 "glib-2.0.vapi"
	result = _tmp4_;
#line 1491 "glib-2.0.vapi"
	return result;
#line 793 "FileItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 225 "Utility/FileItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 801 "FileItem.c"
}

FileItem*
file_item_add_descendant (FileItem* self,
                          const gchar* _file_path,
                          GFileType* _file_type,
                          gint64 item_size,
                          gint64 item_size_compressed)
{
	gchar* item_path = NULL;
	gchar* _tmp0_;
	GFileType _tmp1_ = 0;
	GFileType item_type = 0;
	const gchar* _tmp2_;
	const gchar* _tmp8_;
	gchar* dir_name = NULL;
	gchar* _tmp14_;
	gchar* dir_path = NULL;
	gchar* _tmp15_;
	FileItem* current_dir = NULL;
	FileItem* _tmp16_;
	gchar** arr = NULL;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint arr_length1;
	gint _arr_size_;
	gchar* item_name = NULL;
	gchar** _tmp51_;
	gint _tmp51__length1;
	gchar** _tmp52_;
	gint _tmp52__length1;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	FileItem* _tmp55_;
	GeeHashMap* _tmp56_;
	GeeSet* _tmp57_;
	GeeSet* _tmp58_;
	GeeSet* _tmp59_;
	const gchar* _tmp60_;
	gboolean _tmp61_;
	FileItem* _tmp67_;
	GeeHashMap* _tmp68_;
	const gchar* _tmp69_;
	gpointer _tmp70_;
	FileItem* result = NULL;
#line 201 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 209 "Utility/FileItem.vala"
	_tmp0_ = string_strip (_file_path);
#line 209 "Utility/FileItem.vala"
	item_path = _tmp0_;
#line 210 "Utility/FileItem.vala"
	if (_file_type == NULL) {
#line 210 "Utility/FileItem.vala"
		_tmp1_ = G_FILE_TYPE_REGULAR;
#line 860 "FileItem.c"
	} else {
#line 210 "Utility/FileItem.vala"
		_tmp1_ = *_file_type;
#line 864 "FileItem.c"
	}
#line 210 "Utility/FileItem.vala"
	item_type = _tmp1_;
#line 212 "Utility/FileItem.vala"
	_tmp2_ = item_path;
#line 212 "Utility/FileItem.vala"
	if (g_str_has_suffix (_tmp2_, "/")) {
#line 872 "FileItem.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
#line 213 "Utility/FileItem.vala"
		_tmp3_ = item_path;
#line 213 "Utility/FileItem.vala"
		_tmp4_ = item_path;
#line 213 "Utility/FileItem.vala"
		_tmp5_ = strlen (_tmp4_);
#line 213 "Utility/FileItem.vala"
		_tmp6_ = _tmp5_;
#line 213 "Utility/FileItem.vala"
		_tmp7_ = string_slice (_tmp3_, (glong) 0, (glong) (_tmp6_ - 1));
#line 213 "Utility/FileItem.vala"
		_g_free0 (item_path);
#line 213 "Utility/FileItem.vala"
		item_path = _tmp7_;
#line 214 "Utility/FileItem.vala"
		item_type = G_FILE_TYPE_DIRECTORY;
#line 894 "FileItem.c"
	}
#line 217 "Utility/FileItem.vala"
	_tmp8_ = item_path;
#line 217 "Utility/FileItem.vala"
	if (g_str_has_prefix (_tmp8_, "/")) {
#line 900 "FileItem.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
#line 218 "Utility/FileItem.vala"
		_tmp9_ = item_path;
#line 218 "Utility/FileItem.vala"
		_tmp10_ = item_path;
#line 218 "Utility/FileItem.vala"
		_tmp11_ = strlen (_tmp10_);
#line 218 "Utility/FileItem.vala"
		_tmp12_ = _tmp11_;
#line 218 "Utility/FileItem.vala"
		_tmp13_ = string_slice (_tmp9_, (glong) 1, (glong) _tmp12_);
#line 218 "Utility/FileItem.vala"
		_g_free0 (item_path);
#line 218 "Utility/FileItem.vala"
		item_path = _tmp13_;
#line 920 "FileItem.c"
	}
#line 221 "Utility/FileItem.vala"
	_tmp14_ = g_strdup ("");
#line 221 "Utility/FileItem.vala"
	dir_name = _tmp14_;
#line 222 "Utility/FileItem.vala"
	_tmp15_ = g_strdup ("");
#line 222 "Utility/FileItem.vala"
	dir_path = _tmp15_;
#line 225 "Utility/FileItem.vala"
	_tmp16_ = _g_object_ref0 (self);
#line 225 "Utility/FileItem.vala"
	current_dir = _tmp16_;
#line 226 "Utility/FileItem.vala"
	_tmp17_ = item_path;
#line 226 "Utility/FileItem.vala"
	_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "/", 0);
#line 226 "Utility/FileItem.vala"
	arr = _tmp19_;
#line 226 "Utility/FileItem.vala"
	arr_length1 = _vala_array_length (_tmp18_);
#line 226 "Utility/FileItem.vala"
	_arr_size_ = arr_length1;
#line 944 "FileItem.c"
	{
		gint i = 0;
#line 227 "Utility/FileItem.vala"
		i = 0;
#line 949 "FileItem.c"
		{
			gboolean _tmp20_ = FALSE;
#line 227 "Utility/FileItem.vala"
			_tmp20_ = TRUE;
#line 227 "Utility/FileItem.vala"
			while (TRUE) {
#line 956 "FileItem.c"
				gchar** _tmp22_;
				gint _tmp22__length1;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				FileItem* _tmp26_;
				GeeHashMap* _tmp27_;
				GeeSet* _tmp28_;
				GeeSet* _tmp29_;
				GeeSet* _tmp30_;
				const gchar* _tmp31_;
				gboolean _tmp32_;
				FileItem* _tmp47_;
				GeeHashMap* _tmp48_;
				const gchar* _tmp49_;
				gpointer _tmp50_;
#line 227 "Utility/FileItem.vala"
				if (!_tmp20_) {
#line 976 "FileItem.c"
					gint _tmp21_;
#line 227 "Utility/FileItem.vala"
					_tmp21_ = i;
#line 227 "Utility/FileItem.vala"
					i = _tmp21_ + 1;
#line 982 "FileItem.c"
				}
#line 227 "Utility/FileItem.vala"
				_tmp20_ = FALSE;
#line 227 "Utility/FileItem.vala"
				_tmp22_ = arr;
#line 227 "Utility/FileItem.vala"
				_tmp22__length1 = arr_length1;
#line 227 "Utility/FileItem.vala"
				if (!(i < (_tmp22__length1 - 1))) {
#line 227 "Utility/FileItem.vala"
					break;
#line 994 "FileItem.c"
				}
#line 229 "Utility/FileItem.vala"
				_tmp23_ = arr;
#line 229 "Utility/FileItem.vala"
				_tmp23__length1 = arr_length1;
#line 229 "Utility/FileItem.vala"
				_tmp24_ = _tmp23_[i];
#line 229 "Utility/FileItem.vala"
				_tmp25_ = g_strdup (_tmp24_);
#line 229 "Utility/FileItem.vala"
				_g_free0 (dir_name);
#line 229 "Utility/FileItem.vala"
				dir_name = _tmp25_;
#line 232 "Utility/FileItem.vala"
				_tmp26_ = current_dir;
#line 232 "Utility/FileItem.vala"
				_tmp27_ = _tmp26_->children;
#line 232 "Utility/FileItem.vala"
				_tmp28_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp27_);
#line 232 "Utility/FileItem.vala"
				_tmp29_ = _tmp28_;
#line 232 "Utility/FileItem.vala"
				_tmp30_ = _tmp29_;
#line 232 "Utility/FileItem.vala"
				_tmp31_ = dir_name;
#line 232 "Utility/FileItem.vala"
				_tmp32_ = !gee_collection_contains ((GeeCollection*) _tmp30_, _tmp31_);
#line 232 "Utility/FileItem.vala"
				_g_object_unref0 (_tmp30_);
#line 232 "Utility/FileItem.vala"
				if (_tmp32_) {
#line 1026 "FileItem.c"
					gboolean _tmp33_ = FALSE;
					FileItem* _tmp34_;
					const gchar* _tmp40_;
					const gchar* _tmp41_;
					gchar* _tmp42_;
					FileItem* _tmp43_;
					const gchar* _tmp44_;
					FileItem* _tmp45_;
					FileItem* _tmp46_;
#line 233 "Utility/FileItem.vala"
					_tmp34_ = current_dir;
#line 233 "Utility/FileItem.vala"
					if (_tmp34_ == self) {
#line 1040 "FileItem.c"
						FileItem* _tmp35_;
#line 233 "Utility/FileItem.vala"
						_tmp35_ = current_dir;
#line 233 "Utility/FileItem.vala"
						_tmp33_ = _tmp35_->is_archive;
#line 1046 "FileItem.c"
					} else {
#line 233 "Utility/FileItem.vala"
						_tmp33_ = FALSE;
#line 1050 "FileItem.c"
					}
#line 233 "Utility/FileItem.vala"
					if (_tmp33_) {
#line 1054 "FileItem.c"
						gchar* _tmp36_;
#line 234 "Utility/FileItem.vala"
						_tmp36_ = g_strdup ("");
#line 234 "Utility/FileItem.vala"
						_g_free0 (dir_path);
#line 234 "Utility/FileItem.vala"
						dir_path = _tmp36_;
#line 1062 "FileItem.c"
					} else {
						FileItem* _tmp37_;
						const gchar* _tmp38_;
						gchar* _tmp39_;
#line 237 "Utility/FileItem.vala"
						_tmp37_ = current_dir;
#line 237 "Utility/FileItem.vala"
						_tmp38_ = _tmp37_->file_path;
#line 237 "Utility/FileItem.vala"
						_tmp39_ = g_strconcat (_tmp38_, "/", NULL);
#line 237 "Utility/FileItem.vala"
						_g_free0 (dir_path);
#line 237 "Utility/FileItem.vala"
						dir_path = _tmp39_;
#line 1077 "FileItem.c"
					}
#line 239 "Utility/FileItem.vala"
					_tmp40_ = dir_path;
#line 239 "Utility/FileItem.vala"
					_tmp41_ = dir_name;
#line 239 "Utility/FileItem.vala"
					_tmp42_ = g_strdup_printf ("%s%s", _tmp40_, _tmp41_);
#line 239 "Utility/FileItem.vala"
					_g_free0 (dir_path);
#line 239 "Utility/FileItem.vala"
					dir_path = _tmp42_;
#line 240 "Utility/FileItem.vala"
					_tmp43_ = current_dir;
#line 240 "Utility/FileItem.vala"
					_tmp44_ = dir_path;
#line 240 "Utility/FileItem.vala"
					_tmp45_ = file_item_add_child (_tmp43_, _tmp44_, G_FILE_TYPE_DIRECTORY, (gint64) 0, (gint64) 0, FALSE);
#line 240 "Utility/FileItem.vala"
					_tmp46_ = _tmp45_;
#line 240 "Utility/FileItem.vala"
					_g_object_unref0 (_tmp46_);
#line 1099 "FileItem.c"
				}
#line 243 "Utility/FileItem.vala"
				_tmp47_ = current_dir;
#line 243 "Utility/FileItem.vala"
				_tmp48_ = _tmp47_->children;
#line 243 "Utility/FileItem.vala"
				_tmp49_ = dir_name;
#line 243 "Utility/FileItem.vala"
				_tmp50_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp48_, _tmp49_);
#line 243 "Utility/FileItem.vala"
				_g_object_unref0 (current_dir);
#line 243 "Utility/FileItem.vala"
				current_dir = (FileItem*) _tmp50_;
#line 1113 "FileItem.c"
			}
		}
	}
#line 247 "Utility/FileItem.vala"
	_tmp51_ = arr;
#line 247 "Utility/FileItem.vala"
	_tmp51__length1 = arr_length1;
#line 247 "Utility/FileItem.vala"
	_tmp52_ = arr;
#line 247 "Utility/FileItem.vala"
	_tmp52__length1 = arr_length1;
#line 247 "Utility/FileItem.vala"
	_tmp53_ = _tmp51_[_tmp52__length1 - 1];
#line 247 "Utility/FileItem.vala"
	_tmp54_ = g_strdup (_tmp53_);
#line 247 "Utility/FileItem.vala"
	item_name = _tmp54_;
#line 250 "Utility/FileItem.vala"
	_tmp55_ = current_dir;
#line 250 "Utility/FileItem.vala"
	_tmp56_ = _tmp55_->children;
#line 250 "Utility/FileItem.vala"
	_tmp57_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp56_);
#line 250 "Utility/FileItem.vala"
	_tmp58_ = _tmp57_;
#line 250 "Utility/FileItem.vala"
	_tmp59_ = _tmp58_;
#line 250 "Utility/FileItem.vala"
	_tmp60_ = item_name;
#line 250 "Utility/FileItem.vala"
	_tmp61_ = !gee_collection_contains ((GeeCollection*) _tmp59_, _tmp60_);
#line 250 "Utility/FileItem.vala"
	_g_object_unref0 (_tmp59_);
#line 250 "Utility/FileItem.vala"
	if (_tmp61_) {
#line 1149 "FileItem.c"
		FileItem* _tmp62_;
		const gchar* _tmp63_;
		GFileType _tmp64_;
		FileItem* _tmp65_;
		FileItem* _tmp66_;
#line 254 "Utility/FileItem.vala"
		_tmp62_ = current_dir;
#line 254 "Utility/FileItem.vala"
		_tmp63_ = item_path;
#line 254 "Utility/FileItem.vala"
		_tmp64_ = item_type;
#line 254 "Utility/FileItem.vala"
		_tmp65_ = file_item_add_child (_tmp62_, _tmp63_, _tmp64_, item_size, item_size_compressed, FALSE);
#line 254 "Utility/FileItem.vala"
		_tmp66_ = _tmp65_;
#line 254 "Utility/FileItem.vala"
		_g_object_unref0 (_tmp66_);
#line 1167 "FileItem.c"
	}
#line 260 "Utility/FileItem.vala"
	_tmp67_ = current_dir;
#line 260 "Utility/FileItem.vala"
	_tmp68_ = _tmp67_->children;
#line 260 "Utility/FileItem.vala"
	_tmp69_ = item_name;
#line 260 "Utility/FileItem.vala"
	_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp68_, _tmp69_);
#line 260 "Utility/FileItem.vala"
	result = (FileItem*) _tmp70_;
#line 260 "Utility/FileItem.vala"
	_g_free0 (item_name);
#line 260 "Utility/FileItem.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 260 "Utility/FileItem.vala"
	_g_object_unref0 (current_dir);
#line 260 "Utility/FileItem.vala"
	_g_free0 (dir_path);
#line 260 "Utility/FileItem.vala"
	_g_free0 (dir_name);
#line 260 "Utility/FileItem.vala"
	_g_free0 (item_path);
#line 260 "Utility/FileItem.vala"
	return result;
#line 1193 "FileItem.c"
}

FileItem*
file_item_add_child (FileItem* self,
                     const gchar* item_file_path,
                     GFileType item_file_type,
                     gint64 item_size,
                     gint64 item_size_compressed,
                     gboolean item_query_file_info)
{
	FileItem* item = NULL;
	FileItem* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gboolean existing_file = FALSE;
	GeeHashMap* _tmp6_;
	FileItem* _tmp7_;
	const gchar* _tmp8_;
	FileItem* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	FileItem* result = NULL;
#line 263 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 263 "Utility/FileItem.vala"
	g_return_val_if_fail (item_file_path != NULL, NULL);
#line 274 "Utility/FileItem.vala"
	_tmp0_ = file_item_new_from_path_and_type (item_file_path, item_file_type);
#line 274 "Utility/FileItem.vala"
	item = _tmp0_;
#line 277 "Utility/FileItem.vala"
	_tmp1_ = file_item_archive_extensions;
#line 277 "Utility/FileItem.vala"
	_tmp1__length1 = file_item_archive_extensions_length1;
#line 1228 "FileItem.c"
	{
		gchar** ext_collection = NULL;
		gint ext_collection_length1 = 0;
		gint _ext_collection_size_ = 0;
		gint ext_it = 0;
#line 277 "Utility/FileItem.vala"
		ext_collection = _tmp1_;
#line 277 "Utility/FileItem.vala"
		ext_collection_length1 = _tmp1__length1;
#line 277 "Utility/FileItem.vala"
		for (ext_it = 0; ext_it < ext_collection_length1; ext_it = ext_it + 1) {
#line 1240 "FileItem.c"
			gchar* _tmp2_;
			gchar* ext = NULL;
#line 277 "Utility/FileItem.vala"
			_tmp2_ = g_strdup (ext_collection[ext_it]);
#line 277 "Utility/FileItem.vala"
			ext = _tmp2_;
#line 1247 "FileItem.c"
			{
				const gchar* _tmp3_;
#line 278 "Utility/FileItem.vala"
				_tmp3_ = ext;
#line 278 "Utility/FileItem.vala"
				if (g_str_has_suffix (item_file_path, _tmp3_)) {
#line 1254 "FileItem.c"
					ArchiveFile* _tmp4_;
					FileItem* _tmp5_;
#line 279 "Utility/FileItem.vala"
					_tmp4_ = archive_file_new (item_file_path);
#line 279 "Utility/FileItem.vala"
					_g_object_unref0 (item);
#line 279 "Utility/FileItem.vala"
					item = (FileItem*) _tmp4_;
#line 280 "Utility/FileItem.vala"
					_tmp5_ = item;
#line 280 "Utility/FileItem.vala"
					_tmp5_->is_archive = TRUE;
#line 281 "Utility/FileItem.vala"
					_g_free0 (ext);
#line 281 "Utility/FileItem.vala"
					break;
#line 1271 "FileItem.c"
				}
#line 277 "Utility/FileItem.vala"
				_g_free0 (ext);
#line 1275 "FileItem.c"
			}
		}
	}
#line 287 "Utility/FileItem.vala"
	existing_file = FALSE;
#line 288 "Utility/FileItem.vala"
	_tmp6_ = self->children;
#line 288 "Utility/FileItem.vala"
	_tmp7_ = item;
#line 288 "Utility/FileItem.vala"
	_tmp8_ = _tmp7_->file_name;
#line 288 "Utility/FileItem.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, _tmp8_)) {
#line 1289 "FileItem.c"
		GeeHashMap* _tmp9_;
		FileItem* _tmp10_;
		const gchar* _tmp11_;
		FileItem* _tmp12_;
		FileItem* _tmp13_;
		FileItem* _tmp14_;
#line 289 "Utility/FileItem.vala"
		_tmp9_ = self->children;
#line 289 "Utility/FileItem.vala"
		_tmp10_ = item;
#line 289 "Utility/FileItem.vala"
		_tmp11_ = _tmp10_->file_name;
#line 289 "Utility/FileItem.vala"
		_tmp12_ = item;
#line 289 "Utility/FileItem.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp11_, _tmp12_);
#line 292 "Utility/FileItem.vala"
		_tmp13_ = item;
#line 292 "Utility/FileItem.vala"
		_tmp14_ = _g_object_ref0 (self);
#line 292 "Utility/FileItem.vala"
		_g_object_unref0 (_tmp13_->parent);
#line 292 "Utility/FileItem.vala"
		_tmp13_->parent = _tmp14_;
#line 1314 "FileItem.c"
	} else {
		GeeHashMap* _tmp15_;
		FileItem* _tmp16_;
		const gchar* _tmp17_;
		gpointer _tmp18_;
		FileItem* _tmp19_;
#line 295 "Utility/FileItem.vala"
		existing_file = TRUE;
#line 296 "Utility/FileItem.vala"
		_tmp15_ = self->children;
#line 296 "Utility/FileItem.vala"
		_tmp16_ = item;
#line 296 "Utility/FileItem.vala"
		_tmp17_ = _tmp16_->file_name;
#line 296 "Utility/FileItem.vala"
		_tmp18_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp17_);
#line 296 "Utility/FileItem.vala"
		_g_object_unref0 (item);
#line 296 "Utility/FileItem.vala"
		item = (FileItem*) _tmp18_;
#line 299 "Utility/FileItem.vala"
		_tmp19_ = item;
#line 299 "Utility/FileItem.vala"
		_tmp19_->is_stale = FALSE;
#line 1339 "FileItem.c"
	}
#line 303 "Utility/FileItem.vala"
	_tmp20_ = item;
#line 303 "Utility/FileItem.vala"
	_tmp21_ = self->file_path_prefix;
#line 303 "Utility/FileItem.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 303 "Utility/FileItem.vala"
	_g_free0 (_tmp20_->file_path_prefix);
#line 303 "Utility/FileItem.vala"
	_tmp20_->file_path_prefix = _tmp22_;
#line 306 "Utility/FileItem.vala"
	if (item_query_file_info) {
#line 1353 "FileItem.c"
		FileItem* _tmp23_;
#line 308 "Utility/FileItem.vala"
		_tmp23_ = item;
#line 308 "Utility/FileItem.vala"
		file_item_query_file_info (_tmp23_);
#line 1359 "FileItem.c"
	}
#line 311 "Utility/FileItem.vala"
	if (item_file_type == G_FILE_TYPE_REGULAR) {
#line 316 "Utility/FileItem.vala"
		if (item_size > ((gint64) 0)) {
#line 1365 "FileItem.c"
			FileItem* _tmp24_;
#line 317 "Utility/FileItem.vala"
			_tmp24_ = item;
#line 317 "Utility/FileItem.vala"
			_tmp24_->priv->_size = item_size;
#line 1371 "FileItem.c"
		}
#line 319 "Utility/FileItem.vala"
		if (item_size_compressed > ((gint64) 0)) {
#line 1375 "FileItem.c"
			FileItem* _tmp25_;
#line 320 "Utility/FileItem.vala"
			_tmp25_ = item;
#line 320 "Utility/FileItem.vala"
			_tmp25_->priv->_size_compressed = item_size_compressed;
#line 1381 "FileItem.c"
		}
#line 324 "Utility/FileItem.vala"
		if (!existing_file) {
#line 1385 "FileItem.c"
			glong _tmp26_;
			glong _tmp27_;
			FileItem* temp = NULL;
			FileItem* _tmp28_;
#line 325 "Utility/FileItem.vala"
			_tmp26_ = self->file_count;
#line 325 "Utility/FileItem.vala"
			self->file_count = _tmp26_ + 1;
#line 326 "Utility/FileItem.vala"
			_tmp27_ = self->file_count_total;
#line 326 "Utility/FileItem.vala"
			self->file_count_total = _tmp27_ + 1;
#line 327 "Utility/FileItem.vala"
			self->priv->_size = self->priv->_size + item_size;
#line 328 "Utility/FileItem.vala"
			self->priv->_size_compressed = self->priv->_size_compressed + item_size_compressed;
#line 331 "Utility/FileItem.vala"
			_tmp28_ = _g_object_ref0 (self);
#line 331 "Utility/FileItem.vala"
			temp = _tmp28_;
#line 332 "Utility/FileItem.vala"
			while (TRUE) {
#line 1408 "FileItem.c"
				FileItem* _tmp29_;
				FileItem* _tmp30_;
				FileItem* _tmp31_;
				FileItem* _tmp32_;
				glong _tmp33_;
				FileItem* _tmp34_;
				FileItem* _tmp35_;
				FileItem* _tmp36_;
				FileItem* _tmp37_;
				FileItem* _tmp38_;
				FileItem* _tmp39_;
				FileItem* _tmp40_;
				FileItem* _tmp41_;
				FileItem* _tmp42_;
				FileItem* _tmp43_;
				FileItem* _tmp44_;
#line 332 "Utility/FileItem.vala"
				_tmp29_ = temp;
#line 332 "Utility/FileItem.vala"
				_tmp30_ = _tmp29_->parent;
#line 332 "Utility/FileItem.vala"
				if (!(_tmp30_ != NULL)) {
#line 332 "Utility/FileItem.vala"
					break;
#line 1433 "FileItem.c"
				}
#line 333 "Utility/FileItem.vala"
				_tmp31_ = temp;
#line 333 "Utility/FileItem.vala"
				_tmp32_ = _tmp31_->parent;
#line 333 "Utility/FileItem.vala"
				_tmp33_ = _tmp32_->file_count_total;
#line 333 "Utility/FileItem.vala"
				_tmp32_->file_count_total = _tmp33_ + 1;
#line 334 "Utility/FileItem.vala"
				_tmp34_ = temp;
#line 334 "Utility/FileItem.vala"
				_tmp35_ = _tmp34_->parent;
#line 334 "Utility/FileItem.vala"
				_tmp36_ = temp;
#line 334 "Utility/FileItem.vala"
				_tmp37_ = _tmp36_->parent;
#line 334 "Utility/FileItem.vala"
				_tmp37_->priv->_size = _tmp37_->priv->_size + item_size;
#line 335 "Utility/FileItem.vala"
				_tmp38_ = temp;
#line 335 "Utility/FileItem.vala"
				_tmp39_ = _tmp38_->parent;
#line 335 "Utility/FileItem.vala"
				_tmp40_ = temp;
#line 335 "Utility/FileItem.vala"
				_tmp41_ = _tmp40_->parent;
#line 335 "Utility/FileItem.vala"
				_tmp41_->priv->_size_compressed = _tmp41_->priv->_size_compressed + item_size_compressed;
#line 336 "Utility/FileItem.vala"
				_tmp42_ = temp;
#line 336 "Utility/FileItem.vala"
				_tmp43_ = _tmp42_->parent;
#line 336 "Utility/FileItem.vala"
				_tmp44_ = _g_object_ref0 (_tmp43_);
#line 336 "Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 336 "Utility/FileItem.vala"
				temp = _tmp44_;
#line 1473 "FileItem.c"
			}
#line 324 "Utility/FileItem.vala"
			_g_object_unref0 (temp);
#line 1477 "FileItem.c"
		}
	} else {
#line 340 "Utility/FileItem.vala"
		if (item_file_type == G_FILE_TYPE_DIRECTORY) {
#line 344 "Utility/FileItem.vala"
			if (!existing_file) {
#line 1484 "FileItem.c"
				glong _tmp45_;
				glong _tmp46_;
				FileItem* temp = NULL;
				FileItem* _tmp47_;
#line 347 "Utility/FileItem.vala"
				_tmp45_ = self->dir_count;
#line 347 "Utility/FileItem.vala"
				self->dir_count = _tmp45_ + 1;
#line 348 "Utility/FileItem.vala"
				_tmp46_ = self->dir_count_total;
#line 348 "Utility/FileItem.vala"
				self->dir_count_total = _tmp46_ + 1;
#line 353 "Utility/FileItem.vala"
				_tmp47_ = _g_object_ref0 (self);
#line 353 "Utility/FileItem.vala"
				temp = _tmp47_;
#line 354 "Utility/FileItem.vala"
				while (TRUE) {
#line 1503 "FileItem.c"
					FileItem* _tmp48_;
					FileItem* _tmp49_;
					FileItem* _tmp50_;
					FileItem* _tmp51_;
					glong _tmp52_;
					FileItem* _tmp53_;
					FileItem* _tmp54_;
					FileItem* _tmp55_;
#line 354 "Utility/FileItem.vala"
					_tmp48_ = temp;
#line 354 "Utility/FileItem.vala"
					_tmp49_ = _tmp48_->parent;
#line 354 "Utility/FileItem.vala"
					if (!(_tmp49_ != NULL)) {
#line 354 "Utility/FileItem.vala"
						break;
#line 1520 "FileItem.c"
					}
#line 355 "Utility/FileItem.vala"
					_tmp50_ = temp;
#line 355 "Utility/FileItem.vala"
					_tmp51_ = _tmp50_->parent;
#line 355 "Utility/FileItem.vala"
					_tmp52_ = _tmp51_->dir_count_total;
#line 355 "Utility/FileItem.vala"
					_tmp51_->dir_count_total = _tmp52_ + 1;
#line 356 "Utility/FileItem.vala"
					_tmp53_ = temp;
#line 356 "Utility/FileItem.vala"
					_tmp54_ = _tmp53_->parent;
#line 356 "Utility/FileItem.vala"
					_tmp55_ = _g_object_ref0 (_tmp54_);
#line 356 "Utility/FileItem.vala"
					_g_object_unref0 (temp);
#line 356 "Utility/FileItem.vala"
					temp = _tmp55_;
#line 1540 "FileItem.c"
				}
#line 344 "Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 1544 "FileItem.c"
			}
		}
	}
#line 364 "Utility/FileItem.vala"
	result = item;
#line 364 "Utility/FileItem.vala"
	return result;
#line 1552 "FileItem.c"
}

void
file_item_query_file_info (FileItem* self)
{
	GError* _inner_error0_ = NULL;
#line 367 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 1561 "FileItem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
#line 371 "Utility/FileItem.vala"
		_tmp0_ = self->file_path;
#line 371 "Utility/FileItem.vala"
		_tmp1_ = g_file_parse_name (_tmp0_);
#line 371 "Utility/FileItem.vala"
		file = _tmp1_;
#line 373 "Utility/FileItem.vala"
		_tmp2_ = file;
#line 373 "Utility/FileItem.vala"
		if (g_file_query_exists (_tmp2_, NULL)) {
#line 1578 "FileItem.c"
			GFileInfo* _tmp3_ = NULL;
			GFile* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileType item_file_type = 0;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			GIcon* _tmp12_;
			GIcon* _tmp13_;
			GFileType _tmp14_;
			GFileInfo* _tmp20_ = NULL;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			GFileInfo* _tmp24_;
			GFileInfo* _tmp25_;
			GFileInfo* _tmp26_;
			GFileInfo* _tmp30_;
			GFileInfo* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			gboolean _tmp34_ = FALSE;
			GFileInfo* _tmp37_;
			GTimeVal _tmp38_ = {0};
			GDateTime* _tmp39_;
			GDateTime* _tmp40_;
			GDateTime* _tmp41_;
			GFileInfo* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			GFileInfo* _tmp45_;
			const gchar* _tmp46_;
			gchar* _tmp47_;
#line 377 "Utility/FileItem.vala"
			_tmp4_ = file;
#line 377 "Utility/FileItem.vala"
			_tmp5_ = g_strdup_printf ("%s,%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_ICON, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 377 "Utility/FileItem.vala"
			_tmp6_ = _tmp5_;
#line 377 "Utility/FileItem.vala"
			_tmp7_ = g_file_query_info (_tmp4_, _tmp6_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 377 "Utility/FileItem.vala"
			_tmp8_ = _tmp7_;
#line 377 "Utility/FileItem.vala"
			_g_free0 (_tmp6_);
#line 377 "Utility/FileItem.vala"
			_tmp3_ = _tmp8_;
#line 377 "Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 377 "Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 377 "Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 1635 "FileItem.c"
				goto __catch0_g_error;
			}
#line 377 "Utility/FileItem.vala"
			_tmp9_ = _tmp3_;
#line 377 "Utility/FileItem.vala"
			_tmp3_ = NULL;
#line 377 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 377 "Utility/FileItem.vala"
			info = _tmp9_;
#line 383 "Utility/FileItem.vala"
			_tmp10_ = info;
#line 383 "Utility/FileItem.vala"
			item_file_type = g_file_info_get_file_type (_tmp10_);
#line 385 "Utility/FileItem.vala"
			_tmp11_ = info;
#line 385 "Utility/FileItem.vala"
			_tmp12_ = g_file_info_get_icon (_tmp11_);
#line 385 "Utility/FileItem.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 385 "Utility/FileItem.vala"
			_g_object_unref0 (self->icon);
#line 385 "Utility/FileItem.vala"
			self->icon = _tmp13_;
#line 387 "Utility/FileItem.vala"
			_tmp14_ = item_file_type;
#line 387 "Utility/FileItem.vala"
			if (_tmp14_ == G_FILE_TYPE_SYMBOLIC_LINK) {
#line 1664 "FileItem.c"
				GFileInfo* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 389 "Utility/FileItem.vala"
				self->is_symlink = TRUE;
#line 390 "Utility/FileItem.vala"
				_tmp15_ = info;
#line 390 "Utility/FileItem.vala"
				_tmp16_ = g_file_info_get_symlink_target (_tmp15_);
#line 390 "Utility/FileItem.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 390 "Utility/FileItem.vala"
				_g_free0 (self->symlink_target);
#line 390 "Utility/FileItem.vala"
				self->symlink_target = _tmp17_;
#line 1680 "FileItem.c"
			} else {
				gchar* _tmp18_;
				GFileType _tmp19_;
#line 394 "Utility/FileItem.vala"
				self->is_symlink = FALSE;
#line 395 "Utility/FileItem.vala"
				_tmp18_ = g_strdup ("");
#line 395 "Utility/FileItem.vala"
				_g_free0 (self->symlink_target);
#line 395 "Utility/FileItem.vala"
				self->symlink_target = _tmp18_;
#line 397 "Utility/FileItem.vala"
				_tmp19_ = item_file_type;
#line 397 "Utility/FileItem.vala"
				if (_tmp19_ == G_FILE_TYPE_REGULAR) {
#line 1696 "FileItem.c"
				}
			}
#line 412 "Utility/FileItem.vala"
			_tmp21_ = file;
#line 412 "Utility/FileItem.vala"
			_tmp22_ = g_strdup_printf ("%s,%s,%s,%s,%s,%s,%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_ATTRIBUTE_STANDARD_ICON, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_ATTRIBUTE_OWNER_USER, G_FILE_ATTRIBUTE_OWNER_GROUP, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 412 "Utility/FileItem.vala"
			_tmp23_ = _tmp22_;
#line 412 "Utility/FileItem.vala"
			_tmp24_ = g_file_query_info (_tmp21_, _tmp23_, 0, NULL, &_inner_error0_);
#line 412 "Utility/FileItem.vala"
			_tmp25_ = _tmp24_;
#line 412 "Utility/FileItem.vala"
			_g_free0 (_tmp23_);
#line 412 "Utility/FileItem.vala"
			_tmp20_ = _tmp25_;
#line 412 "Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "Utility/FileItem.vala"
				_g_object_unref0 (_tmp3_);
#line 412 "Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 412 "Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 1721 "FileItem.c"
				goto __catch0_g_error;
			}
#line 412 "Utility/FileItem.vala"
			_tmp26_ = _tmp20_;
#line 412 "Utility/FileItem.vala"
			_tmp20_ = NULL;
#line 412 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 412 "Utility/FileItem.vala"
			info = _tmp26_;
#line 423 "Utility/FileItem.vala"
			if (self->is_symlink) {
#line 1734 "FileItem.c"
				GFileInfo* _tmp27_;
				GIcon* _tmp28_;
				GIcon* _tmp29_;
#line 425 "Utility/FileItem.vala"
				_tmp27_ = info;
#line 425 "Utility/FileItem.vala"
				_tmp28_ = g_file_info_get_icon (_tmp27_);
#line 425 "Utility/FileItem.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 425 "Utility/FileItem.vala"
				_g_object_unref0 (self->icon);
#line 425 "Utility/FileItem.vala"
				self->icon = _tmp29_;
#line 1748 "FileItem.c"
			}
#line 429 "Utility/FileItem.vala"
			_tmp30_ = info;
#line 429 "Utility/FileItem.vala"
			self->file_type = g_file_info_get_file_type (_tmp30_);
#line 432 "Utility/FileItem.vala"
			_tmp31_ = info;
#line 432 "Utility/FileItem.vala"
			_tmp32_ = g_file_info_get_content_type (_tmp31_);
#line 432 "Utility/FileItem.vala"
			_tmp33_ = g_strdup (_tmp32_);
#line 432 "Utility/FileItem.vala"
			_g_free0 (self->content_type);
#line 432 "Utility/FileItem.vala"
			self->content_type = _tmp33_;
#line 435 "Utility/FileItem.vala"
			if (!self->is_symlink) {
#line 1766 "FileItem.c"
				GFileType _tmp35_;
#line 435 "Utility/FileItem.vala"
				_tmp35_ = self->file_type;
#line 435 "Utility/FileItem.vala"
				_tmp34_ = _tmp35_ == G_FILE_TYPE_REGULAR;
#line 1772 "FileItem.c"
			} else {
#line 435 "Utility/FileItem.vala"
				_tmp34_ = FALSE;
#line 1776 "FileItem.c"
			}
#line 435 "Utility/FileItem.vala"
			if (_tmp34_) {
#line 1780 "FileItem.c"
				GFileInfo* _tmp36_;
#line 436 "Utility/FileItem.vala"
				_tmp36_ = info;
#line 436 "Utility/FileItem.vala"
				self->priv->_size = g_file_info_get_size (_tmp36_);
#line 1786 "FileItem.c"
			}
#line 440 "Utility/FileItem.vala"
			_tmp37_ = info;
#line 440 "Utility/FileItem.vala"
			g_file_info_get_modification_time (_tmp37_, &_tmp38_);
#line 440 "Utility/FileItem.vala"
			_tmp39_ = g_date_time_new_from_timeval_utc (&_tmp38_);
#line 440 "Utility/FileItem.vala"
			_tmp40_ = _tmp39_;
#line 440 "Utility/FileItem.vala"
			_tmp41_ = g_date_time_to_local (_tmp40_);
#line 440 "Utility/FileItem.vala"
			_g_date_time_unref0 (self->modified);
#line 440 "Utility/FileItem.vala"
			self->modified = _tmp41_;
#line 440 "Utility/FileItem.vala"
			_g_date_time_unref0 (_tmp40_);
#line 443 "Utility/FileItem.vala"
			_tmp42_ = info;
#line 443 "Utility/FileItem.vala"
			_tmp43_ = g_file_info_get_attribute_string (_tmp42_, G_FILE_ATTRIBUTE_OWNER_USER);
#line 443 "Utility/FileItem.vala"
			_tmp44_ = g_strdup (_tmp43_);
#line 443 "Utility/FileItem.vala"
			_g_free0 (self->owner_user);
#line 443 "Utility/FileItem.vala"
			self->owner_user = _tmp44_;
#line 446 "Utility/FileItem.vala"
			_tmp45_ = info;
#line 446 "Utility/FileItem.vala"
			_tmp46_ = g_file_info_get_attribute_string (_tmp45_, G_FILE_ATTRIBUTE_OWNER_GROUP);
#line 446 "Utility/FileItem.vala"
			_tmp47_ = g_strdup (_tmp46_);
#line 446 "Utility/FileItem.vala"
			_g_free0 (self->owner_group);
#line 446 "Utility/FileItem.vala"
			self->owner_group = _tmp47_;
#line 373 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp20_);
#line 373 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp3_);
#line 1828 "FileItem.c"
		}
#line 369 "Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 369 "Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 1834 "FileItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp48_;
		const gchar* _tmp49_;
#line 369 "Utility/FileItem.vala"
		e = _inner_error0_;
#line 369 "Utility/FileItem.vala"
		_inner_error0_ = NULL;
#line 451 "Utility/FileItem.vala"
		_tmp48_ = e;
#line 451 "Utility/FileItem.vala"
		_tmp49_ = _tmp48_->message;
#line 451 "Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp49_, FALSE, FALSE);
#line 369 "Utility/FileItem.vala"
		_g_error_free0 (e);
#line 1854 "FileItem.c"
	}
	__finally0:
#line 369 "Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 369 "Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 369 "Utility/FileItem.vala"
		g_clear_error (&_inner_error0_);
#line 369 "Utility/FileItem.vala"
		return;
#line 1865 "FileItem.c"
	}
}

void
file_item_query_file_info_basic (FileItem* self)
{
	GError* _inner_error0_ = NULL;
#line 455 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 1875 "FileItem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
#line 459 "Utility/FileItem.vala"
		_tmp0_ = self->file_path;
#line 459 "Utility/FileItem.vala"
		_tmp1_ = g_file_parse_name (_tmp0_);
#line 459 "Utility/FileItem.vala"
		file = _tmp1_;
#line 461 "Utility/FileItem.vala"
		_tmp2_ = file;
#line 461 "Utility/FileItem.vala"
		if (g_file_query_exists (_tmp2_, NULL)) {
#line 1892 "FileItem.c"
			GFileInfo* _tmp3_ = NULL;
			GFile* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GIcon* _tmp11_;
			GIcon* _tmp12_;
			GFileInfo* _tmp13_;
#line 465 "Utility/FileItem.vala"
			_tmp4_ = file;
#line 465 "Utility/FileItem.vala"
			_tmp5_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_ICON);
#line 465 "Utility/FileItem.vala"
			_tmp6_ = _tmp5_;
#line 465 "Utility/FileItem.vala"
			_tmp7_ = g_file_query_info (_tmp4_, _tmp6_, 0, NULL, &_inner_error0_);
#line 465 "Utility/FileItem.vala"
			_tmp8_ = _tmp7_;
#line 465 "Utility/FileItem.vala"
			_g_free0 (_tmp6_);
#line 465 "Utility/FileItem.vala"
			_tmp3_ = _tmp8_;
#line 465 "Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 465 "Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 465 "Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 1924 "FileItem.c"
				goto __catch0_g_error;
			}
#line 465 "Utility/FileItem.vala"
			_tmp9_ = _tmp3_;
#line 465 "Utility/FileItem.vala"
			_tmp3_ = NULL;
#line 465 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 465 "Utility/FileItem.vala"
			info = _tmp9_;
#line 470 "Utility/FileItem.vala"
			_tmp10_ = info;
#line 470 "Utility/FileItem.vala"
			_tmp11_ = g_file_info_get_icon (_tmp10_);
#line 470 "Utility/FileItem.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 470 "Utility/FileItem.vala"
			_g_object_unref0 (self->icon);
#line 470 "Utility/FileItem.vala"
			self->icon = _tmp12_;
#line 472 "Utility/FileItem.vala"
			_tmp13_ = info;
#line 472 "Utility/FileItem.vala"
			self->file_type = g_file_info_get_file_type (_tmp13_);
#line 461 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp3_);
#line 1951 "FileItem.c"
		}
#line 457 "Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 457 "Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 1957 "FileItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 457 "Utility/FileItem.vala"
		e = _inner_error0_;
#line 457 "Utility/FileItem.vala"
		_inner_error0_ = NULL;
#line 476 "Utility/FileItem.vala"
		_tmp14_ = e;
#line 476 "Utility/FileItem.vala"
		_tmp15_ = _tmp14_->message;
#line 476 "Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 457 "Utility/FileItem.vala"
		_g_error_free0 (e);
#line 1977 "FileItem.c"
	}
	__finally0:
#line 457 "Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 457 "Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 457 "Utility/FileItem.vala"
		g_clear_error (&_inner_error0_);
#line 457 "Utility/FileItem.vala"
		return;
#line 1988 "FileItem.c"
	}
}

void
file_item_query_children (FileItem* self,
                          gint depth)
{
	GFileEnumerator* enumerator = NULL;
	GFileInfo* info = NULL;
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileType _tmp3_;
	GError* _inner_error0_ = NULL;
#line 480 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 483 "Utility/FileItem.vala"
	_tmp0_ = self->file_path;
#line 483 "Utility/FileItem.vala"
	_tmp1_ = g_file_parse_name (_tmp0_);
#line 483 "Utility/FileItem.vala"
	file = _tmp1_;
#line 485 "Utility/FileItem.vala"
	_tmp2_ = file;
#line 485 "Utility/FileItem.vala"
	if (!g_file_query_exists (_tmp2_, NULL)) {
#line 486 "Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 486 "Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 486 "Utility/FileItem.vala"
		_g_object_unref0 (enumerator);
#line 486 "Utility/FileItem.vala"
		return;
#line 2024 "FileItem.c"
	}
#line 489 "Utility/FileItem.vala"
	_tmp3_ = self->file_type;
#line 489 "Utility/FileItem.vala"
	if (_tmp3_ == G_FILE_TYPE_DIRECTORY) {
#line 490 "Utility/FileItem.vala"
		if (depth == 0) {
#line 491 "Utility/FileItem.vala"
			_g_object_unref0 (file);
#line 491 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 491 "Utility/FileItem.vala"
			_g_object_unref0 (enumerator);
#line 491 "Utility/FileItem.vala"
			return;
#line 2040 "FileItem.c"
		}
		{
			GFileEnumerator* _tmp14_ = NULL;
			GFile* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GFileEnumerator* _tmp18_;
			GFileEnumerator* _tmp19_;
			GFileEnumerator* _tmp20_;
			GeeArrayList* list = NULL;
			GeeArrayList* _tmp35_;
			{
				GeeIterator* _child_it = NULL;
				GeeHashMap* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeCollection* _tmp7_;
				GeeIterator* _tmp8_;
				GeeIterator* _tmp9_;
#line 496 "Utility/FileItem.vala"
				_tmp4_ = self->children;
#line 496 "Utility/FileItem.vala"
				_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
#line 496 "Utility/FileItem.vala"
				_tmp6_ = _tmp5_;
#line 496 "Utility/FileItem.vala"
				_tmp7_ = _tmp6_;
#line 496 "Utility/FileItem.vala"
				_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 496 "Utility/FileItem.vala"
				_tmp9_ = _tmp8_;
#line 496 "Utility/FileItem.vala"
				_g_object_unref0 (_tmp7_);
#line 496 "Utility/FileItem.vala"
				_child_it = _tmp9_;
#line 496 "Utility/FileItem.vala"
				while (TRUE) {
#line 2078 "FileItem.c"
					GeeIterator* _tmp10_;
					FileItem* child = NULL;
					GeeIterator* _tmp11_;
					gpointer _tmp12_;
					FileItem* _tmp13_;
#line 496 "Utility/FileItem.vala"
					_tmp10_ = _child_it;
#line 496 "Utility/FileItem.vala"
					if (!gee_iterator_next (_tmp10_)) {
#line 496 "Utility/FileItem.vala"
						break;
#line 2090 "FileItem.c"
					}
#line 496 "Utility/FileItem.vala"
					_tmp11_ = _child_it;
#line 496 "Utility/FileItem.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 496 "Utility/FileItem.vala"
					child = (FileItem*) _tmp12_;
#line 497 "Utility/FileItem.vala"
					_tmp13_ = child;
#line 497 "Utility/FileItem.vala"
					_tmp13_->is_stale = TRUE;
#line 496 "Utility/FileItem.vala"
					_g_object_unref0 (child);
#line 2104 "FileItem.c"
				}
#line 496 "Utility/FileItem.vala"
				_g_object_unref0 (_child_it);
#line 2108 "FileItem.c"
			}
#line 501 "Utility/FileItem.vala"
			_tmp15_ = file;
#line 501 "Utility/FileItem.vala"
			_tmp16_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 501 "Utility/FileItem.vala"
			_tmp17_ = _tmp16_;
#line 501 "Utility/FileItem.vala"
			_tmp18_ = g_file_enumerate_children (_tmp15_, _tmp17_, 0, NULL, &_inner_error0_);
#line 501 "Utility/FileItem.vala"
			_tmp19_ = _tmp18_;
#line 501 "Utility/FileItem.vala"
			_g_free0 (_tmp17_);
#line 501 "Utility/FileItem.vala"
			_tmp14_ = _tmp19_;
#line 501 "Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2126 "FileItem.c"
				goto __catch0_g_error;
			}
#line 501 "Utility/FileItem.vala"
			_tmp20_ = _tmp14_;
#line 501 "Utility/FileItem.vala"
			_tmp14_ = NULL;
#line 501 "Utility/FileItem.vala"
			_g_object_unref0 (enumerator);
#line 501 "Utility/FileItem.vala"
			enumerator = _tmp20_;
#line 502 "Utility/FileItem.vala"
			while (TRUE) {
#line 2139 "FileItem.c"
				GFileInfo* _tmp21_ = NULL;
				GFileEnumerator* _tmp22_;
				GFileInfo* _tmp23_;
				GFileInfo* _tmp24_;
				GFileInfo* _tmp25_;
				gchar* child_name = NULL;
				GFileInfo* _tmp26_;
				const gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* child_path = NULL;
				const gchar* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				const gchar* _tmp32_;
				FileItem* _tmp33_;
				FileItem* _tmp34_;
#line 502 "Utility/FileItem.vala"
				_tmp22_ = enumerator;
#line 502 "Utility/FileItem.vala"
				_tmp23_ = g_file_enumerator_next_file (_tmp22_, NULL, &_inner_error0_);
#line 502 "Utility/FileItem.vala"
				_tmp21_ = _tmp23_;
#line 502 "Utility/FileItem.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 502 "Utility/FileItem.vala"
					_g_object_unref0 (_tmp14_);
#line 2166 "FileItem.c"
					goto __catch0_g_error;
				}
#line 502 "Utility/FileItem.vala"
				_tmp24_ = _tmp21_;
#line 502 "Utility/FileItem.vala"
				_tmp21_ = NULL;
#line 502 "Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 502 "Utility/FileItem.vala"
				info = _tmp24_;
#line 502 "Utility/FileItem.vala"
				_tmp25_ = info;
#line 502 "Utility/FileItem.vala"
				if (!(_tmp25_ != NULL)) {
#line 502 "Utility/FileItem.vala"
					_g_object_unref0 (_tmp21_);
#line 502 "Utility/FileItem.vala"
					break;
#line 2185 "FileItem.c"
				}
#line 503 "Utility/FileItem.vala"
				_tmp26_ = info;
#line 503 "Utility/FileItem.vala"
				_tmp27_ = g_file_info_get_name (_tmp26_);
#line 503 "Utility/FileItem.vala"
				_tmp28_ = g_strdup (_tmp27_);
#line 503 "Utility/FileItem.vala"
				child_name = _tmp28_;
#line 504 "Utility/FileItem.vala"
				_tmp29_ = self->file_path;
#line 504 "Utility/FileItem.vala"
				_tmp30_ = child_name;
#line 504 "Utility/FileItem.vala"
				_tmp31_ = g_build_filename (_tmp29_, _tmp30_, NULL);
#line 504 "Utility/FileItem.vala"
				child_path = _tmp31_;
#line 505 "Utility/FileItem.vala"
				_tmp32_ = child_path;
#line 505 "Utility/FileItem.vala"
				_tmp33_ = file_item_add_child_from_disk (self, _tmp32_, depth - 1);
#line 505 "Utility/FileItem.vala"
				_tmp34_ = _tmp33_;
#line 505 "Utility/FileItem.vala"
				_g_object_unref0 (_tmp34_);
#line 502 "Utility/FileItem.vala"
				_g_free0 (child_path);
#line 502 "Utility/FileItem.vala"
				_g_free0 (child_name);
#line 502 "Utility/FileItem.vala"
				_g_object_unref0 (_tmp21_);
#line 2217 "FileItem.c"
			}
#line 509 "Utility/FileItem.vala"
			_tmp35_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 509 "Utility/FileItem.vala"
			list = _tmp35_;
#line 2223 "FileItem.c"
			{
				GeeIterator* _key_it = NULL;
				GeeHashMap* _tmp36_;
				GeeSet* _tmp37_;
				GeeSet* _tmp38_;
				GeeSet* _tmp39_;
				GeeIterator* _tmp40_;
				GeeIterator* _tmp41_;
#line 510 "Utility/FileItem.vala"
				_tmp36_ = self->children;
#line 510 "Utility/FileItem.vala"
				_tmp37_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp36_);
#line 510 "Utility/FileItem.vala"
				_tmp38_ = _tmp37_;
#line 510 "Utility/FileItem.vala"
				_tmp39_ = _tmp38_;
#line 510 "Utility/FileItem.vala"
				_tmp40_ = gee_iterable_iterator ((GeeIterable*) _tmp39_);
#line 510 "Utility/FileItem.vala"
				_tmp41_ = _tmp40_;
#line 510 "Utility/FileItem.vala"
				_g_object_unref0 (_tmp39_);
#line 510 "Utility/FileItem.vala"
				_key_it = _tmp41_;
#line 510 "Utility/FileItem.vala"
				while (TRUE) {
#line 2250 "FileItem.c"
					GeeIterator* _tmp42_;
					gchar* key = NULL;
					GeeIterator* _tmp43_;
					gpointer _tmp44_;
					GeeHashMap* _tmp45_;
					const gchar* _tmp46_;
					gpointer _tmp47_;
					FileItem* _tmp48_;
					gboolean _tmp49_;
#line 510 "Utility/FileItem.vala"
					_tmp42_ = _key_it;
#line 510 "Utility/FileItem.vala"
					if (!gee_iterator_next (_tmp42_)) {
#line 510 "Utility/FileItem.vala"
						break;
#line 2266 "FileItem.c"
					}
#line 510 "Utility/FileItem.vala"
					_tmp43_ = _key_it;
#line 510 "Utility/FileItem.vala"
					_tmp44_ = gee_iterator_get (_tmp43_);
#line 510 "Utility/FileItem.vala"
					key = (gchar*) _tmp44_;
#line 511 "Utility/FileItem.vala"
					_tmp45_ = self->children;
#line 511 "Utility/FileItem.vala"
					_tmp46_ = key;
#line 511 "Utility/FileItem.vala"
					_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp45_, _tmp46_);
#line 511 "Utility/FileItem.vala"
					_tmp48_ = (FileItem*) _tmp47_;
#line 511 "Utility/FileItem.vala"
					_tmp49_ = _tmp48_->is_stale;
#line 511 "Utility/FileItem.vala"
					_g_object_unref0 (_tmp48_);
#line 511 "Utility/FileItem.vala"
					if (_tmp49_) {
#line 2288 "FileItem.c"
						GeeArrayList* _tmp50_;
						const gchar* _tmp51_;
#line 512 "Utility/FileItem.vala"
						_tmp50_ = list;
#line 512 "Utility/FileItem.vala"
						_tmp51_ = key;
#line 512 "Utility/FileItem.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, _tmp51_);
#line 2297 "FileItem.c"
					}
#line 510 "Utility/FileItem.vala"
					_g_free0 (key);
#line 2301 "FileItem.c"
				}
#line 510 "Utility/FileItem.vala"
				_g_object_unref0 (_key_it);
#line 2305 "FileItem.c"
			}
			{
				GeeArrayList* _key_list = NULL;
				GeeArrayList* _tmp52_;
				GeeArrayList* _tmp53_;
				gint _key_size = 0;
				GeeArrayList* _tmp54_;
				gint _tmp55_;
				gint _tmp56_;
				gint _key_index = 0;
#line 515 "Utility/FileItem.vala"
				_tmp52_ = list;
#line 515 "Utility/FileItem.vala"
				_tmp53_ = _g_object_ref0 (_tmp52_);
#line 515 "Utility/FileItem.vala"
				_key_list = _tmp53_;
#line 515 "Utility/FileItem.vala"
				_tmp54_ = _key_list;
#line 515 "Utility/FileItem.vala"
				_tmp55_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp54_);
#line 515 "Utility/FileItem.vala"
				_tmp56_ = _tmp55_;
#line 515 "Utility/FileItem.vala"
				_key_size = _tmp56_;
#line 515 "Utility/FileItem.vala"
				_key_index = -1;
#line 515 "Utility/FileItem.vala"
				while (TRUE) {
#line 2334 "FileItem.c"
					gchar* key = NULL;
					GeeArrayList* _tmp57_;
					gpointer _tmp58_;
					GeeHashMap* _tmp59_;
					const gchar* _tmp60_;
#line 515 "Utility/FileItem.vala"
					_key_index = _key_index + 1;
#line 515 "Utility/FileItem.vala"
					if (!(_key_index < _key_size)) {
#line 515 "Utility/FileItem.vala"
						break;
#line 2346 "FileItem.c"
					}
#line 515 "Utility/FileItem.vala"
					_tmp57_ = _key_list;
#line 515 "Utility/FileItem.vala"
					_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) _tmp57_, _key_index);
#line 515 "Utility/FileItem.vala"
					key = (gchar*) _tmp58_;
#line 517 "Utility/FileItem.vala"
					_tmp59_ = self->children;
#line 517 "Utility/FileItem.vala"
					_tmp60_ = key;
#line 517 "Utility/FileItem.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp59_, _tmp60_, NULL);
#line 515 "Utility/FileItem.vala"
					_g_free0 (key);
#line 2362 "FileItem.c"
				}
#line 515 "Utility/FileItem.vala"
				_g_object_unref0 (_key_list);
#line 2366 "FileItem.c"
			}
#line 494 "Utility/FileItem.vala"
			_g_object_unref0 (list);
#line 494 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp14_);
#line 2372 "FileItem.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp61_;
			const gchar* _tmp62_;
#line 494 "Utility/FileItem.vala"
			e = _inner_error0_;
#line 494 "Utility/FileItem.vala"
			_inner_error0_ = NULL;
#line 521 "Utility/FileItem.vala"
			_tmp61_ = e;
#line 521 "Utility/FileItem.vala"
			_tmp62_ = _tmp61_->message;
#line 521 "Utility/FileItem.vala"
			tee_jee_logging_log_error (_tmp62_, FALSE, FALSE);
#line 494 "Utility/FileItem.vala"
			_g_error_free0 (e);
#line 2392 "FileItem.c"
		}
		__finally0:
#line 494 "Utility/FileItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 494 "Utility/FileItem.vala"
			_g_object_unref0 (file);
#line 494 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 494 "Utility/FileItem.vala"
			_g_object_unref0 (enumerator);
#line 494 "Utility/FileItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 494 "Utility/FileItem.vala"
			g_clear_error (&_inner_error0_);
#line 494 "Utility/FileItem.vala"
			return;
#line 2409 "FileItem.c"
		}
	}
#line 480 "Utility/FileItem.vala"
	_g_object_unref0 (file);
#line 480 "Utility/FileItem.vala"
	_g_object_unref0 (info);
#line 480 "Utility/FileItem.vala"
	_g_object_unref0 (enumerator);
#line 2418 "FileItem.c"
}

void
file_item_clear_children (FileItem* self)
{
	GeeHashMap* _tmp0_;
#line 526 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 527 "Utility/FileItem.vala"
	_tmp0_ = self->children;
#line 527 "Utility/FileItem.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 2431 "FileItem.c"
}

FileItem*
file_item_remove_child (FileItem* self,
                        const gchar* child_name)
{
	FileItem* child = NULL;
	GeeHashMap* _tmp0_;
	FileItem* result = NULL;
#line 530 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 530 "Utility/FileItem.vala"
	g_return_val_if_fail (child_name != NULL, NULL);
#line 531 "Utility/FileItem.vala"
	child = NULL;
#line 533 "Utility/FileItem.vala"
	_tmp0_ = self->children;
#line 533 "Utility/FileItem.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, child_name)) {
#line 2451 "FileItem.c"
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
		GeeHashMap* _tmp3_;
		FileItem* _tmp4_;
		GFileType _tmp5_;
#line 534 "Utility/FileItem.vala"
		_tmp1_ = self->children;
#line 534 "Utility/FileItem.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, child_name);
#line 534 "Utility/FileItem.vala"
		_g_object_unref0 (child);
#line 534 "Utility/FileItem.vala"
		child = (FileItem*) _tmp2_;
#line 535 "Utility/FileItem.vala"
		_tmp3_ = self->children;
#line 535 "Utility/FileItem.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, child_name, NULL);
#line 537 "Utility/FileItem.vala"
		_tmp4_ = child;
#line 537 "Utility/FileItem.vala"
		_tmp5_ = _tmp4_->file_type;
#line 537 "Utility/FileItem.vala"
		if (_tmp5_ == G_FILE_TYPE_REGULAR) {
#line 2475 "FileItem.c"
			glong _tmp6_;
			glong _tmp7_;
			FileItem* _tmp8_;
			gint64 _tmp9_;
			gint64 _tmp10_;
			FileItem* _tmp11_;
			gint64 _tmp12_;
			gint64 _tmp13_;
			FileItem* temp = NULL;
			FileItem* _tmp14_;
#line 539 "Utility/FileItem.vala"
			_tmp6_ = self->file_count;
#line 539 "Utility/FileItem.vala"
			self->file_count = _tmp6_ - 1;
#line 540 "Utility/FileItem.vala"
			_tmp7_ = self->file_count_total;
#line 540 "Utility/FileItem.vala"
			self->file_count_total = _tmp7_ - 1;
#line 543 "Utility/FileItem.vala"
			_tmp8_ = child;
#line 543 "Utility/FileItem.vala"
			_tmp9_ = file_item_get_size (_tmp8_);
#line 543 "Utility/FileItem.vala"
			_tmp10_ = _tmp9_;
#line 543 "Utility/FileItem.vala"
			self->priv->_size = self->priv->_size - _tmp10_;
#line 544 "Utility/FileItem.vala"
			_tmp11_ = child;
#line 544 "Utility/FileItem.vala"
			_tmp12_ = file_item_get_size_compressed (_tmp11_);
#line 544 "Utility/FileItem.vala"
			_tmp13_ = _tmp12_;
#line 544 "Utility/FileItem.vala"
			self->priv->_size_compressed = self->priv->_size_compressed - _tmp13_;
#line 547 "Utility/FileItem.vala"
			_tmp14_ = _g_object_ref0 (self);
#line 547 "Utility/FileItem.vala"
			temp = _tmp14_;
#line 548 "Utility/FileItem.vala"
			while (TRUE) {
#line 2516 "FileItem.c"
				FileItem* _tmp15_;
				FileItem* _tmp16_;
				FileItem* _tmp17_;
				FileItem* _tmp18_;
				glong _tmp19_;
				FileItem* _tmp20_;
				FileItem* _tmp21_;
				FileItem* _tmp22_;
				FileItem* _tmp23_;
				FileItem* _tmp24_;
				gint64 _tmp25_;
				gint64 _tmp26_;
				FileItem* _tmp27_;
				FileItem* _tmp28_;
				FileItem* _tmp29_;
				FileItem* _tmp30_;
				FileItem* _tmp31_;
				gint64 _tmp32_;
				gint64 _tmp33_;
				FileItem* _tmp34_;
				FileItem* _tmp35_;
				FileItem* _tmp36_;
#line 548 "Utility/FileItem.vala"
				_tmp15_ = temp;
#line 548 "Utility/FileItem.vala"
				_tmp16_ = _tmp15_->parent;
#line 548 "Utility/FileItem.vala"
				if (!(_tmp16_ != NULL)) {
#line 548 "Utility/FileItem.vala"
					break;
#line 2547 "FileItem.c"
				}
#line 549 "Utility/FileItem.vala"
				_tmp17_ = temp;
#line 549 "Utility/FileItem.vala"
				_tmp18_ = _tmp17_->parent;
#line 549 "Utility/FileItem.vala"
				_tmp19_ = _tmp18_->file_count_total;
#line 549 "Utility/FileItem.vala"
				_tmp18_->file_count_total = _tmp19_ - 1;
#line 551 "Utility/FileItem.vala"
				_tmp20_ = temp;
#line 551 "Utility/FileItem.vala"
				_tmp21_ = _tmp20_->parent;
#line 551 "Utility/FileItem.vala"
				_tmp22_ = temp;
#line 551 "Utility/FileItem.vala"
				_tmp23_ = _tmp22_->parent;
#line 551 "Utility/FileItem.vala"
				_tmp24_ = child;
#line 551 "Utility/FileItem.vala"
				_tmp25_ = file_item_get_size (_tmp24_);
#line 551 "Utility/FileItem.vala"
				_tmp26_ = _tmp25_;
#line 551 "Utility/FileItem.vala"
				_tmp23_->priv->_size = _tmp23_->priv->_size - _tmp26_;
#line 552 "Utility/FileItem.vala"
				_tmp27_ = temp;
#line 552 "Utility/FileItem.vala"
				_tmp28_ = _tmp27_->parent;
#line 552 "Utility/FileItem.vala"
				_tmp29_ = temp;
#line 552 "Utility/FileItem.vala"
				_tmp30_ = _tmp29_->parent;
#line 552 "Utility/FileItem.vala"
				_tmp31_ = child;
#line 552 "Utility/FileItem.vala"
				_tmp32_ = file_item_get_size_compressed (_tmp31_);
#line 552 "Utility/FileItem.vala"
				_tmp33_ = _tmp32_;
#line 552 "Utility/FileItem.vala"
				_tmp30_->priv->_size_compressed = _tmp30_->priv->_size_compressed - _tmp33_;
#line 554 "Utility/FileItem.vala"
				_tmp34_ = temp;
#line 554 "Utility/FileItem.vala"
				_tmp35_ = _tmp34_->parent;
#line 554 "Utility/FileItem.vala"
				_tmp36_ = _g_object_ref0 (_tmp35_);
#line 554 "Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 554 "Utility/FileItem.vala"
				temp = _tmp36_;
#line 2599 "FileItem.c"
			}
#line 537 "Utility/FileItem.vala"
			_g_object_unref0 (temp);
#line 2603 "FileItem.c"
		} else {
			glong _tmp37_;
			glong _tmp38_;
			FileItem* _tmp39_;
			FileItem* _tmp40_;
			FileItem* _tmp41_;
			gint64 _tmp42_;
			gint64 _tmp43_;
			FileItem* _tmp44_;
			gint64 _tmp45_;
			gint64 _tmp46_;
			FileItem* temp = NULL;
			FileItem* _tmp47_;
#line 559 "Utility/FileItem.vala"
			_tmp37_ = self->dir_count;
#line 559 "Utility/FileItem.vala"
			self->dir_count = _tmp37_ - 1;
#line 560 "Utility/FileItem.vala"
			_tmp38_ = self->dir_count_total;
#line 560 "Utility/FileItem.vala"
			self->dir_count_total = _tmp38_ - 1;
#line 563 "Utility/FileItem.vala"
			_tmp39_ = child;
#line 563 "Utility/FileItem.vala"
			self->file_count_total = self->file_count_total - _tmp39_->file_count_total;
#line 564 "Utility/FileItem.vala"
			_tmp40_ = child;
#line 564 "Utility/FileItem.vala"
			self->dir_count_total = self->dir_count_total - _tmp40_->dir_count_total;
#line 565 "Utility/FileItem.vala"
			_tmp41_ = child;
#line 565 "Utility/FileItem.vala"
			_tmp42_ = file_item_get_size (_tmp41_);
#line 565 "Utility/FileItem.vala"
			_tmp43_ = _tmp42_;
#line 565 "Utility/FileItem.vala"
			self->priv->_size = self->priv->_size - _tmp43_;
#line 566 "Utility/FileItem.vala"
			_tmp44_ = child;
#line 566 "Utility/FileItem.vala"
			_tmp45_ = file_item_get_size_compressed (_tmp44_);
#line 566 "Utility/FileItem.vala"
			_tmp46_ = _tmp45_;
#line 566 "Utility/FileItem.vala"
			self->priv->_size_compressed = self->priv->_size_compressed - _tmp46_;
#line 569 "Utility/FileItem.vala"
			_tmp47_ = _g_object_ref0 (self);
#line 569 "Utility/FileItem.vala"
			temp = _tmp47_;
#line 570 "Utility/FileItem.vala"
			while (TRUE) {
#line 2655 "FileItem.c"
				FileItem* _tmp48_;
				FileItem* _tmp49_;
				FileItem* _tmp50_;
				FileItem* _tmp51_;
				glong _tmp52_;
				FileItem* _tmp53_;
				FileItem* _tmp54_;
				FileItem* _tmp55_;
				FileItem* _tmp56_;
				FileItem* _tmp57_;
				FileItem* _tmp58_;
				FileItem* _tmp59_;
				FileItem* _tmp60_;
				FileItem* _tmp61_;
				FileItem* _tmp62_;
				FileItem* _tmp63_;
				FileItem* _tmp64_;
				FileItem* _tmp65_;
				FileItem* _tmp66_;
				FileItem* _tmp67_;
				gint64 _tmp68_;
				gint64 _tmp69_;
				FileItem* _tmp70_;
				FileItem* _tmp71_;
				FileItem* _tmp72_;
				FileItem* _tmp73_;
				FileItem* _tmp74_;
				gint64 _tmp75_;
				gint64 _tmp76_;
				FileItem* _tmp77_;
				FileItem* _tmp78_;
				FileItem* _tmp79_;
#line 570 "Utility/FileItem.vala"
				_tmp48_ = temp;
#line 570 "Utility/FileItem.vala"
				_tmp49_ = _tmp48_->parent;
#line 570 "Utility/FileItem.vala"
				if (!(_tmp49_ != NULL)) {
#line 570 "Utility/FileItem.vala"
					break;
#line 2696 "FileItem.c"
				}
#line 571 "Utility/FileItem.vala"
				_tmp50_ = temp;
#line 571 "Utility/FileItem.vala"
				_tmp51_ = _tmp50_->parent;
#line 571 "Utility/FileItem.vala"
				_tmp52_ = _tmp51_->dir_count_total;
#line 571 "Utility/FileItem.vala"
				_tmp51_->dir_count_total = _tmp52_ - 1;
#line 573 "Utility/FileItem.vala"
				_tmp53_ = temp;
#line 573 "Utility/FileItem.vala"
				_tmp54_ = _tmp53_->parent;
#line 573 "Utility/FileItem.vala"
				_tmp55_ = temp;
#line 573 "Utility/FileItem.vala"
				_tmp56_ = _tmp55_->parent;
#line 573 "Utility/FileItem.vala"
				_tmp57_ = child;
#line 573 "Utility/FileItem.vala"
				_tmp56_->file_count_total = _tmp56_->file_count_total - _tmp57_->file_count_total;
#line 574 "Utility/FileItem.vala"
				_tmp58_ = temp;
#line 574 "Utility/FileItem.vala"
				_tmp59_ = _tmp58_->parent;
#line 574 "Utility/FileItem.vala"
				_tmp60_ = temp;
#line 574 "Utility/FileItem.vala"
				_tmp61_ = _tmp60_->parent;
#line 574 "Utility/FileItem.vala"
				_tmp62_ = child;
#line 574 "Utility/FileItem.vala"
				_tmp61_->dir_count_total = _tmp61_->dir_count_total - _tmp62_->dir_count_total;
#line 575 "Utility/FileItem.vala"
				_tmp63_ = temp;
#line 575 "Utility/FileItem.vala"
				_tmp64_ = _tmp63_->parent;
#line 575 "Utility/FileItem.vala"
				_tmp65_ = temp;
#line 575 "Utility/FileItem.vala"
				_tmp66_ = _tmp65_->parent;
#line 575 "Utility/FileItem.vala"
				_tmp67_ = child;
#line 575 "Utility/FileItem.vala"
				_tmp68_ = file_item_get_size (_tmp67_);
#line 575 "Utility/FileItem.vala"
				_tmp69_ = _tmp68_;
#line 575 "Utility/FileItem.vala"
				_tmp66_->priv->_size = _tmp66_->priv->_size - _tmp69_;
#line 576 "Utility/FileItem.vala"
				_tmp70_ = temp;
#line 576 "Utility/FileItem.vala"
				_tmp71_ = _tmp70_->parent;
#line 576 "Utility/FileItem.vala"
				_tmp72_ = temp;
#line 576 "Utility/FileItem.vala"
				_tmp73_ = _tmp72_->parent;
#line 576 "Utility/FileItem.vala"
				_tmp74_ = child;
#line 576 "Utility/FileItem.vala"
				_tmp75_ = file_item_get_size_compressed (_tmp74_);
#line 576 "Utility/FileItem.vala"
				_tmp76_ = _tmp75_;
#line 576 "Utility/FileItem.vala"
				_tmp73_->priv->_size_compressed = _tmp73_->priv->_size_compressed - _tmp76_;
#line 578 "Utility/FileItem.vala"
				_tmp77_ = temp;
#line 578 "Utility/FileItem.vala"
				_tmp78_ = _tmp77_->parent;
#line 578 "Utility/FileItem.vala"
				_tmp79_ = _g_object_ref0 (_tmp78_);
#line 578 "Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 578 "Utility/FileItem.vala"
				temp = _tmp79_;
#line 2772 "FileItem.c"
			}
#line 537 "Utility/FileItem.vala"
			_g_object_unref0 (temp);
#line 2776 "FileItem.c"
		}
	}
#line 585 "Utility/FileItem.vala"
	result = child;
#line 585 "Utility/FileItem.vala"
	return result;
#line 2783 "FileItem.c"
}

FileItem*
file_item_find_descendant (FileItem* self,
                           const gchar* path)
{
	FileItem* child = NULL;
	FileItem* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	FileItem* _tmp20_;
	const gchar* _tmp21_;
	FileItem* result = NULL;
#line 588 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 588 "Utility/FileItem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 589 "Utility/FileItem.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 589 "Utility/FileItem.vala"
	child = _tmp0_;
#line 591 "Utility/FileItem.vala"
	_tmp2_ = _tmp1_ = g_strsplit (path, "/", 0);
#line 2807 "FileItem.c"
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
#line 591 "Utility/FileItem.vala"
		part_collection = _tmp2_;
#line 591 "Utility/FileItem.vala"
		part_collection_length1 = _vala_array_length (_tmp1_);
#line 591 "Utility/FileItem.vala"
		for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 2819 "FileItem.c"
			gchar* _tmp3_;
			gchar* part = NULL;
#line 591 "Utility/FileItem.vala"
			_tmp3_ = g_strdup (part_collection[part_it]);
#line 591 "Utility/FileItem.vala"
			part = _tmp3_;
#line 2826 "FileItem.c"
			{
				FileItem* _tmp4_;
				GeeHashMap* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				FileItem* _tmp13_;
				GeeHashMap* _tmp14_;
				const gchar* _tmp15_;
#line 594 "Utility/FileItem.vala"
				_tmp4_ = child;
#line 594 "Utility/FileItem.vala"
				_tmp5_ = _tmp4_->children;
#line 594 "Utility/FileItem.vala"
				_tmp6_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp5_);
#line 594 "Utility/FileItem.vala"
				_tmp7_ = _tmp6_;
#line 594 "Utility/FileItem.vala"
				if (_tmp7_ == 0) {
#line 2845 "FileItem.c"
					FileItem* _tmp8_;
					FileItem* _tmp9_;
					GeeHashMap* _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
#line 595 "Utility/FileItem.vala"
					_tmp8_ = child;
#line 595 "Utility/FileItem.vala"
					file_item_query_children (_tmp8_, 1);
#line 596 "Utility/FileItem.vala"
					_tmp9_ = child;
#line 596 "Utility/FileItem.vala"
					_tmp10_ = _tmp9_->children;
#line 596 "Utility/FileItem.vala"
					_tmp11_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp10_);
#line 596 "Utility/FileItem.vala"
					_tmp12_ = _tmp11_;
#line 596 "Utility/FileItem.vala"
					if (_tmp12_ == 0) {
#line 597 "Utility/FileItem.vala"
						_g_free0 (part);
#line 597 "Utility/FileItem.vala"
						break;
#line 2869 "FileItem.c"
					}
				}
#line 601 "Utility/FileItem.vala"
				_tmp13_ = child;
#line 601 "Utility/FileItem.vala"
				_tmp14_ = _tmp13_->children;
#line 601 "Utility/FileItem.vala"
				_tmp15_ = part;
#line 601 "Utility/FileItem.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp14_, _tmp15_)) {
#line 2880 "FileItem.c"
					FileItem* _tmp16_;
					GeeHashMap* _tmp17_;
					const gchar* _tmp18_;
					gpointer _tmp19_;
#line 602 "Utility/FileItem.vala"
					_tmp16_ = child;
#line 602 "Utility/FileItem.vala"
					_tmp17_ = _tmp16_->children;
#line 602 "Utility/FileItem.vala"
					_tmp18_ = part;
#line 602 "Utility/FileItem.vala"
					_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp17_, _tmp18_);
#line 602 "Utility/FileItem.vala"
					_g_object_unref0 (child);
#line 602 "Utility/FileItem.vala"
					child = (FileItem*) _tmp19_;
#line 2897 "FileItem.c"
				}
#line 591 "Utility/FileItem.vala"
				_g_free0 (part);
#line 2901 "FileItem.c"
			}
		}
#line 591 "Utility/FileItem.vala"
		part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2906 "FileItem.c"
	}
#line 606 "Utility/FileItem.vala"
	_tmp20_ = child;
#line 606 "Utility/FileItem.vala"
	_tmp21_ = _tmp20_->file_path;
#line 606 "Utility/FileItem.vala"
	if (g_strcmp0 (_tmp21_, path) == 0) {
#line 607 "Utility/FileItem.vala"
		result = child;
#line 607 "Utility/FileItem.vala"
		return result;
#line 2918 "FileItem.c"
	} else {
#line 610 "Utility/FileItem.vala"
		result = NULL;
#line 610 "Utility/FileItem.vala"
		_g_object_unref0 (child);
#line 610 "Utility/FileItem.vala"
		return result;
#line 2926 "FileItem.c"
	}
#line 588 "Utility/FileItem.vala"
	_g_object_unref0 (child);
#line 2930 "FileItem.c"
}

void
file_item_set_file_path_prefix (FileItem* self,
                                const gchar* prefix)
{
	gchar* _tmp0_;
#line 614 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 614 "Utility/FileItem.vala"
	g_return_if_fail (prefix != NULL);
#line 615 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (prefix);
#line 615 "Utility/FileItem.vala"
	_g_free0 (self->file_path_prefix);
#line 615 "Utility/FileItem.vala"
	self->file_path_prefix = _tmp0_;
#line 2948 "FileItem.c"
	{
		GeeIterator* _child_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 616 "Utility/FileItem.vala"
		_tmp1_ = self->children;
#line 616 "Utility/FileItem.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 616 "Utility/FileItem.vala"
		_tmp3_ = _tmp2_;
#line 616 "Utility/FileItem.vala"
		_tmp4_ = _tmp3_;
#line 616 "Utility/FileItem.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 616 "Utility/FileItem.vala"
		_tmp6_ = _tmp5_;
#line 616 "Utility/FileItem.vala"
		_g_object_unref0 (_tmp4_);
#line 616 "Utility/FileItem.vala"
		_child_it = _tmp6_;
#line 616 "Utility/FileItem.vala"
		while (TRUE) {
#line 2975 "FileItem.c"
			GeeIterator* _tmp7_;
			FileItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			FileItem* _tmp10_;
#line 616 "Utility/FileItem.vala"
			_tmp7_ = _child_it;
#line 616 "Utility/FileItem.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 616 "Utility/FileItem.vala"
				break;
#line 2987 "FileItem.c"
			}
#line 616 "Utility/FileItem.vala"
			_tmp8_ = _child_it;
#line 616 "Utility/FileItem.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 616 "Utility/FileItem.vala"
			child = (FileItem*) _tmp9_;
#line 617 "Utility/FileItem.vala"
			_tmp10_ = child;
#line 617 "Utility/FileItem.vala"
			file_item_set_file_path_prefix (_tmp10_, prefix);
#line 616 "Utility/FileItem.vala"
			_g_object_unref0 (child);
#line 3001 "FileItem.c"
		}
#line 616 "Utility/FileItem.vala"
		_g_object_unref0 (_child_it);
#line 3005 "FileItem.c"
	}
}

void
file_item_print (FileItem* self,
                 gint level)
{
	FILE* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	FILE* _tmp8_;
#line 621 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 623 "Utility/FileItem.vala"
	if (level == 0) {
#line 3024 "FileItem.c"
		FILE* _tmp0_;
		FILE* _tmp1_;
#line 624 "Utility/FileItem.vala"
		_tmp0_ = stdout;
#line 624 "Utility/FileItem.vala"
		fprintf (_tmp0_, "\n");
#line 625 "Utility/FileItem.vala"
		_tmp1_ = stdout;
#line 625 "Utility/FileItem.vala"
		fflush (_tmp1_);
#line 3035 "FileItem.c"
	}
#line 628 "Utility/FileItem.vala"
	_tmp2_ = stdout;
#line 628 "Utility/FileItem.vala"
	_tmp3_ = g_strnfill ((gsize) (level * 2), ' ');
#line 628 "Utility/FileItem.vala"
	_tmp4_ = _tmp3_;
#line 628 "Utility/FileItem.vala"
	_tmp5_ = self->file_name;
#line 628 "Utility/FileItem.vala"
	_tmp6_ = g_strdup_printf ("%s%s\n", _tmp4_, _tmp5_);
#line 628 "Utility/FileItem.vala"
	_tmp7_ = _tmp6_;
#line 628 "Utility/FileItem.vala"
	fprintf (_tmp2_, "%s", _tmp7_);
#line 628 "Utility/FileItem.vala"
	_g_free0 (_tmp7_);
#line 628 "Utility/FileItem.vala"
	_g_free0 (_tmp4_);
#line 629 "Utility/FileItem.vala"
	_tmp8_ = stdout;
#line 629 "Utility/FileItem.vala"
	fflush (_tmp8_);
#line 3059 "FileItem.c"
	{
		GeeIterator* _key_it = NULL;
		GeeHashMap* _tmp9_;
		GeeSet* _tmp10_;
		GeeSet* _tmp11_;
		GeeSet* _tmp12_;
		GeeIterator* _tmp13_;
		GeeIterator* _tmp14_;
#line 631 "Utility/FileItem.vala"
		_tmp9_ = self->children;
#line 631 "Utility/FileItem.vala"
		_tmp10_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp9_);
#line 631 "Utility/FileItem.vala"
		_tmp11_ = _tmp10_;
#line 631 "Utility/FileItem.vala"
		_tmp12_ = _tmp11_;
#line 631 "Utility/FileItem.vala"
		_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 631 "Utility/FileItem.vala"
		_tmp14_ = _tmp13_;
#line 631 "Utility/FileItem.vala"
		_g_object_unref0 (_tmp12_);
#line 631 "Utility/FileItem.vala"
		_key_it = _tmp14_;
#line 631 "Utility/FileItem.vala"
		while (TRUE) {
#line 3086 "FileItem.c"
			GeeIterator* _tmp15_;
			gchar* key = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			GeeHashMap* _tmp18_;
			const gchar* _tmp19_;
			gpointer _tmp20_;
			FileItem* _tmp21_;
#line 631 "Utility/FileItem.vala"
			_tmp15_ = _key_it;
#line 631 "Utility/FileItem.vala"
			if (!gee_iterator_next (_tmp15_)) {
#line 631 "Utility/FileItem.vala"
				break;
#line 3101 "FileItem.c"
			}
#line 631 "Utility/FileItem.vala"
			_tmp16_ = _key_it;
#line 631 "Utility/FileItem.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 631 "Utility/FileItem.vala"
			key = (gchar*) _tmp17_;
#line 632 "Utility/FileItem.vala"
			_tmp18_ = self->children;
#line 632 "Utility/FileItem.vala"
			_tmp19_ = key;
#line 632 "Utility/FileItem.vala"
			_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, _tmp19_);
#line 632 "Utility/FileItem.vala"
			_tmp21_ = (FileItem*) _tmp20_;
#line 632 "Utility/FileItem.vala"
			file_item_print (_tmp21_, level + 1);
#line 632 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp21_);
#line 631 "Utility/FileItem.vala"
			_g_free0 (key);
#line 3123 "FileItem.c"
		}
#line 631 "Utility/FileItem.vala"
		_g_object_unref0 (_key_it);
#line 3127 "FileItem.c"
	}
}

static gint
__lambda7_ (FileItem* self,
            FileItem* a,
            FileItem* b)
{
	gboolean _tmp0_ = FALSE;
	GFileType _tmp1_;
	gint result = 0;
#line 644 "Utility/FileItem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 644 "Utility/FileItem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 645 "Utility/FileItem.vala"
	_tmp1_ = a->file_type;
#line 645 "Utility/FileItem.vala"
	if (_tmp1_ == G_FILE_TYPE_DIRECTORY) {
#line 3147 "FileItem.c"
		GFileType _tmp2_;
#line 645 "Utility/FileItem.vala"
		_tmp2_ = b->file_type;
#line 645 "Utility/FileItem.vala"
		_tmp0_ = _tmp2_ != G_FILE_TYPE_DIRECTORY;
#line 3153 "FileItem.c"
	} else {
#line 645 "Utility/FileItem.vala"
		_tmp0_ = FALSE;
#line 3157 "FileItem.c"
	}
#line 645 "Utility/FileItem.vala"
	if (_tmp0_) {
#line 646 "Utility/FileItem.vala"
		result = -1;
#line 646 "Utility/FileItem.vala"
		return result;
#line 3165 "FileItem.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GFileType _tmp4_;
#line 648 "Utility/FileItem.vala"
		_tmp4_ = a->file_type;
#line 648 "Utility/FileItem.vala"
		if (_tmp4_ != G_FILE_TYPE_DIRECTORY) {
#line 3173 "FileItem.c"
			GFileType _tmp5_;
#line 648 "Utility/FileItem.vala"
			_tmp5_ = b->file_type;
#line 648 "Utility/FileItem.vala"
			_tmp3_ = _tmp5_ == G_FILE_TYPE_DIRECTORY;
#line 3179 "FileItem.c"
		} else {
#line 648 "Utility/FileItem.vala"
			_tmp3_ = FALSE;
#line 3183 "FileItem.c"
		}
#line 648 "Utility/FileItem.vala"
		if (_tmp3_) {
#line 649 "Utility/FileItem.vala"
			result = 1;
#line 649 "Utility/FileItem.vala"
			return result;
#line 3191 "FileItem.c"
		} else {
			GCompareFunc _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gint _tmp13_;
#line 652 "Utility/FileItem.vala"
			_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 652 "Utility/FileItem.vala"
			_tmp7_ = a->file_name;
#line 652 "Utility/FileItem.vala"
			_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 652 "Utility/FileItem.vala"
			_tmp9_ = _tmp8_;
#line 652 "Utility/FileItem.vala"
			_tmp10_ = b->file_name;
#line 652 "Utility/FileItem.vala"
			_tmp11_ = g_utf8_strdown (_tmp10_, (gssize) -1);
#line 652 "Utility/FileItem.vala"
			_tmp12_ = _tmp11_;
#line 652 "Utility/FileItem.vala"
			_tmp13_ = _tmp6_ (_tmp9_, _tmp12_);
#line 652 "Utility/FileItem.vala"
			_g_free0 (_tmp12_);
#line 652 "Utility/FileItem.vala"
			_g_free0 (_tmp9_);
#line 652 "Utility/FileItem.vala"
			result = _tmp13_;
#line 652 "Utility/FileItem.vala"
			return result;
#line 3225 "FileItem.c"
		}
	}
}

static gint
___lambda7__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda7_ ((FileItem*) self, (FileItem*) a, (FileItem*) b);
#line 644 "Utility/FileItem.vala"
	return result;
#line 3239 "FileItem.c"
}

GeeArrayList*
file_item_get_children_sorted (FileItem* self)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp15_;
	GeeArrayList* result = NULL;
#line 636 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 637 "Utility/FileItem.vala"
	_tmp0_ = gee_array_list_new (TYPE_FILE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 637 "Utility/FileItem.vala"
	list = _tmp0_;
#line 3255 "FileItem.c"
	{
		GeeIterator* _key_it = NULL;
		GeeHashMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 639 "Utility/FileItem.vala"
		_tmp1_ = self->children;
#line 639 "Utility/FileItem.vala"
		_tmp2_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp1_);
#line 639 "Utility/FileItem.vala"
		_tmp3_ = _tmp2_;
#line 639 "Utility/FileItem.vala"
		_tmp4_ = _tmp3_;
#line 639 "Utility/FileItem.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 639 "Utility/FileItem.vala"
		_tmp6_ = _tmp5_;
#line 639 "Utility/FileItem.vala"
		_g_object_unref0 (_tmp4_);
#line 639 "Utility/FileItem.vala"
		_key_it = _tmp6_;
#line 639 "Utility/FileItem.vala"
		while (TRUE) {
#line 3282 "FileItem.c"
			GeeIterator* _tmp7_;
			gchar* key = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			FileItem* item = NULL;
			GeeHashMap* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			GeeArrayList* _tmp13_;
			FileItem* _tmp14_;
#line 639 "Utility/FileItem.vala"
			_tmp7_ = _key_it;
#line 639 "Utility/FileItem.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 639 "Utility/FileItem.vala"
				break;
#line 3299 "FileItem.c"
			}
#line 639 "Utility/FileItem.vala"
			_tmp8_ = _key_it;
#line 639 "Utility/FileItem.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 639 "Utility/FileItem.vala"
			key = (gchar*) _tmp9_;
#line 640 "Utility/FileItem.vala"
			_tmp10_ = self->children;
#line 640 "Utility/FileItem.vala"
			_tmp11_ = key;
#line 640 "Utility/FileItem.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, _tmp11_);
#line 640 "Utility/FileItem.vala"
			item = (FileItem*) _tmp12_;
#line 641 "Utility/FileItem.vala"
			_tmp13_ = list;
#line 641 "Utility/FileItem.vala"
			_tmp14_ = item;
#line 641 "Utility/FileItem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 639 "Utility/FileItem.vala"
			_g_object_unref0 (item);
#line 639 "Utility/FileItem.vala"
			_g_free0 (key);
#line 3325 "FileItem.c"
		}
#line 639 "Utility/FileItem.vala"
		_g_object_unref0 (_key_it);
#line 3329 "FileItem.c"
	}
#line 644 "Utility/FileItem.vala"
	_tmp15_ = list;
#line 644 "Utility/FileItem.vala"
	gee_list_sort ((GeeList*) _tmp15_, ___lambda7__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 656 "Utility/FileItem.vala"
	result = list;
#line 656 "Utility/FileItem.vala"
	return result;
#line 3339 "FileItem.c"
}

GdkPixbuf*
file_item_get_icon (FileItem* self,
                    gint icon_size,
                    gboolean add_transparency,
                    gboolean add_emblems)
{
	GdkPixbuf* pixbuf = NULL;
	GIcon* _tmp0_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* result = NULL;
#line 661 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 663 "Utility/FileItem.vala"
	pixbuf = NULL;
#line 665 "Utility/FileItem.vala"
	_tmp0_ = self->icon;
#line 665 "Utility/FileItem.vala"
	if (_tmp0_ != NULL) {
#line 3360 "FileItem.c"
		GIcon* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 666 "Utility/FileItem.vala"
		_tmp1_ = self->icon;
#line 666 "Utility/FileItem.vala"
		_tmp2_ = icon_manager_lookup_gicon (_tmp1_, icon_size);
#line 666 "Utility/FileItem.vala"
		_g_object_unref0 (pixbuf);
#line 666 "Utility/FileItem.vala"
		pixbuf = _tmp2_;
#line 3371 "FileItem.c"
	}
#line 669 "Utility/FileItem.vala"
	_tmp3_ = pixbuf;
#line 669 "Utility/FileItem.vala"
	if (_tmp3_ == NULL) {
#line 3377 "FileItem.c"
		GFileType _tmp4_;
#line 670 "Utility/FileItem.vala"
		_tmp4_ = self->file_type;
#line 670 "Utility/FileItem.vala"
		if (_tmp4_ == G_FILE_TYPE_DIRECTORY) {
#line 3383 "FileItem.c"
			GdkPixbuf* _tmp5_;
#line 671 "Utility/FileItem.vala"
			_tmp5_ = icon_manager_lookup ("folder", icon_size, FALSE, FALSE, 1);
#line 671 "Utility/FileItem.vala"
			_g_object_unref0 (pixbuf);
#line 671 "Utility/FileItem.vala"
			pixbuf = _tmp5_;
#line 3391 "FileItem.c"
		} else {
			GdkPixbuf* _tmp6_;
#line 674 "Utility/FileItem.vala"
			_tmp6_ = icon_manager_lookup ("text-x-preview", icon_size, FALSE, FALSE, 1);
#line 674 "Utility/FileItem.vala"
			_g_object_unref0 (pixbuf);
#line 674 "Utility/FileItem.vala"
			pixbuf = _tmp6_;
#line 3400 "FileItem.c"
		}
	}
#line 678 "Utility/FileItem.vala"
	result = pixbuf;
#line 678 "Utility/FileItem.vala"
	return result;
#line 3407 "FileItem.c"
}

gint64
file_item_get_size (FileItem* self)
{
	gint64 result;
#line 130 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 131 "Utility/FileItem.vala"
	result = self->priv->_size;
#line 131 "Utility/FileItem.vala"
	return result;
#line 3420 "FileItem.c"
}

gint64
file_item_get_size_compressed (FileItem* self)
{
	gint64 result;
#line 136 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 137 "Utility/FileItem.vala"
	result = self->priv->_size_compressed;
#line 137 "Utility/FileItem.vala"
	return result;
#line 3433 "FileItem.c"
}

static void
file_item_class_init (FileItemClass * klass,
                      gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar** _tmp48_;
#line 37 "Utility/FileItem.vala"
	file_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "Utility/FileItem.vala"
	g_type_class_adjust_private_offset (klass, &FileItem_private_offset);
#line 37 "Utility/FileItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_file_item_get_property;
#line 37 "Utility/FileItem.vala"
	G_OBJECT_CLASS (klass)->finalize = file_item_finalize;
#line 37 "Utility/FileItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_ITEM_SIZE_PROPERTY, file_item_properties[FILE_ITEM_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "Utility/FileItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_ITEM_SIZE_COMPRESSED_PROPERTY, file_item_properties[FILE_ITEM_SIZE_COMPRESSED_PROPERTY] = g_param_spec_int64 ("size-compressed", "size-compressed", "size-compressed", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 77 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (".tar");
#line 77 "Utility/FileItem.vala"
	_tmp1_ = g_strdup (".tar.gz");
#line 77 "Utility/FileItem.vala"
	_tmp2_ = g_strdup (".tgz");
#line 77 "Utility/FileItem.vala"
	_tmp3_ = g_strdup (".tar.bzip2");
#line 77 "Utility/FileItem.vala"
	_tmp4_ = g_strdup (".tar.bz2");
#line 77 "Utility/FileItem.vala"
	_tmp5_ = g_strdup (".tbz");
#line 77 "Utility/FileItem.vala"
	_tmp6_ = g_strdup (".tbz2");
#line 77 "Utility/FileItem.vala"
	_tmp7_ = g_strdup (".tb2");
#line 77 "Utility/FileItem.vala"
	_tmp8_ = g_strdup (".tar.lzma");
#line 77 "Utility/FileItem.vala"
	_tmp9_ = g_strdup (".tar.lz");
#line 77 "Utility/FileItem.vala"
	_tmp10_ = g_strdup (".tlz");
#line 77 "Utility/FileItem.vala"
	_tmp11_ = g_strdup (".tar.xz");
#line 77 "Utility/FileItem.vala"
	_tmp12_ = g_strdup (".txz");
#line 77 "Utility/FileItem.vala"
	_tmp13_ = g_strdup (".tar.7z");
#line 77 "Utility/FileItem.vala"
	_tmp14_ = g_strdup (".tar.zip");
#line 77 "Utility/FileItem.vala"
	_tmp15_ = g_strdup (".7z");
#line 77 "Utility/FileItem.vala"
	_tmp16_ = g_strdup (".lzma");
#line 77 "Utility/FileItem.vala"
	_tmp17_ = g_strdup (".bz2");
#line 77 "Utility/FileItem.vala"
	_tmp18_ = g_strdup (".bzip2");
#line 77 "Utility/FileItem.vala"
	_tmp19_ = g_strdup (".gz");
#line 77 "Utility/FileItem.vala"
	_tmp20_ = g_strdup (".gzip");
#line 77 "Utility/FileItem.vala"
	_tmp21_ = g_strdup (".zip");
#line 77 "Utility/FileItem.vala"
	_tmp22_ = g_strdup (".rar");
#line 77 "Utility/FileItem.vala"
	_tmp23_ = g_strdup (".cab");
#line 77 "Utility/FileItem.vala"
	_tmp24_ = g_strdup (".arj");
#line 77 "Utility/FileItem.vala"
	_tmp25_ = g_strdup (".z");
#line 77 "Utility/FileItem.vala"
	_tmp26_ = g_strdup (".taz");
#line 77 "Utility/FileItem.vala"
	_tmp27_ = g_strdup (".cpio");
#line 77 "Utility/FileItem.vala"
	_tmp28_ = g_strdup (".rpm");
#line 77 "Utility/FileItem.vala"
	_tmp29_ = g_strdup (".deb");
#line 77 "Utility/FileItem.vala"
	_tmp30_ = g_strdup (".lzh");
#line 77 "Utility/FileItem.vala"
	_tmp31_ = g_strdup (".lha");
#line 77 "Utility/FileItem.vala"
	_tmp32_ = g_strdup (".chm");
#line 77 "Utility/FileItem.vala"
	_tmp33_ = g_strdup (".chw");
#line 77 "Utility/FileItem.vala"
	_tmp34_ = g_strdup (".hxs");
#line 77 "Utility/FileItem.vala"
	_tmp35_ = g_strdup (".iso");
#line 77 "Utility/FileItem.vala"
	_tmp36_ = g_strdup (".dmg");
#line 77 "Utility/FileItem.vala"
	_tmp37_ = g_strdup (".xar");
#line 77 "Utility/FileItem.vala"
	_tmp38_ = g_strdup (".hfs");
#line 77 "Utility/FileItem.vala"
	_tmp39_ = g_strdup (".ntfs");
#line 77 "Utility/FileItem.vala"
	_tmp40_ = g_strdup (".fat");
#line 77 "Utility/FileItem.vala"
	_tmp41_ = g_strdup (".vhd");
#line 77 "Utility/FileItem.vala"
	_tmp42_ = g_strdup (".mbr");
#line 77 "Utility/FileItem.vala"
	_tmp43_ = g_strdup (".wim");
#line 77 "Utility/FileItem.vala"
	_tmp44_ = g_strdup (".swm");
#line 77 "Utility/FileItem.vala"
	_tmp45_ = g_strdup (".squashfs");
#line 77 "Utility/FileItem.vala"
	_tmp46_ = g_strdup (".cramfs");
#line 77 "Utility/FileItem.vala"
	_tmp47_ = g_strdup (".scap");
#line 77 "Utility/FileItem.vala"
	_tmp48_ = g_new0 (gchar*, 48 + 1);
#line 77 "Utility/FileItem.vala"
	_tmp48_[0] = _tmp0_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[1] = _tmp1_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[2] = _tmp2_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[3] = _tmp3_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[4] = _tmp4_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[5] = _tmp5_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[6] = _tmp6_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[7] = _tmp7_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[8] = _tmp8_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[9] = _tmp9_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[10] = _tmp10_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[11] = _tmp11_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[12] = _tmp12_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[13] = _tmp13_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[14] = _tmp14_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[15] = _tmp15_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[16] = _tmp16_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[17] = _tmp17_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[18] = _tmp18_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[19] = _tmp19_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[20] = _tmp20_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[21] = _tmp21_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[22] = _tmp22_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[23] = _tmp23_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[24] = _tmp24_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[25] = _tmp25_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[26] = _tmp26_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[27] = _tmp27_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[28] = _tmp28_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[29] = _tmp29_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[30] = _tmp30_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[31] = _tmp31_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[32] = _tmp32_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[33] = _tmp33_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[34] = _tmp34_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[35] = _tmp35_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[36] = _tmp36_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[37] = _tmp37_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[38] = _tmp38_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[39] = _tmp39_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[40] = _tmp40_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[41] = _tmp41_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[42] = _tmp42_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[43] = _tmp43_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[44] = _tmp44_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[45] = _tmp45_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[46] = _tmp46_;
#line 77 "Utility/FileItem.vala"
	_tmp48_[47] = _tmp47_;
#line 77 "Utility/FileItem.vala"
	file_item_archive_extensions = _tmp48_;
#line 77 "Utility/FileItem.vala"
	file_item_archive_extensions_length1 = 48;
#line 3699 "FileItem.c"
}

static void
file_item_gee_comparable_interface_init (GeeComparableIface * iface,
                                         gpointer iface_data)
{
#line 37 "Utility/FileItem.vala"
	file_item_gee_comparable_parent_iface = g_type_interface_peek_parent (iface);
#line 37 "Utility/FileItem.vala"
	iface->compare_to = (gint (*) (GeeComparable*, gconstpointer)) file_item_real_compare_to;
#line 3710 "FileItem.c"
}

static void
file_item_instance_init (FileItem * self,
                         gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GeeHashMap* _tmp10_;
#line 37 "Utility/FileItem.vala"
	self->priv = file_item_get_instance_private (self);
#line 39 "Utility/FileItem.vala"
	_tmp0_ = g_strdup ("");
#line 39 "Utility/FileItem.vala"
	self->file_name = _tmp0_;
#line 40 "Utility/FileItem.vala"
	_tmp1_ = g_strdup ("");
#line 40 "Utility/FileItem.vala"
	self->file_location = _tmp1_;
#line 41 "Utility/FileItem.vala"
	_tmp2_ = g_strdup ("");
#line 41 "Utility/FileItem.vala"
	self->file_path = _tmp2_;
#line 42 "Utility/FileItem.vala"
	_tmp3_ = g_strdup ("");
#line 42 "Utility/FileItem.vala"
	self->file_path_prefix = _tmp3_;
#line 43 "Utility/FileItem.vala"
	self->file_type = G_FILE_TYPE_REGULAR;
#line 45 "Utility/FileItem.vala"
	_tmp4_ = g_strdup ("");
#line 45 "Utility/FileItem.vala"
	self->permissions = _tmp4_;
#line 46 "Utility/FileItem.vala"
	_tmp5_ = g_strdup ("");
#line 46 "Utility/FileItem.vala"
	self->owner_user = _tmp5_;
#line 47 "Utility/FileItem.vala"
	_tmp6_ = g_strdup ("");
#line 47 "Utility/FileItem.vala"
	self->owner_group = _tmp6_;
#line 48 "Utility/FileItem.vala"
	_tmp7_ = g_strdup ("");
#line 48 "Utility/FileItem.vala"
	self->content_type = _tmp7_;
#line 49 "Utility/FileItem.vala"
	_tmp8_ = g_strdup ("");
#line 49 "Utility/FileItem.vala"
	self->file_status = _tmp8_;
#line 51 "Utility/FileItem.vala"
	self->is_selected = FALSE;
#line 52 "Utility/FileItem.vala"
	self->is_symlink = FALSE;
#line 53 "Utility/FileItem.vala"
	_tmp9_ = g_strdup ("");
#line 53 "Utility/FileItem.vala"
	self->symlink_target = _tmp9_;
#line 54 "Utility/FileItem.vala"
	self->is_archive = FALSE;
#line 55 "Utility/FileItem.vala"
	self->is_stale = FALSE;
#line 58 "Utility/FileItem.vala"
	_tmp10_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_FILE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "Utility/FileItem.vala"
	self->children = _tmp10_;
#line 64 "Utility/FileItem.vala"
	self->file_count = (glong) 0;
#line 65 "Utility/FileItem.vala"
	self->dir_count = (glong) 0;
#line 66 "Utility/FileItem.vala"
	self->priv->_size = (gint64) 0;
#line 67 "Utility/FileItem.vala"
	self->priv->_size_compressed = (gint64) 0;
#line 69 "Utility/FileItem.vala"
	self->file_count_total = (glong) 0;
#line 70 "Utility/FileItem.vala"
	self->dir_count_total = (glong) 0;
#line 75 "Utility/FileItem.vala"
	self->is_dummy = FALSE;
#line 3798 "FileItem.c"
}

static void
file_item_finalize (GObject * obj)
{
	FileItem * self;
#line 37 "Utility/FileItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_ITEM, FileItem);
#line 39 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 40 "Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 41 "Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 42 "Utility/FileItem.vala"
	_g_free0 (self->file_path_prefix);
#line 44 "Utility/FileItem.vala"
	_g_date_time_unref0 (self->modified);
#line 45 "Utility/FileItem.vala"
	_g_free0 (self->permissions);
#line 46 "Utility/FileItem.vala"
	_g_free0 (self->owner_user);
#line 47 "Utility/FileItem.vala"
	_g_free0 (self->owner_group);
#line 48 "Utility/FileItem.vala"
	_g_free0 (self->content_type);
#line 49 "Utility/FileItem.vala"
	_g_free0 (self->file_status);
#line 53 "Utility/FileItem.vala"
	_g_free0 (self->symlink_target);
#line 57 "Utility/FileItem.vala"
	_g_object_unref0 (self->parent);
#line 58 "Utility/FileItem.vala"
	_g_object_unref0 (self->children);
#line 59 "Utility/FileItem.vala"
	_g_object_unref0 (self->source_archive);
#line 61 "Utility/FileItem.vala"
	_g_object_unref0 (self->tag);
#line 73 "Utility/FileItem.vala"
	_g_object_unref0 (self->icon);
#line 37 "Utility/FileItem.vala"
	G_OBJECT_CLASS (file_item_parent_class)->finalize (obj);
#line 3841 "FileItem.c"
}

static GType
file_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileItem), 0, (GInstanceInitFunc) file_item_instance_init, NULL };
	static const GInterfaceInfo gee_comparable_info = { (GInterfaceInitFunc) file_item_gee_comparable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType file_item_type_id;
	file_item_type_id = g_type_register_static (G_TYPE_OBJECT, "FileItem", &g_define_type_info, 0);
	g_type_add_interface_static (file_item_type_id, GEE_TYPE_COMPARABLE, &gee_comparable_info);
	FileItem_private_offset = g_type_add_instance_private (file_item_type_id, sizeof (FileItemPrivate));
	return file_item_type_id;
}

GType
file_item_get_type (void)
{
	static volatile gsize file_item_type_id__volatile = 0;
	if (g_once_init_enter (&file_item_type_id__volatile)) {
		GType file_item_type_id;
		file_item_type_id = file_item_get_type_once ();
		g_once_init_leave (&file_item_type_id__volatile, file_item_type_id);
	}
	return file_item_type_id__volatile;
}

static void
_vala_file_item_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	FileItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_ITEM, FileItem);
#line 37 "Utility/FileItem.vala"
	switch (property_id) {
#line 37 "Utility/FileItem.vala"
		case FILE_ITEM_SIZE_PROPERTY:
#line 37 "Utility/FileItem.vala"
		g_value_set_int64 (value, file_item_get_size (self));
#line 37 "Utility/FileItem.vala"
		break;
#line 37 "Utility/FileItem.vala"
		case FILE_ITEM_SIZE_COMPRESSED_PROPERTY:
#line 37 "Utility/FileItem.vala"
		g_value_set_int64 (value, file_item_get_size_compressed (self));
#line 37 "Utility/FileItem.vala"
		break;
#line 3890 "FileItem.c"
		default:
#line 37 "Utility/FileItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "Utility/FileItem.vala"
		break;
#line 3896 "FileItem.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

