/* IconManager.c generated by valac 0.48.8, the Vala compiler
 * generated from IconManager.vala, do not modify */

/*
 * IconManager.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define TYPE_ICON_MANAGER (icon_manager_get_type ())
#define ICON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_MANAGER, IconManager))
#define ICON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_MANAGER, IconManagerClass))
#define IS_ICON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_MANAGER))
#define IS_ICON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_MANAGER))
#define ICON_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_MANAGER, IconManagerClass))

typedef struct _IconManager IconManager;
typedef struct _IconManagerClass IconManagerClass;
typedef struct _IconManagerPrivate IconManagerPrivate;
enum  {
	ICON_MANAGER_0_PROPERTY,
	ICON_MANAGER_NUM_PROPERTIES
};
static GParamSpec* icon_manager_properties[ICON_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _IconManager {
	GObject parent_instance;
	IconManagerPrivate * priv;
};

struct _IconManagerClass {
	GObjectClass parent_class;
};

static gpointer icon_manager_parent_class = NULL;
extern GtkIconTheme* icon_manager_theme;
GtkIconTheme* icon_manager_theme = NULL;
extern GeeArrayList* icon_manager_search_paths;
GeeArrayList* icon_manager_search_paths = NULL;
extern gboolean GTK_INITIALIZED;

GType icon_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconManager, g_object_unref)
#define ICON_MANAGER_SHIELD_ICON_SIZE 64
#define ICON_MANAGER_GENERIC_ICON_IMAGE "image-x-generic"
#define ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING "image-missing"
#define ICON_MANAGER_GENERIC_ICON_VIDEO "video-x-generic"
#define ICON_MANAGER_GENERIC_ICON_FILE "text-x-preview"
#define ICON_MANAGER_GENERIC_ICON_ARCHIVE_FILE "package-x-generic"
#define ICON_MANAGER_GENERIC_ICON_DIRECTORY "folder"
#define ICON_MANAGER_GENERIC_ICON_ISO "media-cdrom"
#define ICON_MANAGER_GENERIC_ICON_PDF "application-pdf"
#define ICON_MANAGER_ICON_HARDDRIVE "drive-harddisk"
#define ICON_MANAGER_SHIELD_LIVE "media-optical"
#define ICON_MANAGER_SHIELD_LOW "timeshift-shield-low"
#define ICON_MANAGER_SHIELD_MED "timeshift-shield-med"
#define ICON_MANAGER_SHIELD_HIGH "timeshift-shield-high"
void icon_manager_init (gchar** args,
                        gint args_length1,
                        const gchar* app_name);
void tee_jee_logging_log_debug (const gchar* message);
gchar* tee_jee_file_system_file_resolve_executable_path (const gchar* file_path);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
void icon_manager_refresh_icon_theme (void);
GdkPixbuf* icon_manager_lookup (const gchar* icon_name,
                                gint icon_size,
                                gboolean symbolic,
                                gboolean use_hardcoded,
                                gint scale);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
GdkPixbuf* icon_manager_load_pixbuf_from_file (const gchar* file_path,
                                               gint icon_size);
GtkImage* icon_manager_lookup_image (const gchar* icon_name,
                                     gint icon_size,
                                     gboolean symbolic,
                                     gboolean use_hardcoded);
cairo_surface_t* icon_manager_lookup_surface (const gchar* icon_name,
                                              gint icon_size,
                                              gint scale,
                                              gboolean symbolic,
                                              gboolean use_hardcoded);
GdkPixbuf* icon_manager_lookup_gicon (GIcon* gicon,
                                      gint icon_size);
GtkImage* icon_manager_lookup_animation (const gchar* gif_name);
GdkPixbuf* icon_manager_add_emblem (GdkPixbuf* pixbuf,
                                    const gchar* icon_name,
                                    gint emblem_size,
                                    gboolean emblem_symbolic,
                                    GtkCornerType corner_type);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
GdkPixbuf* icon_manager_add_overlay (GdkPixbuf* pixbuf_base,
                                     GdkPixbuf* pixbuf_overlay);
GdkPixbuf* icon_manager_resize_icon (GdkPixbuf* pixbuf_image,
                                     gint icon_size);
GdkPixbuf* icon_manager_add_transparency (GdkPixbuf* pixbuf,
                                          gint opacity);
IconManager* icon_manager_new (void);
IconManager* icon_manager_construct (GType object_type);
static void icon_manager_finalize (GObject * obj);
static GType icon_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

void
icon_manager_init (gchar** args,
                   gint args_length1,
                   const gchar* app_name)
{
	GeeArrayList* _tmp0_;
	gchar* binpath = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* path = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* base_path = NULL;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
#line 61 "Utility/IconManager.vala"
	g_return_if_fail (app_name != NULL);
#line 63 "Utility/IconManager.vala"
	tee_jee_logging_log_debug ("IconManager: init()");
#line 65 "Utility/IconManager.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 65 "Utility/IconManager.vala"
	_g_object_unref0 (icon_manager_search_paths);
#line 65 "Utility/IconManager.vala"
	icon_manager_search_paths = _tmp0_;
#line 67 "Utility/IconManager.vala"
	_tmp1_ = args[0];
#line 67 "Utility/IconManager.vala"
	_tmp2_ = tee_jee_file_system_file_resolve_executable_path (_tmp1_);
#line 67 "Utility/IconManager.vala"
	binpath = _tmp2_;
#line 68 "Utility/IconManager.vala"
	_tmp3_ = binpath;
#line 68 "Utility/IconManager.vala"
	_tmp4_ = g_strdup_printf ("bin_path: %s", _tmp3_);
#line 68 "Utility/IconManager.vala"
	_tmp5_ = _tmp4_;
#line 68 "Utility/IconManager.vala"
	tee_jee_logging_log_debug (_tmp5_);
#line 68 "Utility/IconManager.vala"
	_g_free0 (_tmp5_);
#line 71 "Utility/IconManager.vala"
	_tmp6_ = g_strdup_printf ("/usr/share/%s/images", app_name);
#line 71 "Utility/IconManager.vala"
	path = _tmp6_;
#line 72 "Utility/IconManager.vala"
	_tmp7_ = path;
#line 72 "Utility/IconManager.vala"
	if (tee_jee_file_system_dir_exists (_tmp7_)) {
#line 206 "IconManager.c"
		GeeArrayList* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 73 "Utility/IconManager.vala"
		_tmp8_ = icon_manager_search_paths;
#line 73 "Utility/IconManager.vala"
		_tmp9_ = path;
#line 73 "Utility/IconManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 74 "Utility/IconManager.vala"
		_tmp10_ = path;
#line 74 "Utility/IconManager.vala"
		_tmp11_ = g_strdup_printf ("found images directory: %s", _tmp10_);
#line 74 "Utility/IconManager.vala"
		_tmp12_ = _tmp11_;
#line 74 "Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp12_);
#line 74 "Utility/IconManager.vala"
		_g_free0 (_tmp12_);
#line 228 "IconManager.c"
	}
#line 78 "Utility/IconManager.vala"
	_tmp13_ = binpath;
#line 78 "Utility/IconManager.vala"
	_tmp14_ = tee_jee_file_system_file_parent (_tmp13_);
#line 78 "Utility/IconManager.vala"
	_tmp15_ = _tmp14_;
#line 78 "Utility/IconManager.vala"
	_tmp16_ = tee_jee_file_system_file_parent (_tmp15_);
#line 78 "Utility/IconManager.vala"
	_tmp17_ = _tmp16_;
#line 78 "Utility/IconManager.vala"
	_tmp18_ = tee_jee_file_system_file_parent (_tmp17_);
#line 78 "Utility/IconManager.vala"
	_tmp19_ = _tmp18_;
#line 78 "Utility/IconManager.vala"
	_g_free0 (_tmp17_);
#line 78 "Utility/IconManager.vala"
	_g_free0 (_tmp15_);
#line 78 "Utility/IconManager.vala"
	base_path = _tmp19_;
#line 79 "Utility/IconManager.vala"
	_tmp20_ = base_path;
#line 79 "Utility/IconManager.vala"
	if (g_strcmp0 (_tmp20_, "/") != 0) {
#line 254 "IconManager.c"
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
#line 80 "Utility/IconManager.vala"
		_tmp21_ = base_path;
#line 80 "Utility/IconManager.vala"
		_tmp22_ = g_strdup_printf ("base_path: %s", _tmp21_);
#line 80 "Utility/IconManager.vala"
		_tmp23_ = _tmp22_;
#line 80 "Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp23_);
#line 80 "Utility/IconManager.vala"
		_g_free0 (_tmp23_);
#line 81 "Utility/IconManager.vala"
		_tmp24_ = base_path;
#line 81 "Utility/IconManager.vala"
		_tmp25_ = path;
#line 81 "Utility/IconManager.vala"
		_tmp26_ = tee_jee_file_system_path_combine (_tmp24_, _tmp25_);
#line 81 "Utility/IconManager.vala"
		_g_free0 (path);
#line 81 "Utility/IconManager.vala"
		path = _tmp26_;
#line 82 "Utility/IconManager.vala"
		_tmp27_ = path;
#line 82 "Utility/IconManager.vala"
		if (tee_jee_file_system_dir_exists (_tmp27_)) {
#line 286 "IconManager.c"
			GeeArrayList* _tmp28_;
			const gchar* _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 83 "Utility/IconManager.vala"
			_tmp28_ = icon_manager_search_paths;
#line 83 "Utility/IconManager.vala"
			_tmp29_ = path;
#line 83 "Utility/IconManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 84 "Utility/IconManager.vala"
			_tmp30_ = path;
#line 84 "Utility/IconManager.vala"
			_tmp31_ = g_strdup_printf ("found images directory: %s", _tmp30_);
#line 84 "Utility/IconManager.vala"
			_tmp32_ = _tmp31_;
#line 84 "Utility/IconManager.vala"
			tee_jee_logging_log_debug (_tmp32_);
#line 84 "Utility/IconManager.vala"
			_g_free0 (_tmp32_);
#line 308 "IconManager.c"
		}
	}
#line 88 "Utility/IconManager.vala"
	icon_manager_refresh_icon_theme ();
#line 61 "Utility/IconManager.vala"
	_g_free0 (base_path);
#line 61 "Utility/IconManager.vala"
	_g_free0 (path);
#line 61 "Utility/IconManager.vala"
	_g_free0 (binpath);
#line 319 "IconManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 95 "Utility/IconManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 327 "IconManager.c"
}

void
icon_manager_refresh_icon_theme (void)
{
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
#line 93 "Utility/IconManager.vala"
	if (!GTK_INITIALIZED) {
#line 93 "Utility/IconManager.vala"
		return;
#line 339 "IconManager.c"
	}
#line 95 "Utility/IconManager.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 95 "Utility/IconManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 95 "Utility/IconManager.vala"
	_g_object_unref0 (icon_manager_theme);
#line 95 "Utility/IconManager.vala"
	icon_manager_theme = _tmp1_;
#line 349 "IconManager.c"
	{
		GeeArrayList* _path_list = NULL;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _path_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _path_index = 0;
#line 96 "Utility/IconManager.vala"
		_tmp2_ = icon_manager_search_paths;
#line 96 "Utility/IconManager.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 96 "Utility/IconManager.vala"
		_path_list = _tmp3_;
#line 96 "Utility/IconManager.vala"
		_tmp4_ = _path_list;
#line 96 "Utility/IconManager.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 96 "Utility/IconManager.vala"
		_tmp6_ = _tmp5_;
#line 96 "Utility/IconManager.vala"
		_path_size = _tmp6_;
#line 96 "Utility/IconManager.vala"
		_path_index = -1;
#line 96 "Utility/IconManager.vala"
		while (TRUE) {
#line 377 "IconManager.c"
			gchar* path = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			GtkIconTheme* _tmp9_;
			const gchar* _tmp10_;
#line 96 "Utility/IconManager.vala"
			_path_index = _path_index + 1;
#line 96 "Utility/IconManager.vala"
			if (!(_path_index < _path_size)) {
#line 96 "Utility/IconManager.vala"
				break;
#line 389 "IconManager.c"
			}
#line 96 "Utility/IconManager.vala"
			_tmp7_ = _path_list;
#line 96 "Utility/IconManager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _path_index);
#line 96 "Utility/IconManager.vala"
			path = (gchar*) _tmp8_;
#line 97 "Utility/IconManager.vala"
			_tmp9_ = icon_manager_theme;
#line 97 "Utility/IconManager.vala"
			_tmp10_ = path;
#line 97 "Utility/IconManager.vala"
			gtk_icon_theme_append_search_path (_tmp9_, _tmp10_);
#line 96 "Utility/IconManager.vala"
			_g_free0 (path);
#line 405 "IconManager.c"
		}
#line 96 "Utility/IconManager.vala"
		_g_object_unref0 (_path_list);
#line 409 "IconManager.c"
	}
}

GdkPixbuf*
icon_manager_lookup (const gchar* icon_name,
                     gint icon_size,
                     gboolean symbolic,
                     gboolean use_hardcoded,
                     gint scale)
{
	GdkPixbuf* pixbuf = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 101 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 103 "Utility/IconManager.vala"
	pixbuf = NULL;
#line 105 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 105 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 105 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 105 "Utility/IconManager.vala"
		result = NULL;
#line 105 "Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 105 "Utility/IconManager.vala"
		return result;
#line 441 "IconManager.c"
	}
#line 107 "Utility/IconManager.vala"
	if (!use_hardcoded) {
#line 445 "IconManager.c"
		{
			GdkPixbuf* _tmp2_ = NULL;
			GtkIconTheme* _tmp3_;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 109 "Utility/IconManager.vala"
			_tmp3_ = icon_manager_theme;
#line 109 "Utility/IconManager.vala"
			_tmp4_ = gtk_icon_theme_load_icon_for_scale (_tmp3_, icon_name, icon_size, scale, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error0_);
#line 109 "Utility/IconManager.vala"
			_tmp2_ = _tmp4_;
#line 109 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 460 "IconManager.c"
				goto __catch0_g_error;
			}
#line 109 "Utility/IconManager.vala"
			_tmp5_ = _tmp2_;
#line 109 "Utility/IconManager.vala"
			_tmp2_ = NULL;
#line 109 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 109 "Utility/IconManager.vala"
			pixbuf = _tmp5_;
#line 110 "Utility/IconManager.vala"
			_tmp6_ = pixbuf;
#line 110 "Utility/IconManager.vala"
			if (_tmp6_ != NULL) {
#line 110 "Utility/IconManager.vala"
				result = pixbuf;
#line 110 "Utility/IconManager.vala"
				_g_object_unref0 (_tmp2_);
#line 110 "Utility/IconManager.vala"
				return result;
#line 481 "IconManager.c"
			}
#line 108 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp2_);
#line 485 "IconManager.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 108 "Utility/IconManager.vala"
			e = _inner_error0_;
#line 108 "Utility/IconManager.vala"
			_inner_error0_ = NULL;
#line 113 "Utility/IconManager.vala"
			_tmp7_ = e;
#line 113 "Utility/IconManager.vala"
			_tmp8_ = _tmp7_->message;
#line 113 "Utility/IconManager.vala"
			tee_jee_logging_log_debug (_tmp8_);
#line 108 "Utility/IconManager.vala"
			_g_error_free0 (e);
#line 505 "IconManager.c"
		}
		__finally0:
#line 108 "Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 108 "Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 108 "Utility/IconManager.vala"
			return NULL;
#line 518 "IconManager.c"
		}
	}
	{
		GeeArrayList* _search_path_list = NULL;
		GeeArrayList* _tmp9_;
		GeeArrayList* _tmp10_;
		gint _search_path_size = 0;
		GeeArrayList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _search_path_index = 0;
#line 117 "Utility/IconManager.vala"
		_tmp9_ = icon_manager_search_paths;
#line 117 "Utility/IconManager.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 117 "Utility/IconManager.vala"
		_search_path_list = _tmp10_;
#line 117 "Utility/IconManager.vala"
		_tmp11_ = _search_path_list;
#line 117 "Utility/IconManager.vala"
		_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 117 "Utility/IconManager.vala"
		_tmp13_ = _tmp12_;
#line 117 "Utility/IconManager.vala"
		_search_path_size = _tmp13_;
#line 117 "Utility/IconManager.vala"
		_search_path_index = -1;
#line 117 "Utility/IconManager.vala"
		while (TRUE) {
#line 548 "IconManager.c"
			gchar* search_path = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar** _tmp20_;
#line 117 "Utility/IconManager.vala"
			_search_path_index = _search_path_index + 1;
#line 117 "Utility/IconManager.vala"
			if (!(_search_path_index < _search_path_size)) {
#line 117 "Utility/IconManager.vala"
				break;
#line 563 "IconManager.c"
			}
#line 117 "Utility/IconManager.vala"
			_tmp14_ = _search_path_list;
#line 117 "Utility/IconManager.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _search_path_index);
#line 117 "Utility/IconManager.vala"
			search_path = (gchar*) _tmp15_;
#line 119 "Utility/IconManager.vala"
			_tmp16_ = g_strdup (".svg");
#line 119 "Utility/IconManager.vala"
			_tmp17_ = g_strdup (".png");
#line 119 "Utility/IconManager.vala"
			_tmp18_ = g_strdup (".jpg");
#line 119 "Utility/IconManager.vala"
			_tmp19_ = g_strdup (".gif");
#line 119 "Utility/IconManager.vala"
			_tmp20_ = g_new0 (gchar*, 4 + 1);
#line 119 "Utility/IconManager.vala"
			_tmp20_[0] = _tmp16_;
#line 119 "Utility/IconManager.vala"
			_tmp20_[1] = _tmp17_;
#line 119 "Utility/IconManager.vala"
			_tmp20_[2] = _tmp18_;
#line 119 "Utility/IconManager.vala"
			_tmp20_[3] = _tmp19_;
#line 589 "IconManager.c"
			{
				gchar** ext_collection = NULL;
				gint ext_collection_length1 = 0;
				gint _ext_collection_size_ = 0;
				gint ext_it = 0;
#line 119 "Utility/IconManager.vala"
				ext_collection = _tmp20_;
#line 119 "Utility/IconManager.vala"
				ext_collection_length1 = 4;
#line 119 "Utility/IconManager.vala"
				for (ext_it = 0; ext_it < ext_collection_length1; ext_it = ext_it + 1) {
#line 601 "IconManager.c"
					gchar* _tmp21_;
					gchar* ext = NULL;
#line 119 "Utility/IconManager.vala"
					_tmp21_ = g_strdup (ext_collection[ext_it]);
#line 119 "Utility/IconManager.vala"
					ext = _tmp21_;
#line 608 "IconManager.c"
					{
						gchar* img_file = NULL;
						const gchar* _tmp22_;
						const gchar* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						const gchar* _tmp28_;
#line 121 "Utility/IconManager.vala"
						_tmp22_ = search_path;
#line 121 "Utility/IconManager.vala"
						_tmp23_ = ext;
#line 121 "Utility/IconManager.vala"
						_tmp24_ = g_strconcat (icon_name, _tmp23_, NULL);
#line 121 "Utility/IconManager.vala"
						_tmp25_ = _tmp24_;
#line 121 "Utility/IconManager.vala"
						_tmp26_ = tee_jee_file_system_path_combine (_tmp22_, _tmp25_);
#line 121 "Utility/IconManager.vala"
						_tmp27_ = _tmp26_;
#line 121 "Utility/IconManager.vala"
						_g_free0 (_tmp25_);
#line 121 "Utility/IconManager.vala"
						img_file = _tmp27_;
#line 123 "Utility/IconManager.vala"
						_tmp28_ = img_file;
#line 123 "Utility/IconManager.vala"
						if (tee_jee_file_system_file_exists (_tmp28_)) {
#line 638 "IconManager.c"
							const gchar* _tmp29_;
							GdkPixbuf* _tmp30_;
							GdkPixbuf* _tmp31_;
#line 125 "Utility/IconManager.vala"
							_tmp29_ = img_file;
#line 125 "Utility/IconManager.vala"
							_tmp30_ = icon_manager_load_pixbuf_from_file (_tmp29_, icon_size);
#line 125 "Utility/IconManager.vala"
							_g_object_unref0 (pixbuf);
#line 125 "Utility/IconManager.vala"
							pixbuf = _tmp30_;
#line 126 "Utility/IconManager.vala"
							_tmp31_ = pixbuf;
#line 126 "Utility/IconManager.vala"
							if (_tmp31_ != NULL) {
#line 126 "Utility/IconManager.vala"
								result = pixbuf;
#line 126 "Utility/IconManager.vala"
								_g_free0 (img_file);
#line 126 "Utility/IconManager.vala"
								_g_free0 (ext);
#line 126 "Utility/IconManager.vala"
								ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 126 "Utility/IconManager.vala"
								_g_free0 (search_path);
#line 126 "Utility/IconManager.vala"
								_g_object_unref0 (_search_path_list);
#line 126 "Utility/IconManager.vala"
								return result;
#line 668 "IconManager.c"
							}
						}
#line 119 "Utility/IconManager.vala"
						_g_free0 (img_file);
#line 119 "Utility/IconManager.vala"
						_g_free0 (ext);
#line 675 "IconManager.c"
					}
				}
#line 119 "Utility/IconManager.vala"
				ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 680 "IconManager.c"
			}
#line 117 "Utility/IconManager.vala"
			_g_free0 (search_path);
#line 684 "IconManager.c"
		}
#line 117 "Utility/IconManager.vala"
		_g_object_unref0 (_search_path_list);
#line 688 "IconManager.c"
	}
#line 131 "Utility/IconManager.vala"
	result = pixbuf;
#line 131 "Utility/IconManager.vala"
	return result;
#line 694 "IconManager.c"
}

GtkImage*
icon_manager_lookup_image (const gchar* icon_name,
                           gint icon_size,
                           gboolean symbolic,
                           gboolean use_hardcoded)
{
	gint _tmp0_;
	gint _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	GdkPixbuf* pix = NULL;
	GtkImage* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	cairo_surface_t* surf = NULL;
	GdkPixbuf* _tmp12_;
	GtkImage* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	cairo_surface_t* _tmp16_;
	GtkImage* _tmp17_;
	cairo_surface_t* _tmp18_;
	GtkImage* result = NULL;
#line 134 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 136 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 136 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 136 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 136 "Utility/IconManager.vala"
		result = NULL;
#line 136 "Utility/IconManager.vala"
		return result;
#line 734 "IconManager.c"
	}
#line 138 "Utility/IconManager.vala"
	_tmp2_ = (GtkImage*) gtk_image_new ();
#line 138 "Utility/IconManager.vala"
	g_object_ref_sink (_tmp2_);
#line 138 "Utility/IconManager.vala"
	image = _tmp2_;
#line 140 "Utility/IconManager.vala"
	_tmp3_ = image;
#line 140 "Utility/IconManager.vala"
	_tmp4_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp3_);
#line 140 "Utility/IconManager.vala"
	_tmp5_ = _tmp4_;
#line 140 "Utility/IconManager.vala"
	_tmp6_ = icon_manager_lookup (icon_name, icon_size, symbolic, use_hardcoded, _tmp5_);
#line 140 "Utility/IconManager.vala"
	pix = _tmp6_;
#line 142 "Utility/IconManager.vala"
	_tmp7_ = pix;
#line 142 "Utility/IconManager.vala"
	if (_tmp7_ == NULL) {
#line 756 "IconManager.c"
		GtkImage* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		GdkPixbuf* _tmp11_;
#line 143 "Utility/IconManager.vala"
		_tmp8_ = image;
#line 143 "Utility/IconManager.vala"
		_tmp9_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp8_);
#line 143 "Utility/IconManager.vala"
		_tmp10_ = _tmp9_;
#line 143 "Utility/IconManager.vala"
		_tmp11_ = icon_manager_lookup (ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING, icon_size, symbolic, use_hardcoded, _tmp10_);
#line 143 "Utility/IconManager.vala"
		_g_object_unref0 (pix);
#line 143 "Utility/IconManager.vala"
		pix = _tmp11_;
#line 773 "IconManager.c"
	}
#line 146 "Utility/IconManager.vala"
	_tmp12_ = pix;
#line 146 "Utility/IconManager.vala"
	_tmp13_ = image;
#line 146 "Utility/IconManager.vala"
	_tmp14_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp13_);
#line 146 "Utility/IconManager.vala"
	_tmp15_ = _tmp14_;
#line 146 "Utility/IconManager.vala"
	_tmp16_ = gdk_cairo_surface_create_from_pixbuf (_tmp12_, _tmp15_, NULL);
#line 146 "Utility/IconManager.vala"
	surf = _tmp16_;
#line 148 "Utility/IconManager.vala"
	_tmp17_ = image;
#line 148 "Utility/IconManager.vala"
	_tmp18_ = surf;
#line 148 "Utility/IconManager.vala"
	gtk_image_set_from_surface (_tmp17_, _tmp18_);
#line 150 "Utility/IconManager.vala"
	result = image;
#line 150 "Utility/IconManager.vala"
	_cairo_surface_destroy0 (surf);
#line 150 "Utility/IconManager.vala"
	_g_object_unref0 (pix);
#line 150 "Utility/IconManager.vala"
	return result;
#line 801 "IconManager.c"
}

cairo_surface_t*
icon_manager_lookup_surface (const gchar* icon_name,
                             gint icon_size,
                             gint scale,
                             gboolean symbolic,
                             gboolean use_hardcoded)
{
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* pix = NULL;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp5_;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* result = NULL;
#line 153 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 154 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 154 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 154 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 154 "Utility/IconManager.vala"
		result = NULL;
#line 154 "Utility/IconManager.vala"
		return result;
#line 831 "IconManager.c"
	}
#line 156 "Utility/IconManager.vala"
	_tmp2_ = icon_manager_lookup (icon_name, icon_size, symbolic, use_hardcoded, scale);
#line 156 "Utility/IconManager.vala"
	pix = _tmp2_;
#line 158 "Utility/IconManager.vala"
	_tmp3_ = pix;
#line 158 "Utility/IconManager.vala"
	if (_tmp3_ == NULL) {
#line 841 "IconManager.c"
		GdkPixbuf* _tmp4_;
#line 159 "Utility/IconManager.vala"
		_tmp4_ = icon_manager_lookup (ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING, icon_size, symbolic, use_hardcoded, scale);
#line 159 "Utility/IconManager.vala"
		_g_object_unref0 (pix);
#line 159 "Utility/IconManager.vala"
		pix = _tmp4_;
#line 849 "IconManager.c"
	}
#line 162 "Utility/IconManager.vala"
	_tmp5_ = pix;
#line 162 "Utility/IconManager.vala"
	_tmp6_ = gdk_cairo_surface_create_from_pixbuf (_tmp5_, scale, NULL);
#line 162 "Utility/IconManager.vala"
	result = _tmp6_;
#line 162 "Utility/IconManager.vala"
	_g_object_unref0 (pix);
#line 162 "Utility/IconManager.vala"
	return result;
#line 861 "IconManager.c"
}

GdkPixbuf*
icon_manager_lookup_gicon (GIcon* gicon,
                           gint icon_size)
{
	GdkPixbuf* pixbuf = NULL;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 167 "Utility/IconManager.vala"
	pixbuf = NULL;
#line 169 "Utility/IconManager.vala"
	if (gicon == NULL) {
#line 169 "Utility/IconManager.vala"
		result = NULL;
#line 169 "Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 169 "Utility/IconManager.vala"
		return result;
#line 881 "IconManager.c"
	}
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp0_;
		GtkIconInfo* _tmp1_;
		GtkIconInfo* _tmp2_;
#line 172 "Utility/IconManager.vala"
		_tmp0_ = icon_manager_theme;
#line 172 "Utility/IconManager.vala"
		_tmp1_ = gtk_icon_theme_lookup_by_gicon (_tmp0_, gicon, icon_size, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 172 "Utility/IconManager.vala"
		icon_info = _tmp1_;
#line 173 "Utility/IconManager.vala"
		_tmp2_ = icon_info;
#line 173 "Utility/IconManager.vala"
		if (_tmp2_ != NULL) {
#line 898 "IconManager.c"
			GdkPixbuf* _tmp3_ = NULL;
			GtkIconInfo* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 174 "Utility/IconManager.vala"
			_tmp4_ = icon_info;
#line 174 "Utility/IconManager.vala"
			_tmp5_ = gtk_icon_info_load_icon (_tmp4_, &_inner_error0_);
#line 174 "Utility/IconManager.vala"
			_tmp3_ = _tmp5_;
#line 174 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "Utility/IconManager.vala"
				_g_object_unref0 (icon_info);
#line 913 "IconManager.c"
				goto __catch0_g_error;
			}
#line 174 "Utility/IconManager.vala"
			_tmp6_ = _tmp3_;
#line 174 "Utility/IconManager.vala"
			_tmp3_ = NULL;
#line 174 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 174 "Utility/IconManager.vala"
			pixbuf = _tmp6_;
#line 173 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp3_);
#line 926 "IconManager.c"
		}
#line 171 "Utility/IconManager.vala"
		_g_object_unref0 (icon_info);
#line 930 "IconManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 171 "Utility/IconManager.vala"
		e = _inner_error0_;
#line 171 "Utility/IconManager.vala"
		_inner_error0_ = NULL;
#line 178 "Utility/IconManager.vala"
		_tmp7_ = e;
#line 178 "Utility/IconManager.vala"
		_tmp8_ = _tmp7_->message;
#line 178 "Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp8_);
#line 171 "Utility/IconManager.vala"
		_g_error_free0 (e);
#line 950 "IconManager.c"
	}
	__finally0:
#line 171 "Utility/IconManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 171 "Utility/IconManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "Utility/IconManager.vala"
		g_clear_error (&_inner_error0_);
#line 171 "Utility/IconManager.vala"
		return NULL;
#line 963 "IconManager.c"
	}
#line 181 "Utility/IconManager.vala"
	result = pixbuf;
#line 181 "Utility/IconManager.vala"
	return result;
#line 969 "IconManager.c"
}

GtkImage*
icon_manager_lookup_animation (const gchar* gif_name)
{
	gint _tmp0_;
	gint _tmp1_;
	GtkImage* result = NULL;
#line 184 "Utility/IconManager.vala"
	g_return_val_if_fail (gif_name != NULL, NULL);
#line 186 "Utility/IconManager.vala"
	_tmp0_ = strlen (gif_name);
#line 186 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 186 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 186 "Utility/IconManager.vala"
		result = NULL;
#line 186 "Utility/IconManager.vala"
		return result;
#line 990 "IconManager.c"
	}
	{
		GeeArrayList* _search_path_list = NULL;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _search_path_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _search_path_index = 0;
#line 188 "Utility/IconManager.vala"
		_tmp2_ = icon_manager_search_paths;
#line 188 "Utility/IconManager.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 188 "Utility/IconManager.vala"
		_search_path_list = _tmp3_;
#line 188 "Utility/IconManager.vala"
		_tmp4_ = _search_path_list;
#line 188 "Utility/IconManager.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 188 "Utility/IconManager.vala"
		_tmp6_ = _tmp5_;
#line 188 "Utility/IconManager.vala"
		_search_path_size = _tmp6_;
#line 188 "Utility/IconManager.vala"
		_search_path_index = -1;
#line 188 "Utility/IconManager.vala"
		while (TRUE) {
#line 1019 "IconManager.c"
			gchar* search_path = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
#line 188 "Utility/IconManager.vala"
			_search_path_index = _search_path_index + 1;
#line 188 "Utility/IconManager.vala"
			if (!(_search_path_index < _search_path_size)) {
#line 188 "Utility/IconManager.vala"
				break;
#line 1031 "IconManager.c"
			}
#line 188 "Utility/IconManager.vala"
			_tmp7_ = _search_path_list;
#line 188 "Utility/IconManager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _search_path_index);
#line 188 "Utility/IconManager.vala"
			search_path = (gchar*) _tmp8_;
#line 190 "Utility/IconManager.vala"
			_tmp9_ = g_strdup (".gif");
#line 190 "Utility/IconManager.vala"
			_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 190 "Utility/IconManager.vala"
			_tmp10_[0] = _tmp9_;
#line 1045 "IconManager.c"
			{
				gchar** ext_collection = NULL;
				gint ext_collection_length1 = 0;
				gint _ext_collection_size_ = 0;
				gint ext_it = 0;
#line 190 "Utility/IconManager.vala"
				ext_collection = _tmp10_;
#line 190 "Utility/IconManager.vala"
				ext_collection_length1 = 1;
#line 190 "Utility/IconManager.vala"
				for (ext_it = 0; ext_it < ext_collection_length1; ext_it = ext_it + 1) {
#line 1057 "IconManager.c"
					gchar* _tmp11_;
					gchar* ext = NULL;
#line 190 "Utility/IconManager.vala"
					_tmp11_ = g_strdup (ext_collection[ext_it]);
#line 190 "Utility/IconManager.vala"
					ext = _tmp11_;
#line 1064 "IconManager.c"
					{
						gchar* img_file = NULL;
						const gchar* _tmp12_;
						const gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						const gchar* _tmp18_;
#line 192 "Utility/IconManager.vala"
						_tmp12_ = search_path;
#line 192 "Utility/IconManager.vala"
						_tmp13_ = ext;
#line 192 "Utility/IconManager.vala"
						_tmp14_ = g_strconcat (gif_name, _tmp13_, NULL);
#line 192 "Utility/IconManager.vala"
						_tmp15_ = _tmp14_;
#line 192 "Utility/IconManager.vala"
						_tmp16_ = tee_jee_file_system_path_combine (_tmp12_, _tmp15_);
#line 192 "Utility/IconManager.vala"
						_tmp17_ = _tmp16_;
#line 192 "Utility/IconManager.vala"
						_g_free0 (_tmp15_);
#line 192 "Utility/IconManager.vala"
						img_file = _tmp17_;
#line 194 "Utility/IconManager.vala"
						_tmp18_ = img_file;
#line 194 "Utility/IconManager.vala"
						if (tee_jee_file_system_file_exists (_tmp18_)) {
#line 1094 "IconManager.c"
							const gchar* _tmp19_;
							GtkImage* _tmp20_;
#line 196 "Utility/IconManager.vala"
							_tmp19_ = img_file;
#line 196 "Utility/IconManager.vala"
							_tmp20_ = (GtkImage*) gtk_image_new_from_file (_tmp19_);
#line 196 "Utility/IconManager.vala"
							g_object_ref_sink (_tmp20_);
#line 196 "Utility/IconManager.vala"
							result = _tmp20_;
#line 196 "Utility/IconManager.vala"
							_g_free0 (img_file);
#line 196 "Utility/IconManager.vala"
							_g_free0 (ext);
#line 196 "Utility/IconManager.vala"
							ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 196 "Utility/IconManager.vala"
							_g_free0 (search_path);
#line 196 "Utility/IconManager.vala"
							_g_object_unref0 (_search_path_list);
#line 196 "Utility/IconManager.vala"
							return result;
#line 1117 "IconManager.c"
						}
#line 190 "Utility/IconManager.vala"
						_g_free0 (img_file);
#line 190 "Utility/IconManager.vala"
						_g_free0 (ext);
#line 1123 "IconManager.c"
					}
				}
#line 190 "Utility/IconManager.vala"
				ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1128 "IconManager.c"
			}
#line 188 "Utility/IconManager.vala"
			_g_free0 (search_path);
#line 1132 "IconManager.c"
		}
#line 188 "Utility/IconManager.vala"
		_g_object_unref0 (_search_path_list);
#line 1136 "IconManager.c"
	}
#line 201 "Utility/IconManager.vala"
	result = NULL;
#line 201 "Utility/IconManager.vala"
	return result;
#line 1142 "IconManager.c"
}

GdkPixbuf*
icon_manager_add_emblem (GdkPixbuf* pixbuf,
                         const gchar* icon_name,
                         gint emblem_size,
                         gboolean emblem_symbolic,
                         GtkCornerType corner_type)
{
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* emblem = NULL;
	GdkRGBA SMALL_EMBLEM_COLOR = {0};
	gint EMBLEM_PADDING = 0;
	GdkPixbuf* _tmp19_;
	gint offset_x = 0;
	gboolean _tmp21_ = FALSE;
	gint offset_y = 0;
	gboolean _tmp27_ = FALSE;
	GdkPixbuf* emblemed = NULL;
	GdkPixbuf* _tmp33_;
	GdkPixbuf* _tmp34_;
	GdkPixbuf* _tmp35_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 204 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 204 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 207 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 207 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 207 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 1178 "IconManager.c"
		GdkPixbuf* _tmp2_;
#line 207 "Utility/IconManager.vala"
		_tmp2_ = _g_object_ref0 (pixbuf);
#line 207 "Utility/IconManager.vala"
		result = _tmp2_;
#line 207 "Utility/IconManager.vala"
		return result;
#line 1186 "IconManager.c"
	}
#line 209 "Utility/IconManager.vala"
	emblem = NULL;
#line 211 "Utility/IconManager.vala"
	memset (&SMALL_EMBLEM_COLOR, 0, sizeof (GdkRGBA));
#line 212 "Utility/IconManager.vala"
	gdk_rgba_parse (&SMALL_EMBLEM_COLOR, "#000000");
#line 213 "Utility/IconManager.vala"
	SMALL_EMBLEM_COLOR.alpha = 1.0;
#line 215 "Utility/IconManager.vala"
	EMBLEM_PADDING = 1;
#line 1198 "IconManager.c"
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp3_;
		GtkIconInfo* _tmp4_;
#line 218 "Utility/IconManager.vala"
		_tmp3_ = icon_manager_theme;
#line 218 "Utility/IconManager.vala"
		_tmp4_ = gtk_icon_theme_lookup_icon (_tmp3_, icon_name, emblem_size, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 218 "Utility/IconManager.vala"
		icon_info = _tmp4_;
#line 219 "Utility/IconManager.vala"
		if (emblem_symbolic) {
#line 1211 "IconManager.c"
			GdkPixbuf* _tmp5_ = NULL;
			GtkIconInfo* _tmp6_;
			GdkRGBA _tmp7_;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 220 "Utility/IconManager.vala"
			_tmp6_ = icon_info;
#line 220 "Utility/IconManager.vala"
			_tmp7_ = SMALL_EMBLEM_COLOR;
#line 220 "Utility/IconManager.vala"
			_tmp8_ = gtk_icon_info_load_symbolic (_tmp6_, &_tmp7_, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 220 "Utility/IconManager.vala"
			_tmp5_ = _tmp8_;
#line 220 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "Utility/IconManager.vala"
				_g_object_unref0 (icon_info);
#line 1229 "IconManager.c"
				goto __catch0_g_error;
			}
#line 220 "Utility/IconManager.vala"
			_tmp9_ = _tmp5_;
#line 220 "Utility/IconManager.vala"
			_tmp5_ = NULL;
#line 220 "Utility/IconManager.vala"
			_g_object_unref0 (emblem);
#line 220 "Utility/IconManager.vala"
			emblem = _tmp9_;
#line 219 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp5_);
#line 1242 "IconManager.c"
		} else {
			GdkPixbuf* _tmp10_ = NULL;
			GtkIconInfo* _tmp11_;
			GdkPixbuf* _tmp12_;
			GdkPixbuf* _tmp13_;
#line 223 "Utility/IconManager.vala"
			_tmp11_ = icon_info;
#line 223 "Utility/IconManager.vala"
			_tmp12_ = gtk_icon_info_load_icon (_tmp11_, &_inner_error0_);
#line 223 "Utility/IconManager.vala"
			_tmp10_ = _tmp12_;
#line 223 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "Utility/IconManager.vala"
				_g_object_unref0 (icon_info);
#line 1258 "IconManager.c"
				goto __catch0_g_error;
			}
#line 223 "Utility/IconManager.vala"
			_tmp13_ = _tmp10_;
#line 223 "Utility/IconManager.vala"
			_tmp10_ = NULL;
#line 223 "Utility/IconManager.vala"
			_g_object_unref0 (emblem);
#line 223 "Utility/IconManager.vala"
			emblem = _tmp13_;
#line 219 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp10_);
#line 1271 "IconManager.c"
		}
#line 217 "Utility/IconManager.vala"
		_g_object_unref0 (icon_info);
#line 1275 "IconManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GdkPixbuf* _tmp18_;
#line 217 "Utility/IconManager.vala"
		e = _inner_error0_;
#line 217 "Utility/IconManager.vala"
		_inner_error0_ = NULL;
#line 226 "Utility/IconManager.vala"
		_tmp14_ = e;
#line 226 "Utility/IconManager.vala"
		_tmp15_ = _tmp14_->message;
#line 226 "Utility/IconManager.vala"
		_tmp16_ = g_strdup_printf ("get_icon_emblemed(): %s", _tmp15_);
#line 226 "Utility/IconManager.vala"
		_tmp17_ = _tmp16_;
#line 226 "Utility/IconManager.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 226 "Utility/IconManager.vala"
		_g_free0 (_tmp17_);
#line 227 "Utility/IconManager.vala"
		_tmp18_ = _g_object_ref0 (pixbuf);
#line 227 "Utility/IconManager.vala"
		result = _tmp18_;
#line 227 "Utility/IconManager.vala"
		_g_error_free0 (e);
#line 227 "Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 227 "Utility/IconManager.vala"
		return result;
#line 1312 "IconManager.c"
	}
	__finally0:
#line 217 "Utility/IconManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 217 "Utility/IconManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 217 "Utility/IconManager.vala"
		g_clear_error (&_inner_error0_);
#line 217 "Utility/IconManager.vala"
		return NULL;
#line 1325 "IconManager.c"
	}
#line 230 "Utility/IconManager.vala"
	_tmp19_ = emblem;
#line 230 "Utility/IconManager.vala"
	if (_tmp19_ == NULL) {
#line 1331 "IconManager.c"
		GdkPixbuf* _tmp20_;
#line 231 "Utility/IconManager.vala"
		_tmp20_ = _g_object_ref0 (pixbuf);
#line 231 "Utility/IconManager.vala"
		result = _tmp20_;
#line 231 "Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 231 "Utility/IconManager.vala"
		return result;
#line 1341 "IconManager.c"
	}
#line 233 "Utility/IconManager.vala"
	offset_x = EMBLEM_PADDING;
#line 235 "Utility/IconManager.vala"
	if (corner_type == GTK_CORNER_BOTTOM_RIGHT) {
#line 235 "Utility/IconManager.vala"
		_tmp21_ = TRUE;
#line 1349 "IconManager.c"
	} else {
#line 235 "Utility/IconManager.vala"
		_tmp21_ = corner_type == GTK_CORNER_TOP_RIGHT;
#line 1353 "IconManager.c"
	}
#line 235 "Utility/IconManager.vala"
	if (_tmp21_) {
#line 1357 "IconManager.c"
		gint _tmp22_;
		gint _tmp23_;
		GdkPixbuf* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 236 "Utility/IconManager.vala"
		_tmp22_ = gdk_pixbuf_get_width (pixbuf);
#line 236 "Utility/IconManager.vala"
		_tmp23_ = _tmp22_;
#line 236 "Utility/IconManager.vala"
		_tmp24_ = emblem;
#line 236 "Utility/IconManager.vala"
		_tmp25_ = gdk_pixbuf_get_width (_tmp24_);
#line 236 "Utility/IconManager.vala"
		_tmp26_ = _tmp25_;
#line 236 "Utility/IconManager.vala"
		offset_x = (_tmp23_ - _tmp26_) - EMBLEM_PADDING;
#line 1375 "IconManager.c"
	}
#line 239 "Utility/IconManager.vala"
	offset_y = EMBLEM_PADDING;
#line 241 "Utility/IconManager.vala"
	if (corner_type == GTK_CORNER_BOTTOM_LEFT) {
#line 241 "Utility/IconManager.vala"
		_tmp27_ = TRUE;
#line 1383 "IconManager.c"
	} else {
#line 241 "Utility/IconManager.vala"
		_tmp27_ = corner_type == GTK_CORNER_BOTTOM_RIGHT;
#line 1387 "IconManager.c"
	}
#line 241 "Utility/IconManager.vala"
	if (_tmp27_) {
#line 1391 "IconManager.c"
		gint _tmp28_;
		gint _tmp29_;
		GdkPixbuf* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
#line 242 "Utility/IconManager.vala"
		_tmp28_ = gdk_pixbuf_get_height (pixbuf);
#line 242 "Utility/IconManager.vala"
		_tmp29_ = _tmp28_;
#line 242 "Utility/IconManager.vala"
		_tmp30_ = emblem;
#line 242 "Utility/IconManager.vala"
		_tmp31_ = gdk_pixbuf_get_height (_tmp30_);
#line 242 "Utility/IconManager.vala"
		_tmp32_ = _tmp31_;
#line 242 "Utility/IconManager.vala"
		offset_y = (_tmp29_ - _tmp32_) - EMBLEM_PADDING;
#line 1409 "IconManager.c"
	}
#line 245 "Utility/IconManager.vala"
	_tmp33_ = gdk_pixbuf_copy (pixbuf);
#line 245 "Utility/IconManager.vala"
	emblemed = _tmp33_;
#line 247 "Utility/IconManager.vala"
	_tmp34_ = emblem;
#line 247 "Utility/IconManager.vala"
	_tmp35_ = emblemed;
#line 247 "Utility/IconManager.vala"
	gdk_pixbuf_composite (_tmp34_, _tmp35_, offset_x, offset_y, emblem_size, emblem_size, (gdouble) offset_x, (gdouble) offset_y, 1.0, 1.0, GDK_INTERP_BILINEAR, 255);
#line 254 "Utility/IconManager.vala"
	result = emblemed;
#line 254 "Utility/IconManager.vala"
	_g_object_unref0 (emblem);
#line 254 "Utility/IconManager.vala"
	return result;
#line 1427 "IconManager.c"
}

GdkPixbuf*
icon_manager_add_overlay (GdkPixbuf* pixbuf_base,
                          GdkPixbuf* pixbuf_overlay)
{
	gint offset_x = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint offset_y = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GdkPixbuf* emblemed = NULL;
	GdkPixbuf* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GdkPixbuf* result = NULL;
#line 257 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_base != NULL, NULL);
#line 257 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_overlay != NULL, NULL);
#line 259 "Utility/IconManager.vala"
	_tmp0_ = gdk_pixbuf_get_width (pixbuf_base);
#line 259 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 259 "Utility/IconManager.vala"
	_tmp2_ = gdk_pixbuf_get_width (pixbuf_overlay);
#line 259 "Utility/IconManager.vala"
	_tmp3_ = _tmp2_;
#line 259 "Utility/IconManager.vala"
	offset_x = (_tmp1_ - _tmp3_) / 2;
#line 261 "Utility/IconManager.vala"
	_tmp4_ = gdk_pixbuf_get_height (pixbuf_base);
#line 261 "Utility/IconManager.vala"
	_tmp5_ = _tmp4_;
#line 261 "Utility/IconManager.vala"
	_tmp6_ = gdk_pixbuf_get_height (pixbuf_overlay);
#line 261 "Utility/IconManager.vala"
	_tmp7_ = _tmp6_;
#line 261 "Utility/IconManager.vala"
	offset_y = (_tmp5_ - _tmp7_) / 2;
#line 263 "Utility/IconManager.vala"
	_tmp8_ = gdk_pixbuf_copy (pixbuf_base);
#line 263 "Utility/IconManager.vala"
	emblemed = _tmp8_;
#line 265 "Utility/IconManager.vala"
	_tmp9_ = gdk_pixbuf_get_width (pixbuf_overlay);
#line 265 "Utility/IconManager.vala"
	_tmp10_ = _tmp9_;
#line 265 "Utility/IconManager.vala"
	_tmp11_ = gdk_pixbuf_get_height (pixbuf_overlay);
#line 265 "Utility/IconManager.vala"
	_tmp12_ = _tmp11_;
#line 265 "Utility/IconManager.vala"
	gdk_pixbuf_composite (pixbuf_overlay, emblemed, offset_x, offset_y, _tmp10_, _tmp12_, (gdouble) offset_x, (gdouble) offset_y, 1.0, 1.0, GDK_INTERP_BILINEAR, 255);
#line 272 "Utility/IconManager.vala"
	result = emblemed;
#line 272 "Utility/IconManager.vala"
	return result;
#line 1493 "IconManager.c"
}

GdkPixbuf*
icon_manager_resize_icon (GdkPixbuf* pixbuf_image,
                          gint icon_size)
{
	GdkPixbuf* pixbuf_empty = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* pixbuf_resized = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* result = NULL;
#line 275 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_image != NULL, NULL);
#line 279 "Utility/IconManager.vala"
	_tmp0_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, icon_size, icon_size);
#line 279 "Utility/IconManager.vala"
	pixbuf_empty = _tmp0_;
#line 280 "Utility/IconManager.vala"
	gdk_pixbuf_fill (pixbuf_empty, (guint32) 0x00000000);
#line 284 "Utility/IconManager.vala"
	_tmp1_ = icon_manager_add_overlay (pixbuf_empty, pixbuf_image);
#line 284 "Utility/IconManager.vala"
	pixbuf_resized = _tmp1_;
#line 290 "Utility/IconManager.vala"
	result = pixbuf_resized;
#line 290 "Utility/IconManager.vala"
	_g_object_unref0 (pixbuf_empty);
#line 290 "Utility/IconManager.vala"
	return result;
#line 1523 "IconManager.c"
}

GdkPixbuf*
icon_manager_add_transparency (GdkPixbuf* pixbuf,
                               gint opacity)
{
	GdkPixbuf* trans = NULL;
	GdkPixbuf* _tmp0_;
	gint width = 0;
	gint height = 0;
	GdkPixbuf* result = NULL;
#line 293 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 295 "Utility/IconManager.vala"
	_tmp0_ = gdk_pixbuf_copy (pixbuf);
#line 295 "Utility/IconManager.vala"
	trans = _tmp0_;
#line 296 "Utility/IconManager.vala"
	gdk_pixbuf_fill (trans, (guint32) 0xFFFFFF00LL);
#line 300 "Utility/IconManager.vala"
	width = gdk_pixbuf_get_width (pixbuf);
#line 301 "Utility/IconManager.vala"
	height = gdk_pixbuf_get_height (pixbuf);
#line 302 "Utility/IconManager.vala"
	gdk_pixbuf_composite (pixbuf, trans, 0, 0, width, height, (gdouble) 0, (gdouble) 0, 1.0, 1.0, GDK_INTERP_BILINEAR, opacity);
#line 304 "Utility/IconManager.vala"
	result = trans;
#line 304 "Utility/IconManager.vala"
	return result;
#line 1553 "IconManager.c"
}

GdkPixbuf*
icon_manager_load_pixbuf_from_file (const gchar* file_path,
                                    gint icon_size)
{
	GdkPixbuf* pixbuf = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
#line 307 "Utility/IconManager.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 309 "Utility/IconManager.vala"
	pixbuf = NULL;
#line 312 "Utility/IconManager.vala"
	gdk_pixbuf_get_file_info (file_path, &_tmp0_, &_tmp1_);
#line 312 "Utility/IconManager.vala"
	width = _tmp0_;
#line 312 "Utility/IconManager.vala"
	height = _tmp1_;
#line 314 "Utility/IconManager.vala"
	if (width <= icon_size) {
#line 314 "Utility/IconManager.vala"
		_tmp2_ = height <= icon_size;
#line 1582 "IconManager.c"
	} else {
#line 314 "Utility/IconManager.vala"
		_tmp2_ = FALSE;
#line 1586 "IconManager.c"
	}
#line 314 "Utility/IconManager.vala"
	if (_tmp2_) {
#line 1590 "IconManager.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
#line 317 "Utility/IconManager.vala"
			_tmp4_ = gdk_pixbuf_new_from_file (file_path, &_inner_error0_);
#line 317 "Utility/IconManager.vala"
			_tmp3_ = _tmp4_;
#line 317 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1604 "IconManager.c"
				goto __catch0_g_error;
			}
#line 317 "Utility/IconManager.vala"
			_tmp5_ = _tmp3_;
#line 317 "Utility/IconManager.vala"
			_tmp3_ = NULL;
#line 317 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 317 "Utility/IconManager.vala"
			pixbuf = _tmp5_;
#line 319 "Utility/IconManager.vala"
			_tmp6_ = pixbuf;
#line 319 "Utility/IconManager.vala"
			_tmp7_ = icon_manager_resize_icon (_tmp6_, icon_size);
#line 319 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 319 "Utility/IconManager.vala"
			pixbuf = _tmp7_;
#line 321 "Utility/IconManager.vala"
			_tmp8_ = pixbuf;
#line 321 "Utility/IconManager.vala"
			if (_tmp8_ != NULL) {
#line 321 "Utility/IconManager.vala"
				result = pixbuf;
#line 321 "Utility/IconManager.vala"
				_g_object_unref0 (_tmp3_);
#line 321 "Utility/IconManager.vala"
				return result;
#line 1633 "IconManager.c"
			}
#line 315 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp3_);
#line 1637 "IconManager.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 315 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 1644 "IconManager.c"
		}
		__finally0:
#line 315 "Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 315 "Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 315 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 315 "Utility/IconManager.vala"
			return NULL;
#line 1657 "IconManager.c"
		}
	} else {
		{
			GdkPixbuf* _tmp9_ = NULL;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			GdkPixbuf* _tmp13_;
			GdkPixbuf* _tmp14_;
#line 330 "Utility/IconManager.vala"
			_tmp10_ = gdk_pixbuf_new_from_file_at_scale (file_path, icon_size, icon_size, TRUE, &_inner_error0_);
#line 330 "Utility/IconManager.vala"
			_tmp9_ = _tmp10_;
#line 330 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1673 "IconManager.c"
				goto __catch1_g_error;
			}
#line 330 "Utility/IconManager.vala"
			_tmp11_ = _tmp9_;
#line 330 "Utility/IconManager.vala"
			_tmp9_ = NULL;
#line 330 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 330 "Utility/IconManager.vala"
			pixbuf = _tmp11_;
#line 332 "Utility/IconManager.vala"
			_tmp12_ = pixbuf;
#line 332 "Utility/IconManager.vala"
			_tmp13_ = icon_manager_resize_icon (_tmp12_, icon_size);
#line 332 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 332 "Utility/IconManager.vala"
			pixbuf = _tmp13_;
#line 334 "Utility/IconManager.vala"
			_tmp14_ = pixbuf;
#line 334 "Utility/IconManager.vala"
			if (_tmp14_ != NULL) {
#line 334 "Utility/IconManager.vala"
				result = pixbuf;
#line 334 "Utility/IconManager.vala"
				_g_object_unref0 (_tmp9_);
#line 334 "Utility/IconManager.vala"
				return result;
#line 1702 "IconManager.c"
			}
#line 328 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp9_);
#line 1706 "IconManager.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 328 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 1713 "IconManager.c"
		}
		__finally1:
#line 328 "Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 328 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 328 "Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 328 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 328 "Utility/IconManager.vala"
			return NULL;
#line 1726 "IconManager.c"
		}
	}
#line 341 "Utility/IconManager.vala"
	result = NULL;
#line 341 "Utility/IconManager.vala"
	_g_object_unref0 (pixbuf);
#line 341 "Utility/IconManager.vala"
	return result;
#line 1735 "IconManager.c"
}

IconManager*
icon_manager_construct (GType object_type)
{
	IconManager * self = NULL;
#line 37 "Utility/IconManager.vala"
	self = (IconManager*) g_object_new (object_type, NULL);
#line 37 "Utility/IconManager.vala"
	return self;
#line 1746 "IconManager.c"
}

IconManager*
icon_manager_new (void)
{
#line 37 "Utility/IconManager.vala"
	return icon_manager_construct (TYPE_ICON_MANAGER);
#line 1754 "IconManager.c"
}

static void
icon_manager_class_init (IconManagerClass * klass,
                         gpointer klass_data)
{
	GeeArrayList* _tmp0_;
#line 37 "Utility/IconManager.vala"
	icon_manager_parent_class = g_type_class_peek_parent (klass);
#line 37 "Utility/IconManager.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_manager_finalize;
#line 41 "Utility/IconManager.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 41 "Utility/IconManager.vala"
	icon_manager_search_paths = _tmp0_;
#line 1770 "IconManager.c"
}

static void
icon_manager_instance_init (IconManager * self,
                            gpointer klass)
{
}

static void
icon_manager_finalize (GObject * obj)
{
	IconManager * self;
#line 37 "Utility/IconManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_MANAGER, IconManager);
#line 37 "Utility/IconManager.vala"
	G_OBJECT_CLASS (icon_manager_parent_class)->finalize (obj);
#line 1787 "IconManager.c"
}

static GType
icon_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconManager), 0, (GInstanceInitFunc) icon_manager_instance_init, NULL };
	GType icon_manager_type_id;
	icon_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "IconManager", &g_define_type_info, 0);
	return icon_manager_type_id;
}

GType
icon_manager_get_type (void)
{
	static volatile gsize icon_manager_type_id__volatile = 0;
	if (g_once_init_enter (&icon_manager_type_id__volatile)) {
		GType icon_manager_type_id;
		icon_manager_type_id = icon_manager_get_type_once ();
		g_once_init_leave (&icon_manager_type_id__volatile, icon_manager_type_id);
	}
	return icon_manager_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

