/* TeeJee.Process.c generated by valac 0.48.8, the Vala compiler
 * generated from TeeJee.Process.vala, do not modify */

/*
 * TeeJee.ProcessHelper.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <signal.h>
#include <sys/types.h>
#include <glib/gi18n-lib.h>
#include <sys/time.h>
#include <sys/resource.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

extern gchar* tee_jee_process_helper_TEMP_DIR;
gchar* tee_jee_process_helper_TEMP_DIR = NULL;

void tee_jee_process_helper_init_tmp (const gchar* subdir_name);
gchar* tee_jee_misc_random_string (gint length,
                                   const gchar* charset);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gint tee_jee_file_system_chmod (const gchar* file,
                                const gchar* permission);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gchar* tee_jee_process_helper_create_temp_subdir (void);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands,
                                                     const gchar* script_path,
                                                     gboolean force_locale,
                                                     gboolean supress_errors);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
gint tee_jee_process_helper_exec_script_async (const gchar* script);
gchar* tee_jee_process_helper_get_temp_file_path (void);
gchar* tee_jee_misc_timestamp_numeric (void);
void tee_jee_process_helper_exec_process_new_session (const gchar* command);
gchar* tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool);
gboolean tee_jee_process_helper_cmd_exists (const gchar* cmd_tool);
gint tee_jee_process_helper_get_pid_by_name (const gchar* name);
gint tee_jee_process_helper_get_pid_by_command (const gchar* cmdline);
void tee_jee_process_helper_get_proc_io_stats (gint pid,
                                               gint64* read_bytes,
                                               gint64* write_bytes);
gboolean tee_jee_process_helper_process_is_running (glong pid);
gboolean tee_jee_process_helper_process_is_running_by_name (const gchar* proc_name);
gint* tee_jee_process_helper_get_process_children (GPid parent_pid,
                                                   gint* result_length1);
static void _vala_array_add3 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
void tee_jee_process_helper_process_quit (GPid process_pid,
                                          gboolean killChildren);
void tee_jee_process_helper_process_kill (GPid process_pid,
                                          gboolean killChildren);
gint tee_jee_process_helper_process_pause (GPid procID);
gint tee_jee_process_helper_process_resume (GPid procID);
void tee_jee_process_helper_process_quit_by_name (const gchar* cmd_name,
                                                  const gchar* cmd_to_match,
                                                  gboolean exact_match);
void tee_jee_logging_log_debug (const gchar* message);
void tee_jee_process_helper_process_set_priority (GPid procID,
                                                  gint prio);
gint tee_jee_process_helper_process_get_priority (GPid procID);
void tee_jee_process_helper_process_set_priority_normal (GPid procID);
void tee_jee_process_helper_process_set_priority_low (GPid procID);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 136 "TeeJee.Process.c"
}

void
tee_jee_process_helper_init_tmp (const gchar* subdir_name)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
#line 36 "Utility/TeeJee.Process.vala"
	g_return_if_fail (subdir_name != NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_get_tmp_dir ();
#line 39 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 39 "Utility/TeeJee.Process.vala"
	_tmp3_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 39 "Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 39 "Utility/TeeJee.Process.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (tee_jee_process_helper_TEMP_DIR);
#line 39 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_TEMP_DIR = _tmp5_;
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp4_);
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 40 "Utility/TeeJee.Process.vala"
	_tmp6_ = tee_jee_process_helper_TEMP_DIR;
#line 40 "Utility/TeeJee.Process.vala"
	tee_jee_file_system_dir_create (_tmp6_, FALSE);
#line 41 "Utility/TeeJee.Process.vala"
	_tmp7_ = tee_jee_process_helper_TEMP_DIR;
#line 41 "Utility/TeeJee.Process.vala"
	tee_jee_file_system_chmod (_tmp7_, "0750");
#line 43 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_script_sync ("echo 'ok'", &_tmp8_, &_tmp9_, TRUE, FALSE, TRUE, FALSE);
#line 43 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 43 "Utility/TeeJee.Process.vala"
	std_out = _tmp8_;
#line 43 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 43 "Utility/TeeJee.Process.vala"
	std_err = _tmp9_;
#line 45 "Utility/TeeJee.Process.vala"
	_tmp11_ = std_out;
#line 45 "Utility/TeeJee.Process.vala"
	if (_tmp11_ == NULL) {
#line 45 "Utility/TeeJee.Process.vala"
		_tmp10_ = TRUE;
#line 202 "TeeJee.Process.c"
	} else {
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 45 "Utility/TeeJee.Process.vala"
		_tmp12_ = std_out;
#line 45 "Utility/TeeJee.Process.vala"
		_tmp13_ = string_strip (_tmp12_);
#line 45 "Utility/TeeJee.Process.vala"
		_tmp14_ = _tmp13_;
#line 45 "Utility/TeeJee.Process.vala"
		_tmp10_ = g_strcmp0 (_tmp14_, "ok") != 0;
#line 45 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp14_);
#line 217 "TeeJee.Process.c"
	}
#line 45 "Utility/TeeJee.Process.vala"
	if (_tmp10_) {
#line 221 "TeeJee.Process.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 47 "Utility/TeeJee.Process.vala"
		_tmp15_ = g_get_home_dir ();
#line 47 "Utility/TeeJee.Process.vala"
		_tmp16_ = g_strconcat (_tmp15_, "/.temp/", NULL);
#line 47 "Utility/TeeJee.Process.vala"
		_tmp17_ = _tmp16_;
#line 47 "Utility/TeeJee.Process.vala"
		_tmp18_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 47 "Utility/TeeJee.Process.vala"
		_tmp19_ = _tmp18_;
#line 47 "Utility/TeeJee.Process.vala"
		_tmp20_ = g_strconcat (_tmp17_, _tmp19_, NULL);
#line 47 "Utility/TeeJee.Process.vala"
		_g_free0 (tee_jee_process_helper_TEMP_DIR);
#line 47 "Utility/TeeJee.Process.vala"
		tee_jee_process_helper_TEMP_DIR = _tmp20_;
#line 47 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp19_);
#line 47 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp17_);
#line 48 "Utility/TeeJee.Process.vala"
		_tmp21_ = tee_jee_process_helper_TEMP_DIR;
#line 48 "Utility/TeeJee.Process.vala"
		tee_jee_file_system_dir_create (_tmp21_, FALSE);
#line 49 "Utility/TeeJee.Process.vala"
		_tmp22_ = tee_jee_process_helper_TEMP_DIR;
#line 49 "Utility/TeeJee.Process.vala"
		tee_jee_file_system_chmod (_tmp22_, "0750");
#line 258 "TeeJee.Process.c"
	}
#line 36 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 36 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 264 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_create_temp_subdir (void)
{
	gchar* temp = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 56 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 56 "Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 56 "Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 56 "Utility/TeeJee.Process.vala"
	_tmp3_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp2_);
#line 56 "Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 56 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 56 "Utility/TeeJee.Process.vala"
	temp = _tmp4_;
#line 57 "Utility/TeeJee.Process.vala"
	tee_jee_file_system_dir_create (temp, FALSE);
#line 58 "Utility/TeeJee.Process.vala"
	result = temp;
#line 58 "Utility/TeeJee.Process.vala"
	return result;
#line 297 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_exec_sync (const gchar* cmd,
                                  gchar* * std_out,
                                  gchar* * std_err)
{
	gchar* _vala_std_out = NULL;
	gchar* _vala_std_err = NULL;
	gint _tmp5_ = -1;
	GError* _inner_error0_ = NULL;
	gint result = 0;
#line 61 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd != NULL, 0);
#line 312 "TeeJee.Process.c"
	{
		gint status = 0;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
#line 69 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (cmd, &_tmp0_, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 69 "Utility/TeeJee.Process.vala"
		_g_free0 (_vala_std_out);
#line 69 "Utility/TeeJee.Process.vala"
		_vala_std_out = _tmp0_;
#line 69 "Utility/TeeJee.Process.vala"
		_g_free0 (_vala_std_err);
#line 69 "Utility/TeeJee.Process.vala"
		_vala_std_err = _tmp1_;
#line 69 "Utility/TeeJee.Process.vala"
		status = _tmp2_;
#line 69 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
#line 70 "Utility/TeeJee.Process.vala"
		result = status;
#line 70 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 70 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 341 "TeeJee.Process.c"
		} else {
#line 70 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 345 "TeeJee.Process.c"
		}
#line 70 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 70 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 351 "TeeJee.Process.c"
		} else {
#line 70 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 355 "TeeJee.Process.c"
		}
#line 70 "Utility/TeeJee.Process.vala"
		return result;
#line 359 "TeeJee.Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 67 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 67 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 73 "Utility/TeeJee.Process.vala"
		_tmp3_ = e;
#line 73 "Utility/TeeJee.Process.vala"
		_tmp4_ = _tmp3_->message;
#line 73 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 74 "Utility/TeeJee.Process.vala"
		result = -1;
#line 74 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 74 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 74 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 385 "TeeJee.Process.c"
		} else {
#line 74 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 389 "TeeJee.Process.c"
		}
#line 74 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 74 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 395 "TeeJee.Process.c"
		} else {
#line 74 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 399 "TeeJee.Process.c"
		}
#line 74 "Utility/TeeJee.Process.vala"
		return result;
#line 403 "TeeJee.Process.c"
	}
	__finally0:
#line 67 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 67 "Utility/TeeJee.Process.vala"
	return _tmp5_;
#line 412 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_exec_script_sync (const gchar* script,
                                         gchar* * std_out,
                                         gchar* * std_err,
                                         gboolean supress_errors,
                                         gboolean run_as_admin,
                                         gboolean cleanup_tmp,
                                         gboolean print_to_terminal)
{
	gchar* _vala_std_out = NULL;
	gchar* _vala_std_err = NULL;
	gchar* sh_file = NULL;
	gchar* _tmp0_;
	gchar* sh_file_admin = NULL;
	gchar* _tmp1_;
	gint _tmp43_ = -1;
	GError* _inner_error0_ = NULL;
	gint result = 0;
#line 78 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (script != NULL, 0);
#line 89 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_save_bash_script_temp (script, NULL, TRUE, supress_errors);
#line 89 "Utility/TeeJee.Process.vala"
	sh_file = _tmp0_;
#line 90 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup ("");
#line 90 "Utility/TeeJee.Process.vala"
	sh_file_admin = _tmp1_;
#line 92 "Utility/TeeJee.Process.vala"
	if (run_as_admin) {
#line 445 "TeeJee.Process.c"
		gchar* script_admin = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 94 "Utility/TeeJee.Process.vala"
		_tmp2_ = g_strdup ("#!/bin/bash\n");
#line 94 "Utility/TeeJee.Process.vala"
		script_admin = _tmp2_;
#line 95 "Utility/TeeJee.Process.vala"
		_tmp3_ = script_admin;
#line 95 "Utility/TeeJee.Process.vala"
		_tmp4_ = g_strconcat (_tmp3_, "pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY", NULL);
#line 95 "Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 95 "Utility/TeeJee.Process.vala"
		script_admin = _tmp4_;
#line 96 "Utility/TeeJee.Process.vala"
		_tmp5_ = script_admin;
#line 96 "Utility/TeeJee.Process.vala"
		_tmp6_ = sh_file;
#line 96 "Utility/TeeJee.Process.vala"
		_tmp7_ = tee_jee_file_system_escape_single_quote (_tmp6_);
#line 96 "Utility/TeeJee.Process.vala"
		_tmp8_ = _tmp7_;
#line 96 "Utility/TeeJee.Process.vala"
		_tmp9_ = g_strdup_printf (" '%s'", _tmp8_);
#line 96 "Utility/TeeJee.Process.vala"
		_tmp10_ = _tmp9_;
#line 96 "Utility/TeeJee.Process.vala"
		_tmp11_ = g_strconcat (_tmp5_, _tmp10_, NULL);
#line 96 "Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 96 "Utility/TeeJee.Process.vala"
		script_admin = _tmp11_;
#line 96 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp10_);
#line 96 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp8_);
#line 98 "Utility/TeeJee.Process.vala"
		_tmp12_ = sh_file;
#line 98 "Utility/TeeJee.Process.vala"
		_tmp13_ = tee_jee_file_system_file_parent (_tmp12_);
#line 98 "Utility/TeeJee.Process.vala"
		_tmp14_ = _tmp13_;
#line 98 "Utility/TeeJee.Process.vala"
		_tmp15_ = g_build_filename (_tmp14_, "script-admin.sh", NULL);
#line 98 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 98 "Utility/TeeJee.Process.vala"
		sh_file_admin = _tmp15_;
#line 98 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp14_);
#line 100 "Utility/TeeJee.Process.vala"
		_tmp16_ = script_admin;
#line 100 "Utility/TeeJee.Process.vala"
		_tmp17_ = sh_file_admin;
#line 100 "Utility/TeeJee.Process.vala"
		_tmp18_ = tee_jee_process_helper_save_bash_script_temp (_tmp16_, _tmp17_, TRUE, supress_errors);
#line 100 "Utility/TeeJee.Process.vala"
		_tmp19_ = _tmp18_;
#line 100 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp19_);
#line 92 "Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 525 "TeeJee.Process.c"
	}
	{
		gchar** argv = NULL;
		gchar** _tmp20_;
		gint argv_length1;
		gint _argv_size_;
		gchar** env = NULL;
		gchar** _tmp27_;
		gchar** _tmp28_;
		gint env_length1;
		gint _env_size_;
		gint exit_code = 0;
#line 104 "Utility/TeeJee.Process.vala"
		_tmp20_ = g_new0 (gchar*, 1 + 1);
#line 104 "Utility/TeeJee.Process.vala"
		argv = _tmp20_;
#line 104 "Utility/TeeJee.Process.vala"
		argv_length1 = 1;
#line 104 "Utility/TeeJee.Process.vala"
		_argv_size_ = argv_length1;
#line 105 "Utility/TeeJee.Process.vala"
		if (run_as_admin) {
#line 548 "TeeJee.Process.c"
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
			gchar* _tmp23_;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp21_ = argv;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp21__length1 = argv_length1;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp22_ = sh_file_admin;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 106 "Utility/TeeJee.Process.vala"
			_g_free0 (_tmp21_[0]);
#line 106 "Utility/TeeJee.Process.vala"
			_tmp21_[0] = _tmp23_;
#line 565 "TeeJee.Process.c"
		} else {
			gchar** _tmp24_;
			gint _tmp24__length1;
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 109 "Utility/TeeJee.Process.vala"
			_tmp24_ = argv;
#line 109 "Utility/TeeJee.Process.vala"
			_tmp24__length1 = argv_length1;
#line 109 "Utility/TeeJee.Process.vala"
			_tmp25_ = sh_file;
#line 109 "Utility/TeeJee.Process.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 109 "Utility/TeeJee.Process.vala"
			_g_free0 (_tmp24_[0]);
#line 109 "Utility/TeeJee.Process.vala"
			_tmp24_[0] = _tmp26_;
#line 583 "TeeJee.Process.c"
		}
#line 112 "Utility/TeeJee.Process.vala"
		_tmp28_ = _tmp27_ = g_get_environ ();
#line 112 "Utility/TeeJee.Process.vala"
		env = _tmp28_;
#line 112 "Utility/TeeJee.Process.vala"
		env_length1 = _vala_array_length (_tmp27_);
#line 112 "Utility/TeeJee.Process.vala"
		_env_size_ = env_length1;
#line 116 "Utility/TeeJee.Process.vala"
		if (print_to_terminal) {
#line 595 "TeeJee.Process.c"
			const gchar* _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			gchar** _tmp31_;
			gint _tmp31__length1;
			gint _tmp32_ = 0;
#line 118 "Utility/TeeJee.Process.vala"
			_tmp29_ = tee_jee_process_helper_TEMP_DIR;
#line 118 "Utility/TeeJee.Process.vala"
			_tmp30_ = argv;
#line 118 "Utility/TeeJee.Process.vala"
			_tmp30__length1 = argv_length1;
#line 118 "Utility/TeeJee.Process.vala"
			_tmp31_ = env;
#line 118 "Utility/TeeJee.Process.vala"
			_tmp31__length1 = env_length1;
#line 118 "Utility/TeeJee.Process.vala"
			g_spawn_sync (_tmp29_, _tmp30_, _tmp31_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, &_tmp32_, &_inner_error0_);
#line 118 "Utility/TeeJee.Process.vala"
			exit_code = _tmp32_;
#line 118 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "Utility/TeeJee.Process.vala"
				env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 118 "Utility/TeeJee.Process.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 622 "TeeJee.Process.c"
				goto __catch0_g_error;
			}
		} else {
			const gchar* _tmp33_;
			gchar** _tmp34_;
			gint _tmp34__length1;
			gchar** _tmp35_;
			gint _tmp35__length1;
			gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
			gint _tmp38_ = 0;
#line 131 "Utility/TeeJee.Process.vala"
			_tmp33_ = tee_jee_process_helper_TEMP_DIR;
#line 131 "Utility/TeeJee.Process.vala"
			_tmp34_ = argv;
#line 131 "Utility/TeeJee.Process.vala"
			_tmp34__length1 = argv_length1;
#line 131 "Utility/TeeJee.Process.vala"
			_tmp35_ = env;
#line 131 "Utility/TeeJee.Process.vala"
			_tmp35__length1 = env_length1;
#line 131 "Utility/TeeJee.Process.vala"
			g_spawn_sync (_tmp33_, _tmp34_, _tmp35_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp36_, &_tmp37_, &_tmp38_, &_inner_error0_);
#line 131 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 131 "Utility/TeeJee.Process.vala"
			_vala_std_out = _tmp36_;
#line 131 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 131 "Utility/TeeJee.Process.vala"
			_vala_std_err = _tmp37_;
#line 131 "Utility/TeeJee.Process.vala"
			exit_code = _tmp38_;
#line 131 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "Utility/TeeJee.Process.vala"
				env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 131 "Utility/TeeJee.Process.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 662 "TeeJee.Process.c"
				goto __catch0_g_error;
			}
		}
#line 143 "Utility/TeeJee.Process.vala"
		if (cleanup_tmp) {
#line 668 "TeeJee.Process.c"
			const gchar* _tmp39_;
#line 144 "Utility/TeeJee.Process.vala"
			_tmp39_ = sh_file;
#line 144 "Utility/TeeJee.Process.vala"
			tee_jee_file_system_file_delete (_tmp39_);
#line 145 "Utility/TeeJee.Process.vala"
			if (run_as_admin) {
#line 676 "TeeJee.Process.c"
				const gchar* _tmp40_;
#line 146 "Utility/TeeJee.Process.vala"
				_tmp40_ = sh_file_admin;
#line 146 "Utility/TeeJee.Process.vala"
				tee_jee_file_system_file_delete (_tmp40_);
#line 682 "TeeJee.Process.c"
			}
		}
#line 150 "Utility/TeeJee.Process.vala"
		result = exit_code;
#line 150 "Utility/TeeJee.Process.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 150 "Utility/TeeJee.Process.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 150 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 150 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file);
#line 150 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 150 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 699 "TeeJee.Process.c"
		} else {
#line 150 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 703 "TeeJee.Process.c"
		}
#line 150 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 150 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 709 "TeeJee.Process.c"
		} else {
#line 150 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 713 "TeeJee.Process.c"
		}
#line 150 "Utility/TeeJee.Process.vala"
		return result;
#line 717 "TeeJee.Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
#line 103 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 103 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 153 "Utility/TeeJee.Process.vala"
		if (!supress_errors) {
#line 729 "TeeJee.Process.c"
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 154 "Utility/TeeJee.Process.vala"
			_tmp41_ = e;
#line 154 "Utility/TeeJee.Process.vala"
			_tmp42_ = _tmp41_->message;
#line 154 "Utility/TeeJee.Process.vala"
			tee_jee_logging_log_error (_tmp42_, FALSE, FALSE);
#line 738 "TeeJee.Process.c"
		}
#line 156 "Utility/TeeJee.Process.vala"
		result = -1;
#line 156 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 156 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 156 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file);
#line 156 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 156 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 752 "TeeJee.Process.c"
		} else {
#line 156 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 756 "TeeJee.Process.c"
		}
#line 156 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 156 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 762 "TeeJee.Process.c"
		} else {
#line 156 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 766 "TeeJee.Process.c"
		}
#line 156 "Utility/TeeJee.Process.vala"
		return result;
#line 770 "TeeJee.Process.c"
	}
	__finally0:
#line 103 "Utility/TeeJee.Process.vala"
	_g_free0 (sh_file_admin);
#line 103 "Utility/TeeJee.Process.vala"
	_g_free0 (sh_file);
#line 103 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 103 "Utility/TeeJee.Process.vala"
	return _tmp43_;
#line 783 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_exec_script_async (const gchar* script)
{
	gint _tmp9_ = -1;
	GError* _inner_error0_ = NULL;
	gint result = 0;
#line 160 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (script != NULL, 0);
#line 794 "TeeJee.Process.c"
	{
		gchar* scriptfile = NULL;
		gchar* _tmp0_;
		gchar** argv = NULL;
		gchar** _tmp1_;
		gint argv_length1;
		gint _argv_size_;
		gchar* _tmp2_;
		gchar** env = NULL;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint env_length1;
		gint _env_size_;
		GPid child_pid = 0;
		const gchar* _tmp5_;
		GPid _tmp6_ = 0;
#line 170 "Utility/TeeJee.Process.vala"
		_tmp0_ = tee_jee_process_helper_save_bash_script_temp (script, NULL, TRUE, FALSE);
#line 170 "Utility/TeeJee.Process.vala"
		scriptfile = _tmp0_;
#line 172 "Utility/TeeJee.Process.vala"
		_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 172 "Utility/TeeJee.Process.vala"
		argv = _tmp1_;
#line 172 "Utility/TeeJee.Process.vala"
		argv_length1 = 1;
#line 172 "Utility/TeeJee.Process.vala"
		_argv_size_ = argv_length1;
#line 173 "Utility/TeeJee.Process.vala"
		_tmp2_ = g_strdup (scriptfile);
#line 173 "Utility/TeeJee.Process.vala"
		_g_free0 (argv[0]);
#line 173 "Utility/TeeJee.Process.vala"
		argv[0] = _tmp2_;
#line 175 "Utility/TeeJee.Process.vala"
		_tmp4_ = _tmp3_ = g_get_environ ();
#line 175 "Utility/TeeJee.Process.vala"
		env = _tmp4_;
#line 175 "Utility/TeeJee.Process.vala"
		env_length1 = _vala_array_length (_tmp3_);
#line 175 "Utility/TeeJee.Process.vala"
		_env_size_ = env_length1;
#line 178 "Utility/TeeJee.Process.vala"
		_tmp5_ = tee_jee_process_helper_TEMP_DIR;
#line 178 "Utility/TeeJee.Process.vala"
		g_spawn_async_with_pipes (_tmp5_, argv, env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp6_, NULL, NULL, NULL, &_inner_error0_);
#line 178 "Utility/TeeJee.Process.vala"
		child_pid = _tmp6_;
#line 178 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "Utility/TeeJee.Process.vala"
			env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 178 "Utility/TeeJee.Process.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 178 "Utility/TeeJee.Process.vala"
			_g_free0 (scriptfile);
#line 851 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
#line 186 "Utility/TeeJee.Process.vala"
		result = 0;
#line 186 "Utility/TeeJee.Process.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 186 "Utility/TeeJee.Process.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 186 "Utility/TeeJee.Process.vala"
		_g_free0 (scriptfile);
#line 186 "Utility/TeeJee.Process.vala"
		return result;
#line 864 "TeeJee.Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 168 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 168 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 189 "Utility/TeeJee.Process.vala"
		_tmp7_ = e;
#line 189 "Utility/TeeJee.Process.vala"
		_tmp8_ = _tmp7_->message;
#line 189 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 190 "Utility/TeeJee.Process.vala"
		result = 1;
#line 190 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 190 "Utility/TeeJee.Process.vala"
		return result;
#line 888 "TeeJee.Process.c"
	}
	__finally0:
#line 168 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 168 "Utility/TeeJee.Process.vala"
	return _tmp9_;
#line 897 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_save_bash_script_temp (const gchar* commands,
                                              const gchar* script_path,
                                              gboolean force_locale,
                                              gboolean supress_errors)
{
	gchar* sh_path = NULL;
	gchar* _tmp0_;
	GString* script = NULL;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp5_;
	GString* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GString* _tmp9_;
	GString* _tmp10_;
	GString* _tmp11_;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp13_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 194 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (commands != NULL, NULL);
#line 197 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup (script_path);
#line 197 "Utility/TeeJee.Process.vala"
	sh_path = _tmp0_;
#line 202 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_string_new ("");
#line 202 "Utility/TeeJee.Process.vala"
	script = _tmp1_;
#line 203 "Utility/TeeJee.Process.vala"
	_tmp2_ = script;
#line 203 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp2_, "#!/bin/bash\n");
#line 204 "Utility/TeeJee.Process.vala"
	_tmp3_ = script;
#line 204 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp3_, "\n");
#line 205 "Utility/TeeJee.Process.vala"
	if (force_locale) {
#line 943 "TeeJee.Process.c"
		GString* _tmp4_;
#line 206 "Utility/TeeJee.Process.vala"
		_tmp4_ = script;
#line 206 "Utility/TeeJee.Process.vala"
		g_string_append (_tmp4_, "LANG=C\n");
#line 949 "TeeJee.Process.c"
	}
#line 208 "Utility/TeeJee.Process.vala"
	_tmp5_ = script;
#line 208 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp5_, "\n");
#line 209 "Utility/TeeJee.Process.vala"
	_tmp6_ = script;
#line 209 "Utility/TeeJee.Process.vala"
	_tmp7_ = g_strdup_printf ("%s\n", commands);
#line 209 "Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_;
#line 209 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp6_, _tmp8_);
#line 209 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp8_);
#line 210 "Utility/TeeJee.Process.vala"
	_tmp9_ = script;
#line 210 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp9_, "\n\nexitCode=$?\n");
#line 211 "Utility/TeeJee.Process.vala"
	_tmp10_ = script;
#line 211 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp10_, "echo ${exitCode} > ${exitCode}\n");
#line 212 "Utility/TeeJee.Process.vala"
	_tmp11_ = script;
#line 212 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp11_, "echo ${exitCode} > status\n");
#line 214 "Utility/TeeJee.Process.vala"
	_tmp13_ = sh_path;
#line 214 "Utility/TeeJee.Process.vala"
	if (_tmp13_ == NULL) {
#line 214 "Utility/TeeJee.Process.vala"
		_tmp12_ = TRUE;
#line 983 "TeeJee.Process.c"
	} else {
		const gchar* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 214 "Utility/TeeJee.Process.vala"
		_tmp14_ = sh_path;
#line 214 "Utility/TeeJee.Process.vala"
		_tmp15_ = strlen (_tmp14_);
#line 214 "Utility/TeeJee.Process.vala"
		_tmp16_ = _tmp15_;
#line 214 "Utility/TeeJee.Process.vala"
		_tmp12_ = _tmp16_ == 0;
#line 996 "TeeJee.Process.c"
	}
#line 214 "Utility/TeeJee.Process.vala"
	if (_tmp12_) {
#line 1000 "TeeJee.Process.c"
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 215 "Utility/TeeJee.Process.vala"
		_tmp17_ = tee_jee_process_helper_get_temp_file_path ();
#line 215 "Utility/TeeJee.Process.vala"
		_tmp18_ = _tmp17_;
#line 215 "Utility/TeeJee.Process.vala"
		_tmp19_ = g_strconcat (_tmp18_, ".sh", NULL);
#line 215 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_path);
#line 215 "Utility/TeeJee.Process.vala"
		sh_path = _tmp19_;
#line 215 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp18_);
#line 1016 "TeeJee.Process.c"
	}
	{
		GFile* file = NULL;
		const gchar* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp24_;
		GFileOutputStream* _tmp25_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp26_;
		GDataOutputStream* _tmp27_;
		GDataOutputStream* _tmp28_;
		GString* _tmp29_;
		const gchar* _tmp30_;
		GDataOutputStream* _tmp31_;
		const gchar* _tmp32_;
#line 220 "Utility/TeeJee.Process.vala"
		_tmp20_ = sh_path;
#line 220 "Utility/TeeJee.Process.vala"
		_tmp21_ = g_file_new_for_path (_tmp20_);
#line 220 "Utility/TeeJee.Process.vala"
		file = _tmp21_;
#line 221 "Utility/TeeJee.Process.vala"
		_tmp22_ = file;
#line 221 "Utility/TeeJee.Process.vala"
		if (g_file_query_exists (_tmp22_, NULL)) {
#line 1044 "TeeJee.Process.c"
			GFile* _tmp23_;
#line 222 "Utility/TeeJee.Process.vala"
			_tmp23_ = file;
#line 222 "Utility/TeeJee.Process.vala"
			g_file_delete (_tmp23_, NULL, &_inner_error0_);
#line 222 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 1054 "TeeJee.Process.c"
				goto __catch0_g_error;
			}
		}
#line 224 "Utility/TeeJee.Process.vala"
		_tmp24_ = file;
#line 224 "Utility/TeeJee.Process.vala"
		_tmp25_ = g_file_create (_tmp24_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 224 "Utility/TeeJee.Process.vala"
		file_stream = _tmp25_;
#line 224 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1068 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
#line 225 "Utility/TeeJee.Process.vala"
		_tmp26_ = file_stream;
#line 225 "Utility/TeeJee.Process.vala"
		_tmp27_ = g_data_output_stream_new ((GOutputStream*) _tmp26_);
#line 225 "Utility/TeeJee.Process.vala"
		data_stream = _tmp27_;
#line 226 "Utility/TeeJee.Process.vala"
		_tmp28_ = data_stream;
#line 226 "Utility/TeeJee.Process.vala"
		_tmp29_ = script;
#line 226 "Utility/TeeJee.Process.vala"
		_tmp30_ = _tmp29_->str;
#line 226 "Utility/TeeJee.Process.vala"
		g_data_output_stream_put_string (_tmp28_, _tmp30_, NULL, &_inner_error0_);
#line 226 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (data_stream);
#line 226 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file_stream);
#line 226 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1093 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
#line 227 "Utility/TeeJee.Process.vala"
		_tmp31_ = data_stream;
#line 227 "Utility/TeeJee.Process.vala"
		g_output_stream_close ((GOutputStream*) _tmp31_, NULL, &_inner_error0_);
#line 227 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (data_stream);
#line 227 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file_stream);
#line 227 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1108 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
#line 230 "Utility/TeeJee.Process.vala"
		_tmp32_ = sh_path;
#line 230 "Utility/TeeJee.Process.vala"
		tee_jee_file_system_chmod (_tmp32_, "u+x");
#line 232 "Utility/TeeJee.Process.vala"
		result = sh_path;
#line 232 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (data_stream);
#line 232 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file_stream);
#line 232 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 232 "Utility/TeeJee.Process.vala"
		_g_string_free0 (script);
#line 232 "Utility/TeeJee.Process.vala"
		return result;
#line 1127 "TeeJee.Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
#line 218 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 218 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 235 "Utility/TeeJee.Process.vala"
		if (!supress_errors) {
#line 1139 "TeeJee.Process.c"
			GError* _tmp33_;
			const gchar* _tmp34_;
#line 236 "Utility/TeeJee.Process.vala"
			_tmp33_ = e;
#line 236 "Utility/TeeJee.Process.vala"
			_tmp34_ = _tmp33_->message;
#line 236 "Utility/TeeJee.Process.vala"
			tee_jee_logging_log_error (_tmp34_, FALSE, FALSE);
#line 1148 "TeeJee.Process.c"
		}
#line 218 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 1152 "TeeJee.Process.c"
	}
	__finally0:
#line 218 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "Utility/TeeJee.Process.vala"
		_g_string_free0 (script);
#line 218 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_path);
#line 218 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 218 "Utility/TeeJee.Process.vala"
		return NULL;
#line 1167 "TeeJee.Process.c"
	}
#line 240 "Utility/TeeJee.Process.vala"
	result = NULL;
#line 240 "Utility/TeeJee.Process.vala"
	_g_string_free0 (script);
#line 240 "Utility/TeeJee.Process.vala"
	_g_free0 (sh_path);
#line 240 "Utility/TeeJee.Process.vala"
	return result;
#line 1177 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_get_temp_file_path (void)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GRand* _tmp7_;
	GRand* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result = NULL;
#line 247 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 247 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 247 "Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 247 "Utility/TeeJee.Process.vala"
	_tmp3_ = tee_jee_misc_timestamp_numeric ();
#line 247 "Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 247 "Utility/TeeJee.Process.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 247 "Utility/TeeJee.Process.vala"
	_tmp6_ = _tmp5_;
#line 247 "Utility/TeeJee.Process.vala"
	_tmp7_ = g_rand_new ();
#line 247 "Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_;
#line 247 "Utility/TeeJee.Process.vala"
	_tmp9_ = g_strdup_printf ("%u", g_rand_int (_tmp8_));
#line 247 "Utility/TeeJee.Process.vala"
	_tmp10_ = _tmp9_;
#line 247 "Utility/TeeJee.Process.vala"
	_tmp11_ = g_strconcat (_tmp6_, _tmp10_, NULL);
#line 247 "Utility/TeeJee.Process.vala"
	_tmp12_ = _tmp11_;
#line 247 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp10_);
#line 247 "Utility/TeeJee.Process.vala"
	_g_rand_free0 (_tmp8_);
#line 247 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp6_);
#line 247 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp4_);
#line 247 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 247 "Utility/TeeJee.Process.vala"
	result = _tmp12_;
#line 247 "Utility/TeeJee.Process.vala"
	return result;
#line 1237 "TeeJee.Process.c"
}

void
tee_jee_process_helper_exec_process_new_session (const gchar* command)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 250 "Utility/TeeJee.Process.vala"
	g_return_if_fail (command != NULL);
#line 251 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("setsid %s &", command);
#line 251 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 251 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_script_async (_tmp1_);
#line 251 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 1255 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool)
{
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 257 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd_tool != NULL, NULL);
#line 1265 "TeeJee.Process.c"
	{
		gint exitCode = 0;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gint _tmp4_ = 0;
#line 264 "Utility/TeeJee.Process.vala"
		_tmp0_ = g_strconcat ("which ", cmd_tool, NULL);
#line 264 "Utility/TeeJee.Process.vala"
		_tmp1_ = _tmp0_;
#line 264 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_inner_error0_);
#line 264 "Utility/TeeJee.Process.vala"
		_g_free0 (stdout);
#line 264 "Utility/TeeJee.Process.vala"
		stdout = _tmp2_;
#line 264 "Utility/TeeJee.Process.vala"
		_g_free0 (stderr);
#line 264 "Utility/TeeJee.Process.vala"
		stderr = _tmp3_;
#line 264 "Utility/TeeJee.Process.vala"
		exitCode = _tmp4_;
#line 264 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp1_);
#line 264 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "Utility/TeeJee.Process.vala"
			_g_free0 (stderr);
#line 264 "Utility/TeeJee.Process.vala"
			_g_free0 (stdout);
#line 1299 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
#line 265 "Utility/TeeJee.Process.vala"
		result = stdout;
#line 265 "Utility/TeeJee.Process.vala"
		_g_free0 (stderr);
#line 265 "Utility/TeeJee.Process.vala"
		return result;
#line 1308 "TeeJee.Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 261 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 261 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 268 "Utility/TeeJee.Process.vala"
		_tmp5_ = e;
#line 268 "Utility/TeeJee.Process.vala"
		_tmp6_ = _tmp5_->message;
#line 268 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 269 "Utility/TeeJee.Process.vala"
		_tmp7_ = g_strdup ("");
#line 269 "Utility/TeeJee.Process.vala"
		result = _tmp7_;
#line 269 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 269 "Utility/TeeJee.Process.vala"
		return result;
#line 1335 "TeeJee.Process.c"
	}
	__finally0:
#line 261 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 261 "Utility/TeeJee.Process.vala"
	return NULL;
#line 1344 "TeeJee.Process.c"
}

gboolean
tee_jee_process_helper_cmd_exists (const gchar* cmd_tool)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result = FALSE;
#line 273 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd_tool != NULL, FALSE);
#line 274 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path (cmd_tool);
#line 274 "Utility/TeeJee.Process.vala"
	path = _tmp0_;
#line 275 "Utility/TeeJee.Process.vala"
	_tmp2_ = path;
#line 275 "Utility/TeeJee.Process.vala"
	if (_tmp2_ == NULL) {
#line 275 "Utility/TeeJee.Process.vala"
		_tmp1_ = TRUE;
#line 1367 "TeeJee.Process.c"
	} else {
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 275 "Utility/TeeJee.Process.vala"
		_tmp3_ = path;
#line 275 "Utility/TeeJee.Process.vala"
		_tmp4_ = strlen (_tmp3_);
#line 275 "Utility/TeeJee.Process.vala"
		_tmp5_ = _tmp4_;
#line 275 "Utility/TeeJee.Process.vala"
		_tmp1_ = _tmp5_ == 0;
#line 1380 "TeeJee.Process.c"
	}
#line 275 "Utility/TeeJee.Process.vala"
	if (_tmp1_) {
#line 276 "Utility/TeeJee.Process.vala"
		result = FALSE;
#line 276 "Utility/TeeJee.Process.vala"
		_g_free0 (path);
#line 276 "Utility/TeeJee.Process.vala"
		return result;
#line 1390 "TeeJee.Process.c"
	} else {
#line 279 "Utility/TeeJee.Process.vala"
		result = TRUE;
#line 279 "Utility/TeeJee.Process.vala"
		_g_free0 (path);
#line 279 "Utility/TeeJee.Process.vala"
		return result;
#line 1398 "TeeJee.Process.c"
	}
#line 273 "Utility/TeeJee.Process.vala"
	_g_free0 (path);
#line 1402 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_get_pid_by_name (const gchar* name)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gint result = 0;
#line 284 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 289 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("pidof \"%s\"", name);
#line 289 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 289 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 289 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 289 "Utility/TeeJee.Process.vala"
	std_out = _tmp2_;
#line 289 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 289 "Utility/TeeJee.Process.vala"
	std_err = _tmp3_;
#line 289 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 291 "Utility/TeeJee.Process.vala"
	_tmp4_ = std_out;
#line 291 "Utility/TeeJee.Process.vala"
	if (_tmp4_ != NULL) {
#line 1438 "TeeJee.Process.c"
		gchar** arr = NULL;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint arr_length1;
		gint _arr_size_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 292 "Utility/TeeJee.Process.vala"
		_tmp5_ = std_out;
#line 292 "Utility/TeeJee.Process.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 292 "Utility/TeeJee.Process.vala"
		arr = _tmp7_;
#line 292 "Utility/TeeJee.Process.vala"
		arr_length1 = _vala_array_length (_tmp6_);
#line 292 "Utility/TeeJee.Process.vala"
		_arr_size_ = arr_length1;
#line 293 "Utility/TeeJee.Process.vala"
		_tmp8_ = arr;
#line 293 "Utility/TeeJee.Process.vala"
		_tmp8__length1 = arr_length1;
#line 293 "Utility/TeeJee.Process.vala"
		if (_tmp8__length1 > 0) {
#line 1463 "TeeJee.Process.c"
			gchar** _tmp9_;
			gint _tmp9__length1;
			const gchar* _tmp10_;
#line 294 "Utility/TeeJee.Process.vala"
			_tmp9_ = arr;
#line 294 "Utility/TeeJee.Process.vala"
			_tmp9__length1 = arr_length1;
#line 294 "Utility/TeeJee.Process.vala"
			_tmp10_ = _tmp9_[0];
#line 294 "Utility/TeeJee.Process.vala"
			result = atoi (_tmp10_);
#line 294 "Utility/TeeJee.Process.vala"
			arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 294 "Utility/TeeJee.Process.vala"
			_g_free0 (std_err);
#line 294 "Utility/TeeJee.Process.vala"
			_g_free0 (std_out);
#line 294 "Utility/TeeJee.Process.vala"
			return result;
#line 1483 "TeeJee.Process.c"
		}
#line 291 "Utility/TeeJee.Process.vala"
		arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 1487 "TeeJee.Process.c"
	}
#line 298 "Utility/TeeJee.Process.vala"
	result = -1;
#line 298 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 298 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 298 "Utility/TeeJee.Process.vala"
	return result;
#line 1497 "TeeJee.Process.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1516 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_get_pid_by_command (const gchar* cmdline)
{
	GError* _inner_error0_ = NULL;
	gint result = 0;
#line 301 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmdline != NULL, 0);
#line 1526 "TeeJee.Process.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFileEnumerator* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileEnumerator* _tmp4_;
#line 310 "Utility/TeeJee.Process.vala"
		_tmp0_ = g_file_parse_name ("/proc");
#line 310 "Utility/TeeJee.Process.vala"
		file = _tmp0_;
#line 312 "Utility/TeeJee.Process.vala"
		_tmp2_ = file;
#line 312 "Utility/TeeJee.Process.vala"
		_tmp3_ = g_file_enumerate_children (_tmp2_, "standard::name", 0, NULL, &_inner_error0_);
#line 312 "Utility/TeeJee.Process.vala"
		_tmp1_ = _tmp3_;
#line 312 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 312 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (info);
#line 312 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (enumerator);
#line 1554 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
#line 312 "Utility/TeeJee.Process.vala"
		_tmp4_ = _tmp1_;
#line 312 "Utility/TeeJee.Process.vala"
		_tmp1_ = NULL;
#line 312 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (enumerator);
#line 312 "Utility/TeeJee.Process.vala"
		enumerator = _tmp4_;
#line 313 "Utility/TeeJee.Process.vala"
		while (TRUE) {
#line 1567 "TeeJee.Process.c"
			GFileInfo* _tmp5_ = NULL;
			GFileEnumerator* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
#line 313 "Utility/TeeJee.Process.vala"
			_tmp6_ = enumerator;
#line 313 "Utility/TeeJee.Process.vala"
			_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error0_);
#line 313 "Utility/TeeJee.Process.vala"
			_tmp5_ = _tmp7_;
#line 313 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp1_);
#line 313 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 313 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (info);
#line 313 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (enumerator);
#line 1589 "TeeJee.Process.c"
				goto __catch0_g_error;
			}
#line 313 "Utility/TeeJee.Process.vala"
			_tmp8_ = _tmp5_;
#line 313 "Utility/TeeJee.Process.vala"
			_tmp5_ = NULL;
#line 313 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (info);
#line 313 "Utility/TeeJee.Process.vala"
			info = _tmp8_;
#line 313 "Utility/TeeJee.Process.vala"
			_tmp9_ = info;
#line 313 "Utility/TeeJee.Process.vala"
			if (!(_tmp9_ != NULL)) {
#line 313 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp5_);
#line 313 "Utility/TeeJee.Process.vala"
				break;
#line 1608 "TeeJee.Process.c"
			}
			{
				gchar* io_stat_file_path = NULL;
				GFileInfo* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				GFile* io_stat_file = NULL;
				const gchar* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
#line 315 "Utility/TeeJee.Process.vala"
				_tmp10_ = info;
#line 315 "Utility/TeeJee.Process.vala"
				_tmp11_ = g_file_info_get_name (_tmp10_);
#line 315 "Utility/TeeJee.Process.vala"
				_tmp12_ = g_strdup_printf ("/proc/%s/cmdline", _tmp11_);
#line 315 "Utility/TeeJee.Process.vala"
				io_stat_file_path = _tmp12_;
#line 316 "Utility/TeeJee.Process.vala"
				_tmp13_ = io_stat_file_path;
#line 316 "Utility/TeeJee.Process.vala"
				_tmp14_ = g_file_new_for_path (_tmp13_);
#line 316 "Utility/TeeJee.Process.vala"
				io_stat_file = _tmp14_;
#line 317 "Utility/TeeJee.Process.vala"
				_tmp15_ = file;
#line 317 "Utility/TeeJee.Process.vala"
				if (g_file_query_exists (_tmp15_, NULL)) {
#line 1637 "TeeJee.Process.c"
					GFileInputStream* _tmp16_ = NULL;
					GFile* _tmp17_;
					GFileInputStream* _tmp18_;
					GDataInputStream* dis = NULL;
					GDataInputStream* _tmp19_;
					gchar* line = NULL;
					gchar* text = NULL;
					gchar* _tmp20_;
					gsize length = 0UL;
					gboolean _tmp32_ = FALSE;
					const gchar* _tmp33_;
#line 318 "Utility/TeeJee.Process.vala"
					_tmp17_ = io_stat_file;
#line 318 "Utility/TeeJee.Process.vala"
					_tmp18_ = g_file_read (_tmp17_, NULL, &_inner_error0_);
#line 318 "Utility/TeeJee.Process.vala"
					_tmp16_ = _tmp18_;
#line 318 "Utility/TeeJee.Process.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (io_stat_file);
#line 318 "Utility/TeeJee.Process.vala"
						_g_free0 (io_stat_file_path);
#line 1661 "TeeJee.Process.c"
						goto __catch1_g_error;
					}
#line 318 "Utility/TeeJee.Process.vala"
					_tmp19_ = g_data_input_stream_new ((GInputStream*) _tmp16_);
#line 318 "Utility/TeeJee.Process.vala"
					dis = _tmp19_;
#line 321 "Utility/TeeJee.Process.vala"
					_tmp20_ = g_strdup ("");
#line 321 "Utility/TeeJee.Process.vala"
					text = _tmp20_;
#line 323 "Utility/TeeJee.Process.vala"
					while (TRUE) {
#line 1674 "TeeJee.Process.c"
						gchar* _tmp21_ = NULL;
						GDataInputStream* _tmp22_;
						gsize _tmp23_ = 0UL;
						gchar* _tmp24_;
						gchar* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
#line 323 "Utility/TeeJee.Process.vala"
						_tmp22_ = dis;
#line 323 "Utility/TeeJee.Process.vala"
						_tmp24_ = g_data_input_stream_read_until (_tmp22_, "\0", &_tmp23_, NULL, &_inner_error0_);
#line 323 "Utility/TeeJee.Process.vala"
						length = _tmp23_;
#line 323 "Utility/TeeJee.Process.vala"
						_tmp21_ = _tmp24_;
#line 323 "Utility/TeeJee.Process.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 323 "Utility/TeeJee.Process.vala"
							_g_free0 (text);
#line 323 "Utility/TeeJee.Process.vala"
							_g_free0 (line);
#line 323 "Utility/TeeJee.Process.vala"
							_g_object_unref0 (dis);
#line 323 "Utility/TeeJee.Process.vala"
							_g_object_unref0 (_tmp16_);
#line 323 "Utility/TeeJee.Process.vala"
							_g_object_unref0 (io_stat_file);
#line 323 "Utility/TeeJee.Process.vala"
							_g_free0 (io_stat_file_path);
#line 1708 "TeeJee.Process.c"
							goto __catch1_g_error;
						}
#line 323 "Utility/TeeJee.Process.vala"
						_tmp25_ = _tmp21_;
#line 323 "Utility/TeeJee.Process.vala"
						_tmp21_ = NULL;
#line 323 "Utility/TeeJee.Process.vala"
						_g_free0 (line);
#line 323 "Utility/TeeJee.Process.vala"
						line = _tmp25_;
#line 323 "Utility/TeeJee.Process.vala"
						_tmp26_ = line;
#line 323 "Utility/TeeJee.Process.vala"
						if (!(_tmp26_ != NULL)) {
#line 323 "Utility/TeeJee.Process.vala"
							_g_free0 (_tmp21_);
#line 323 "Utility/TeeJee.Process.vala"
							break;
#line 1727 "TeeJee.Process.c"
						}
#line 324 "Utility/TeeJee.Process.vala"
						_tmp27_ = text;
#line 324 "Utility/TeeJee.Process.vala"
						_tmp28_ = line;
#line 324 "Utility/TeeJee.Process.vala"
						_tmp29_ = g_strconcat (" ", _tmp28_, NULL);
#line 324 "Utility/TeeJee.Process.vala"
						_tmp30_ = _tmp29_;
#line 324 "Utility/TeeJee.Process.vala"
						_tmp31_ = g_strconcat (_tmp27_, _tmp30_, NULL);
#line 324 "Utility/TeeJee.Process.vala"
						_g_free0 (text);
#line 324 "Utility/TeeJee.Process.vala"
						text = _tmp31_;
#line 324 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp30_);
#line 323 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp21_);
#line 1747 "TeeJee.Process.c"
					}
#line 327 "Utility/TeeJee.Process.vala"
					_tmp33_ = text;
#line 327 "Utility/TeeJee.Process.vala"
					if (_tmp33_ != NULL) {
#line 1753 "TeeJee.Process.c"
						const gchar* _tmp34_;
#line 327 "Utility/TeeJee.Process.vala"
						_tmp34_ = text;
#line 327 "Utility/TeeJee.Process.vala"
						_tmp32_ = string_contains (_tmp34_, cmdline);
#line 1759 "TeeJee.Process.c"
					} else {
#line 327 "Utility/TeeJee.Process.vala"
						_tmp32_ = FALSE;
#line 1763 "TeeJee.Process.c"
					}
#line 327 "Utility/TeeJee.Process.vala"
					if (_tmp32_) {
#line 1767 "TeeJee.Process.c"
						GFileInfo* _tmp35_;
						const gchar* _tmp36_;
#line 328 "Utility/TeeJee.Process.vala"
						_tmp35_ = info;
#line 328 "Utility/TeeJee.Process.vala"
						_tmp36_ = g_file_info_get_name (_tmp35_);
#line 328 "Utility/TeeJee.Process.vala"
						result = atoi (_tmp36_);
#line 328 "Utility/TeeJee.Process.vala"
						_g_free0 (text);
#line 328 "Utility/TeeJee.Process.vala"
						_g_free0 (line);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (dis);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp16_);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (io_stat_file);
#line 328 "Utility/TeeJee.Process.vala"
						_g_free0 (io_stat_file_path);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp5_);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp1_);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (file);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (info);
#line 328 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (enumerator);
#line 328 "Utility/TeeJee.Process.vala"
						return result;
#line 1800 "TeeJee.Process.c"
					}
#line 317 "Utility/TeeJee.Process.vala"
					_g_free0 (text);
#line 317 "Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 317 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (dis);
#line 317 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (_tmp16_);
#line 1810 "TeeJee.Process.c"
				}
#line 314 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (io_stat_file);
#line 314 "Utility/TeeJee.Process.vala"
				_g_free0 (io_stat_file_path);
#line 1816 "TeeJee.Process.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 314 "Utility/TeeJee.Process.vala"
				g_clear_error (&_inner_error0_);
#line 1823 "TeeJee.Process.c"
			}
			__finally1:
#line 314 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 314 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp5_);
#line 314 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp1_);
#line 314 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 314 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (info);
#line 314 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (enumerator);
#line 1838 "TeeJee.Process.c"
				goto __catch0_g_error;
			}
#line 313 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (_tmp5_);
#line 1843 "TeeJee.Process.c"
		}
#line 307 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (_tmp1_);
#line 307 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 307 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (info);
#line 307 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (enumerator);
#line 1853 "TeeJee.Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp37_;
		const gchar* _tmp38_;
#line 307 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 307 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 339 "Utility/TeeJee.Process.vala"
		_tmp37_ = e;
#line 339 "Utility/TeeJee.Process.vala"
		_tmp38_ = _tmp37_->message;
#line 339 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp38_, FALSE, FALSE);
#line 307 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 1873 "TeeJee.Process.c"
	}
	__finally0:
#line 307 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1878 "TeeJee.Process.c"
		gint _tmp39_ = -1;
#line 307 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 307 "Utility/TeeJee.Process.vala"
		return _tmp39_;
#line 1886 "TeeJee.Process.c"
	}
#line 342 "Utility/TeeJee.Process.vala"
	result = -1;
#line 342 "Utility/TeeJee.Process.vala"
	return result;
#line 1892 "TeeJee.Process.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result = 0LL;
#line 770 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 771 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 771 "glib-2.0.vapi"
	return result;
#line 1906 "TeeJee.Process.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1928 "TeeJee.Process.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1932 "TeeJee.Process.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1938 "TeeJee.Process.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1942 "TeeJee.Process.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1946 "TeeJee.Process.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 1954 "TeeJee.Process.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1982 "TeeJee.Process.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 1991 "TeeJee.Process.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2005 "TeeJee.Process.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 2014 "TeeJee.Process.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 2028 "TeeJee.Process.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2037 "TeeJee.Process.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 2046 "TeeJee.Process.c"
}

void
tee_jee_process_helper_get_proc_io_stats (gint pid,
                                          gint64* read_bytes,
                                          gint64* write_bytes)
{
	gint64 _vala_read_bytes = 0LL;
	gint64 _vala_write_bytes = 0LL;
	gchar* io_stat_file_path = NULL;
	gchar* _tmp0_;
	GFile* file = NULL;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 349 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("/proc/%d/io", pid);
#line 349 "Utility/TeeJee.Process.vala"
	io_stat_file_path = _tmp0_;
#line 350 "Utility/TeeJee.Process.vala"
	_tmp1_ = io_stat_file_path;
#line 350 "Utility/TeeJee.Process.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 350 "Utility/TeeJee.Process.vala"
	file = _tmp2_;
#line 352 "Utility/TeeJee.Process.vala"
	_vala_read_bytes = (gint64) 0;
#line 353 "Utility/TeeJee.Process.vala"
	_vala_write_bytes = (gint64) 0;
#line 2076 "TeeJee.Process.c"
	{
		GFile* _tmp3_;
#line 356 "Utility/TeeJee.Process.vala"
		_tmp3_ = file;
#line 356 "Utility/TeeJee.Process.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 2083 "TeeJee.Process.c"
			GFileInputStream* _tmp4_ = NULL;
			GFile* _tmp5_;
			GFileInputStream* _tmp6_;
			GDataInputStream* dis = NULL;
			GDataInputStream* _tmp7_;
			gchar* line = NULL;
#line 357 "Utility/TeeJee.Process.vala"
			_tmp5_ = file;
#line 357 "Utility/TeeJee.Process.vala"
			_tmp6_ = g_file_read (_tmp5_, NULL, &_inner_error0_);
#line 357 "Utility/TeeJee.Process.vala"
			_tmp4_ = _tmp6_;
#line 357 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2098 "TeeJee.Process.c"
				goto __catch0_g_error;
			}
#line 357 "Utility/TeeJee.Process.vala"
			_tmp7_ = g_data_input_stream_new ((GInputStream*) _tmp4_);
#line 357 "Utility/TeeJee.Process.vala"
			dis = _tmp7_;
#line 359 "Utility/TeeJee.Process.vala"
			while (TRUE) {
#line 2107 "TeeJee.Process.c"
				gchar* _tmp8_ = NULL;
				GDataInputStream* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
#line 359 "Utility/TeeJee.Process.vala"
				_tmp9_ = dis;
#line 359 "Utility/TeeJee.Process.vala"
				_tmp10_ = g_data_input_stream_read_line (_tmp9_, NULL, NULL, &_inner_error0_);
#line 359 "Utility/TeeJee.Process.vala"
				_tmp8_ = _tmp10_;
#line 359 "Utility/TeeJee.Process.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 359 "Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 359 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (dis);
#line 359 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (_tmp4_);
#line 2128 "TeeJee.Process.c"
					goto __catch0_g_error;
				}
#line 359 "Utility/TeeJee.Process.vala"
				_tmp11_ = _tmp8_;
#line 359 "Utility/TeeJee.Process.vala"
				_tmp8_ = NULL;
#line 359 "Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 359 "Utility/TeeJee.Process.vala"
				line = _tmp11_;
#line 359 "Utility/TeeJee.Process.vala"
				_tmp12_ = line;
#line 359 "Utility/TeeJee.Process.vala"
				if (!(_tmp12_ != NULL)) {
#line 359 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp8_);
#line 359 "Utility/TeeJee.Process.vala"
					break;
#line 2147 "TeeJee.Process.c"
				}
#line 360 "Utility/TeeJee.Process.vala"
				_tmp13_ = line;
#line 360 "Utility/TeeJee.Process.vala"
				if (g_str_has_prefix (_tmp13_, "rchar:")) {
#line 2153 "TeeJee.Process.c"
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
#line 361 "Utility/TeeJee.Process.vala"
					_tmp14_ = line;
#line 361 "Utility/TeeJee.Process.vala"
					_tmp15_ = string_replace (_tmp14_, "rchar:", "");
#line 361 "Utility/TeeJee.Process.vala"
					_tmp16_ = _tmp15_;
#line 361 "Utility/TeeJee.Process.vala"
					_tmp17_ = string_strip (_tmp16_);
#line 361 "Utility/TeeJee.Process.vala"
					_tmp18_ = _tmp17_;
#line 361 "Utility/TeeJee.Process.vala"
					_vala_read_bytes = int64_parse (_tmp18_, (guint) 0);
#line 361 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp18_);
#line 361 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp16_);
#line 2175 "TeeJee.Process.c"
				} else {
					const gchar* _tmp19_;
#line 363 "Utility/TeeJee.Process.vala"
					_tmp19_ = line;
#line 363 "Utility/TeeJee.Process.vala"
					if (g_str_has_prefix (_tmp19_, "wchar:")) {
#line 2182 "TeeJee.Process.c"
						const gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
#line 364 "Utility/TeeJee.Process.vala"
						_tmp20_ = line;
#line 364 "Utility/TeeJee.Process.vala"
						_tmp21_ = string_replace (_tmp20_, "wchar:", "");
#line 364 "Utility/TeeJee.Process.vala"
						_tmp22_ = _tmp21_;
#line 364 "Utility/TeeJee.Process.vala"
						_tmp23_ = string_strip (_tmp22_);
#line 364 "Utility/TeeJee.Process.vala"
						_tmp24_ = _tmp23_;
#line 364 "Utility/TeeJee.Process.vala"
						_vala_write_bytes = int64_parse (_tmp24_, (guint) 0);
#line 364 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp24_);
#line 364 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp22_);
#line 2204 "TeeJee.Process.c"
					}
				}
#line 359 "Utility/TeeJee.Process.vala"
				_g_free0 (_tmp8_);
#line 2209 "TeeJee.Process.c"
			}
#line 356 "Utility/TeeJee.Process.vala"
			_g_free0 (line);
#line 356 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (dis);
#line 356 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (_tmp4_);
#line 2217 "TeeJee.Process.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 355 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 355 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 370 "Utility/TeeJee.Process.vala"
		_tmp25_ = e;
#line 370 "Utility/TeeJee.Process.vala"
		_tmp26_ = _tmp25_->message;
#line 370 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp26_, FALSE, FALSE);
#line 355 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 2238 "TeeJee.Process.c"
	}
	__finally0:
#line 355 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 355 "Utility/TeeJee.Process.vala"
		_g_free0 (io_stat_file_path);
#line 355 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 355 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 355 "Utility/TeeJee.Process.vala"
		return;
#line 2253 "TeeJee.Process.c"
	}
#line 345 "Utility/TeeJee.Process.vala"
	_g_object_unref0 (file);
#line 345 "Utility/TeeJee.Process.vala"
	_g_free0 (io_stat_file_path);
#line 345 "Utility/TeeJee.Process.vala"
	if (read_bytes) {
#line 345 "Utility/TeeJee.Process.vala"
		*read_bytes = _vala_read_bytes;
#line 2263 "TeeJee.Process.c"
	}
#line 345 "Utility/TeeJee.Process.vala"
	if (write_bytes) {
#line 345 "Utility/TeeJee.Process.vala"
		*write_bytes = _vala_write_bytes;
#line 2269 "TeeJee.Process.c"
	}
}

gboolean
tee_jee_process_helper_process_is_running (glong pid)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 379 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup ("");
#line 379 "Utility/TeeJee.Process.vala"
	cmd = _tmp0_;
#line 2287 "TeeJee.Process.c"
	{
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 385 "Utility/TeeJee.Process.vala"
		_tmp1_ = g_strdup_printf ("ps --pid %ld", pid);
#line 385 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 385 "Utility/TeeJee.Process.vala"
		cmd = _tmp1_;
#line 386 "Utility/TeeJee.Process.vala"
		_tmp2_ = cmd;
#line 386 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 386 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 386 "Utility/TeeJee.Process.vala"
		std_out = _tmp3_;
#line 386 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 386 "Utility/TeeJee.Process.vala"
		std_err = _tmp4_;
#line 386 "Utility/TeeJee.Process.vala"
		ret_val = _tmp5_;
#line 386 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2316 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 384 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 384 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 389 "Utility/TeeJee.Process.vala"
		_tmp6_ = e;
#line 389 "Utility/TeeJee.Process.vala"
		_tmp7_ = _tmp6_->message;
#line 389 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 390 "Utility/TeeJee.Process.vala"
		result = FALSE;
#line 390 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 390 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 390 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 390 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 390 "Utility/TeeJee.Process.vala"
		return result;
#line 2348 "TeeJee.Process.c"
	}
	__finally0:
#line 384 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2353 "TeeJee.Process.c"
		gboolean _tmp8_ = FALSE;
#line 384 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 384 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 384 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 384 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 384 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 384 "Utility/TeeJee.Process.vala"
		return _tmp8_;
#line 2367 "TeeJee.Process.c"
	}
#line 393 "Utility/TeeJee.Process.vala"
	result = ret_val == 0;
#line 393 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 393 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 393 "Utility/TeeJee.Process.vala"
	_g_free0 (cmd);
#line 393 "Utility/TeeJee.Process.vala"
	return result;
#line 2379 "TeeJee.Process.c"
}

gboolean
tee_jee_process_helper_process_is_running_by_name (const gchar* proc_name)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 397 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (proc_name != NULL, FALSE);
#line 401 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup ("");
#line 401 "Utility/TeeJee.Process.vala"
	cmd = _tmp0_;
#line 2398 "TeeJee.Process.c"
	{
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 407 "Utility/TeeJee.Process.vala"
		_tmp1_ = g_strdup_printf ("pgrep -f '%s'", proc_name);
#line 407 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 407 "Utility/TeeJee.Process.vala"
		cmd = _tmp1_;
#line 408 "Utility/TeeJee.Process.vala"
		_tmp2_ = cmd;
#line 408 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 408 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 408 "Utility/TeeJee.Process.vala"
		std_out = _tmp3_;
#line 408 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 408 "Utility/TeeJee.Process.vala"
		std_err = _tmp4_;
#line 408 "Utility/TeeJee.Process.vala"
		ret_val = _tmp5_;
#line 408 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2427 "TeeJee.Process.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 406 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 406 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 411 "Utility/TeeJee.Process.vala"
		_tmp6_ = e;
#line 411 "Utility/TeeJee.Process.vala"
		_tmp7_ = _tmp6_->message;
#line 411 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 412 "Utility/TeeJee.Process.vala"
		result = FALSE;
#line 412 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 412 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 412 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 412 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 412 "Utility/TeeJee.Process.vala"
		return result;
#line 2459 "TeeJee.Process.c"
	}
	__finally0:
#line 406 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2464 "TeeJee.Process.c"
		gboolean _tmp8_ = FALSE;
#line 406 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 406 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 406 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 406 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 406 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 406 "Utility/TeeJee.Process.vala"
		return _tmp8_;
#line 2478 "TeeJee.Process.c"
	}
#line 415 "Utility/TeeJee.Process.vala"
	result = ret_val == 0;
#line 415 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 415 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 415 "Utility/TeeJee.Process.vala"
	_g_free0 (cmd);
#line 415 "Utility/TeeJee.Process.vala"
	return result;
#line 2490 "TeeJee.Process.c"
}

static void
_vala_array_add3 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 438 "Utility/TeeJee.Process.vala"
	if ((*length) == (*size)) {
#line 438 "Utility/TeeJee.Process.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 438 "Utility/TeeJee.Process.vala"
		*array = g_renew (gint, *array, *size);
#line 2505 "TeeJee.Process.c"
	}
#line 438 "Utility/TeeJee.Process.vala"
	(*array)[(*length)++] = value;
#line 2509 "TeeJee.Process.c"
}

gint*
tee_jee_process_helper_get_process_children (GPid parent_pid,
                                             gint* result_length1)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gint pid = 0;
	gint* procList = NULL;
	gint* _tmp4_;
	gint procList_length1;
	gint _procList_size_;
	gchar** arr = NULL;
	gint arr_length1 = 0;
	gint _arr_size_ = 0;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint* _tmp17_;
	gint _tmp17__length1;
	gint* result = NULL;
#line 424 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("ps --ppid %d", (gint) parent_pid);
#line 424 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 424 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 424 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 424 "Utility/TeeJee.Process.vala"
	std_out = _tmp2_;
#line 424 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 424 "Utility/TeeJee.Process.vala"
	std_err = _tmp3_;
#line 424 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 427 "Utility/TeeJee.Process.vala"
	_tmp4_ = g_new0 (gint, 0);
#line 427 "Utility/TeeJee.Process.vala"
	procList = _tmp4_;
#line 427 "Utility/TeeJee.Process.vala"
	procList_length1 = 0;
#line 427 "Utility/TeeJee.Process.vala"
	_procList_size_ = procList_length1;
#line 430 "Utility/TeeJee.Process.vala"
	_tmp5_ = std_out;
#line 430 "Utility/TeeJee.Process.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 2564 "TeeJee.Process.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 430 "Utility/TeeJee.Process.vala"
		line_collection = _tmp7_;
#line 430 "Utility/TeeJee.Process.vala"
		line_collection_length1 = _vala_array_length (_tmp6_);
#line 430 "Utility/TeeJee.Process.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 2576 "TeeJee.Process.c"
			gchar* _tmp8_;
			gchar* line = NULL;
#line 430 "Utility/TeeJee.Process.vala"
			_tmp8_ = g_strdup (line_collection[line_it]);
#line 430 "Utility/TeeJee.Process.vala"
			line = _tmp8_;
#line 2583 "TeeJee.Process.c"
			{
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar** _tmp12_;
				gchar** _tmp13_;
				gchar** _tmp14_;
				gint _tmp14__length1;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
#line 431 "Utility/TeeJee.Process.vala"
				_tmp9_ = line;
#line 431 "Utility/TeeJee.Process.vala"
				_tmp10_ = string_strip (_tmp9_);
#line 431 "Utility/TeeJee.Process.vala"
				_tmp11_ = _tmp10_;
#line 431 "Utility/TeeJee.Process.vala"
				_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, " ", 0);
#line 431 "Utility/TeeJee.Process.vala"
				arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 431 "Utility/TeeJee.Process.vala"
				arr = _tmp13_;
#line 431 "Utility/TeeJee.Process.vala"
				arr_length1 = _vala_array_length (_tmp12_);
#line 431 "Utility/TeeJee.Process.vala"
				_arr_size_ = arr_length1;
#line 431 "Utility/TeeJee.Process.vala"
				_g_free0 (_tmp11_);
#line 432 "Utility/TeeJee.Process.vala"
				_tmp14_ = arr;
#line 432 "Utility/TeeJee.Process.vala"
				_tmp14__length1 = arr_length1;
#line 432 "Utility/TeeJee.Process.vala"
				if (_tmp14__length1 < 1) {
#line 432 "Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 432 "Utility/TeeJee.Process.vala"
					continue;
#line 2623 "TeeJee.Process.c"
				}
#line 434 "Utility/TeeJee.Process.vala"
				pid = 0;
#line 435 "Utility/TeeJee.Process.vala"
				_tmp15_ = arr;
#line 435 "Utility/TeeJee.Process.vala"
				_tmp15__length1 = arr_length1;
#line 435 "Utility/TeeJee.Process.vala"
				_tmp16_ = _tmp15_[0];
#line 435 "Utility/TeeJee.Process.vala"
				pid = atoi (_tmp16_);
#line 437 "Utility/TeeJee.Process.vala"
				if (pid != 0) {
#line 438 "Utility/TeeJee.Process.vala"
					_vala_array_add3 (&procList, &procList_length1, &_procList_size_, pid);
#line 2639 "TeeJee.Process.c"
				}
#line 430 "Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 2643 "TeeJee.Process.c"
			}
		}
#line 430 "Utility/TeeJee.Process.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2648 "TeeJee.Process.c"
	}
#line 441 "Utility/TeeJee.Process.vala"
	_tmp17_ = procList;
#line 441 "Utility/TeeJee.Process.vala"
	_tmp17__length1 = procList_length1;
#line 441 "Utility/TeeJee.Process.vala"
	if (result_length1) {
#line 441 "Utility/TeeJee.Process.vala"
		*result_length1 = _tmp17__length1;
#line 2658 "TeeJee.Process.c"
	}
#line 441 "Utility/TeeJee.Process.vala"
	result = _tmp17_;
#line 441 "Utility/TeeJee.Process.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 441 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 441 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 441 "Utility/TeeJee.Process.vala"
	return result;
#line 2670 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_quit (GPid process_pid,
                                     gboolean killChildren)
{
	gint* child_pids = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint child_pids_length1;
	gint _child_pids_size_;
#line 452 "Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_process_helper_get_process_children (process_pid, &_tmp0_);
#line 452 "Utility/TeeJee.Process.vala"
	child_pids = _tmp1_;
#line 452 "Utility/TeeJee.Process.vala"
	child_pids_length1 = _tmp0_;
#line 452 "Utility/TeeJee.Process.vala"
	_child_pids_size_ = child_pids_length1;
#line 453 "Utility/TeeJee.Process.vala"
	kill ((pid_t) process_pid, SIGTERM);
#line 455 "Utility/TeeJee.Process.vala"
	if (killChildren) {
#line 2694 "TeeJee.Process.c"
		GPid childPid = 0;
		gint* _tmp2_;
		gint _tmp2__length1;
#line 457 "Utility/TeeJee.Process.vala"
		_tmp2_ = child_pids;
#line 457 "Utility/TeeJee.Process.vala"
		_tmp2__length1 = child_pids_length1;
#line 2702 "TeeJee.Process.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 457 "Utility/TeeJee.Process.vala"
			pid_collection = _tmp2_;
#line 457 "Utility/TeeJee.Process.vala"
			pid_collection_length1 = _tmp2__length1;
#line 457 "Utility/TeeJee.Process.vala"
			for (pid_it = 0; pid_it < pid_collection_length1; pid_it = pid_it + 1) {
#line 2714 "TeeJee.Process.c"
				glong pid = 0L;
#line 457 "Utility/TeeJee.Process.vala"
				pid = (glong) pid_collection[pid_it];
#line 2718 "TeeJee.Process.c"
				{
#line 458 "Utility/TeeJee.Process.vala"
					childPid = (GPid) pid;
#line 459 "Utility/TeeJee.Process.vala"
					kill ((pid_t) childPid, SIGTERM);
#line 2724 "TeeJee.Process.c"
				}
			}
		}
	}
#line 446 "Utility/TeeJee.Process.vala"
	child_pids = (g_free (child_pids), NULL);
#line 2731 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_kill (GPid process_pid,
                                     gboolean killChildren)
{
	gint* child_pids = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint child_pids_length1;
	gint _child_pids_size_;
#line 471 "Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_process_helper_get_process_children (process_pid, &_tmp0_);
#line 471 "Utility/TeeJee.Process.vala"
	child_pids = _tmp1_;
#line 471 "Utility/TeeJee.Process.vala"
	child_pids_length1 = _tmp0_;
#line 471 "Utility/TeeJee.Process.vala"
	_child_pids_size_ = child_pids_length1;
#line 472 "Utility/TeeJee.Process.vala"
	kill ((pid_t) process_pid, SIGKILL);
#line 474 "Utility/TeeJee.Process.vala"
	if (killChildren) {
#line 2755 "TeeJee.Process.c"
		GPid childPid = 0;
		gint* _tmp2_;
		gint _tmp2__length1;
#line 476 "Utility/TeeJee.Process.vala"
		_tmp2_ = child_pids;
#line 476 "Utility/TeeJee.Process.vala"
		_tmp2__length1 = child_pids_length1;
#line 2763 "TeeJee.Process.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 476 "Utility/TeeJee.Process.vala"
			pid_collection = _tmp2_;
#line 476 "Utility/TeeJee.Process.vala"
			pid_collection_length1 = _tmp2__length1;
#line 476 "Utility/TeeJee.Process.vala"
			for (pid_it = 0; pid_it < pid_collection_length1; pid_it = pid_it + 1) {
#line 2775 "TeeJee.Process.c"
				glong pid = 0L;
#line 476 "Utility/TeeJee.Process.vala"
				pid = (glong) pid_collection[pid_it];
#line 2779 "TeeJee.Process.c"
				{
#line 477 "Utility/TeeJee.Process.vala"
					childPid = (GPid) pid;
#line 478 "Utility/TeeJee.Process.vala"
					kill ((pid_t) childPid, SIGKILL);
#line 2785 "TeeJee.Process.c"
				}
			}
		}
	}
#line 464 "Utility/TeeJee.Process.vala"
	child_pids = (g_free (child_pids), NULL);
#line 2792 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_process_pause (GPid procID)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 488 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("kill -STOP %d", (gint) procID);
#line 488 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 488 "Utility/TeeJee.Process.vala"
	_tmp2_ = tee_jee_process_helper_exec_sync (_tmp1_, NULL, NULL);
#line 488 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 488 "Utility/TeeJee.Process.vala"
	result = _tmp2_;
#line 488 "Utility/TeeJee.Process.vala"
	return result;
#line 2814 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_process_resume (GPid procID)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 496 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("kill -CONT %d", (gint) procID);
#line 496 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 496 "Utility/TeeJee.Process.vala"
	_tmp2_ = tee_jee_process_helper_exec_sync (_tmp1_, NULL, NULL);
#line 496 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 496 "Utility/TeeJee.Process.vala"
	result = _tmp2_;
#line 496 "Utility/TeeJee.Process.vala"
	return result;
#line 2836 "TeeJee.Process.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
#line 1133 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1133 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1134 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1134 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1136 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1136 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2860 "TeeJee.Process.c"
		gchar* _tmp2_;
#line 1137 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1137 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1137 "glib-2.0.vapi"
		return result;
#line 2868 "TeeJee.Process.c"
	} else {
#line 1139 "glib-2.0.vapi"
		result = -1;
#line 1139 "glib-2.0.vapi"
		return result;
#line 2874 "TeeJee.Process.c"
	}
}

void
tee_jee_process_helper_process_quit_by_name (const gchar* cmd_name,
                                             const gchar* cmd_to_match,
                                             gboolean exact_match)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* pid = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
#line 500 "Utility/TeeJee.Process.vala"
	g_return_if_fail (cmd_name != NULL);
#line 500 "Utility/TeeJee.Process.vala"
	g_return_if_fail (cmd_to_match != NULL);
#line 505 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("ps w -C '%s'", cmd_name);
#line 505 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 505 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 505 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 505 "Utility/TeeJee.Process.vala"
	std_out = _tmp2_;
#line 505 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 505 "Utility/TeeJee.Process.vala"
	std_err = _tmp3_;
#line 505 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 508 "Utility/TeeJee.Process.vala"
	_tmp4_ = g_strdup ("");
#line 508 "Utility/TeeJee.Process.vala"
	pid = _tmp4_;
#line 509 "Utility/TeeJee.Process.vala"
	_tmp5_ = std_out;
#line 509 "Utility/TeeJee.Process.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 2922 "TeeJee.Process.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 509 "Utility/TeeJee.Process.vala"
		line_collection = _tmp7_;
#line 509 "Utility/TeeJee.Process.vala"
		line_collection_length1 = _vala_array_length (_tmp6_);
#line 509 "Utility/TeeJee.Process.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 2934 "TeeJee.Process.c"
			gchar* _tmp8_;
			gchar* line = NULL;
#line 509 "Utility/TeeJee.Process.vala"
			_tmp8_ = g_strdup (line_collection[line_it]);
#line 509 "Utility/TeeJee.Process.vala"
			line = _tmp8_;
#line 2941 "TeeJee.Process.c"
			{
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 510 "Utility/TeeJee.Process.vala"
				if (exact_match) {
#line 2947 "TeeJee.Process.c"
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
#line 510 "Utility/TeeJee.Process.vala"
					_tmp11_ = line;
#line 510 "Utility/TeeJee.Process.vala"
					_tmp12_ = g_strconcat (" ", cmd_to_match, NULL);
#line 510 "Utility/TeeJee.Process.vala"
					_tmp13_ = _tmp12_;
#line 510 "Utility/TeeJee.Process.vala"
					_tmp10_ = g_str_has_suffix (_tmp11_, _tmp13_);
#line 510 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp13_);
#line 2961 "TeeJee.Process.c"
				} else {
#line 510 "Utility/TeeJee.Process.vala"
					_tmp10_ = FALSE;
#line 2965 "TeeJee.Process.c"
				}
#line 510 "Utility/TeeJee.Process.vala"
				if (_tmp10_) {
#line 510 "Utility/TeeJee.Process.vala"
					_tmp9_ = TRUE;
#line 2971 "TeeJee.Process.c"
				} else {
					gboolean _tmp14_ = FALSE;
#line 511 "Utility/TeeJee.Process.vala"
					if (!exact_match) {
#line 2976 "TeeJee.Process.c"
						const gchar* _tmp15_;
#line 511 "Utility/TeeJee.Process.vala"
						_tmp15_ = line;
#line 511 "Utility/TeeJee.Process.vala"
						_tmp14_ = string_index_of (_tmp15_, cmd_to_match, 0) != -1;
#line 2982 "TeeJee.Process.c"
					} else {
#line 511 "Utility/TeeJee.Process.vala"
						_tmp14_ = FALSE;
#line 2986 "TeeJee.Process.c"
					}
#line 511 "Utility/TeeJee.Process.vala"
					_tmp9_ = _tmp14_;
#line 2990 "TeeJee.Process.c"
				}
#line 510 "Utility/TeeJee.Process.vala"
				if (_tmp9_) {
#line 2994 "TeeJee.Process.c"
					const gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar** _tmp19_;
					gchar** _tmp20_;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
#line 512 "Utility/TeeJee.Process.vala"
					_tmp16_ = line;
#line 512 "Utility/TeeJee.Process.vala"
					_tmp17_ = string_strip (_tmp16_);
#line 512 "Utility/TeeJee.Process.vala"
					_tmp18_ = _tmp17_;
#line 512 "Utility/TeeJee.Process.vala"
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, " ", 0);
#line 512 "Utility/TeeJee.Process.vala"
					_tmp21_ = _tmp20_;
#line 512 "Utility/TeeJee.Process.vala"
					_tmp21__length1 = _vala_array_length (_tmp19_);
#line 512 "Utility/TeeJee.Process.vala"
					_tmp22_ = _tmp21_[0];
#line 512 "Utility/TeeJee.Process.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 512 "Utility/TeeJee.Process.vala"
					_g_free0 (pid);
#line 512 "Utility/TeeJee.Process.vala"
					pid = _tmp23_;
#line 512 "Utility/TeeJee.Process.vala"
					_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 512 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp18_);
#line 513 "Utility/TeeJee.Process.vala"
					_tmp24_ = pid;
#line 513 "Utility/TeeJee.Process.vala"
					kill ((pid_t) ((GPid) atoi (_tmp24_)), 15);
#line 514 "Utility/TeeJee.Process.vala"
					_tmp25_ = g_strconcat (_ ("Stopped"), ": [PID=", NULL);
#line 514 "Utility/TeeJee.Process.vala"
					_tmp26_ = _tmp25_;
#line 514 "Utility/TeeJee.Process.vala"
					_tmp27_ = pid;
#line 514 "Utility/TeeJee.Process.vala"
					_tmp28_ = g_strconcat (_tmp26_, _tmp27_, NULL);
#line 514 "Utility/TeeJee.Process.vala"
					_tmp29_ = _tmp28_;
#line 514 "Utility/TeeJee.Process.vala"
					_tmp30_ = g_strconcat (_tmp29_, "] ", NULL);
#line 514 "Utility/TeeJee.Process.vala"
					_tmp31_ = _tmp30_;
#line 514 "Utility/TeeJee.Process.vala"
					tee_jee_logging_log_debug (_tmp31_);
#line 514 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp31_);
#line 514 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp29_);
#line 514 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp26_);
#line 3062 "TeeJee.Process.c"
				}
#line 509 "Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 3066 "TeeJee.Process.c"
			}
		}
#line 509 "Utility/TeeJee.Process.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3071 "TeeJee.Process.c"
	}
#line 500 "Utility/TeeJee.Process.vala"
	_g_free0 (pid);
#line 500 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 500 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 3079 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_set_priority (GPid procID,
                                             gint prio)
{
#line 525 "Utility/TeeJee.Process.vala"
	if (getpriority (PRIO_PROCESS, (gint) procID) != prio) {
#line 526 "Utility/TeeJee.Process.vala"
		setpriority (PRIO_PROCESS, (gint) procID, prio);
#line 3090 "TeeJee.Process.c"
	}
}

gint
tee_jee_process_helper_process_get_priority (GPid procID)
{
	gint result = 0;
#line 533 "Utility/TeeJee.Process.vala"
	result = getpriority (PRIO_PROCESS, (gint) procID);
#line 533 "Utility/TeeJee.Process.vala"
	return result;
#line 3102 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_set_priority_normal (GPid procID)
{
#line 540 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_process_set_priority (procID, 0);
#line 3110 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_set_priority_low (GPid procID)
{
#line 547 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_process_set_priority (procID, 5);
#line 3118 "TeeJee.Process.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

